/*
 * $PSLibId: Run-time Library Release 4.0$
 */
#if defined(APD_SAVE) || defined(APD_LOAD)
	static char	*progname="module/execmenu/balls/balls.cpe";
#endif
/*				balls
 *
 *		ʓoEh镡̃{[`悷
 *
 *		Copyright (C) 1993 by Sony Corporation
 *			All rights Reserved
 *
 *	 Version	Date		Design
 *	-----------------------------------------
 *	1.00		Aug,31,1993	suzu
 *	2.00		Nov,17,1993	suzu	(using 'libgpu)
 *	3.00		Dec.27.1993	suzu	(rewrite)
 *	3.01		Dec.27.1993	suzu	(for newpad)
 *	3.02		Aug.31.1994	noda    (for KANJI)
 *	4.00		May.22.1995	sachiko	({̃Rgtj
 *	4.00c		Sep.04.1995	yoshi	(for EXECj
 *	4.01c		Apr.11.1997	sachiko	(for AutoPaDj
 *	4.10		Jul.01.1998	MikeKav	added Dual Shock controller code
 */

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libpad.h>


/*#define DEBUG */
/*
 * Primitive Buffer: v~eBu֘Ãobt@
 */
#define OTSIZE		1		/* size of ordering table
					   : I[_Oe[u̐ */
#define MAXOBJ		4000		/* max sprite number :
					   XvCgi{[j̏ */
typedef struct {
	DRAWENV		draw;		/* drawing environment : ` */
	DISPENV		disp;		/* display environment : \ */
	u_long		ot[OTSIZE];	/* ordering table:
					   : I[_Oe[u */
	SPRT_16		sprt[MAXOBJ];	/* 16x16 fixed-size sprite:
					   16x16ŒTCỸXvCg */
} DB;

/*
 * Position Buffer: XvCg̓Ɋւobt@
 */
typedef struct {
	u_short x, y;			/* current point: ݂̈ʒu */
	u_short dx, dy;			/* verocity: x */
} POS;

/*
 * \̈
 */
#define	FRAME_X		320		/* frame size:\̈TCY(320x240)*/
#define	FRAME_Y		240
#define WALL_X		(FRAME_X-16)	/* reflection point
					   : XvCg̉̈TCY */
#define WALL_Y		(FRAME_Y-16)

/* preset unchanged primitve members: v~eBuobt@̏ݒ */
static void init_prim(DB *db);	

/* parse controller: Rg[̉ */
static int  pad_read(int n);	

/* callback for VSync: V-Sync̃R[obN[` */
static void  cbvsync(void);	

/* intitialze position table : {[̃X^[gʒuƈړ̐ݒ */
static int  init_point(POS *pos);

// Dual Shock values
static unsigned char padbuff[2][34];
unsigned char Motor[2];
int portNo = 0x00;
int ctr;
static unsigned char align[6]={0,1,0xFF,0xFF,0xFF,0xFF};

#define DUALSHOCKMODE ((u_long *)0x80010000)
unsigned long *storedMode = DUALSHOCKMODE;


main()
{
	/* {[̍Wlƈړi[obt@ */
	POS	pos[MAXOBJ];	
	
	/* double buffer: _uobt@̂߂Qpӂ */
	DB	db[2];		
	
	/* current double buffer: ݂̃_uobt@obt@̃AhX */
	DB	*cdb;		
				   
	/* object number: \XvCg̐iŏ͂Pj*/
	int	nobj = 1;	
	
	/* current OT: ݂̂ns̃AhX */
	u_long	*ot;		
	
	SPRT_16	*sp;		/* work */
	POS	*pp;		/* work */
	int	i, cnt, x, y;	/* work */
	int offs,maxID,set;

    /* O */
	ResetCallback();

	PadInitDirect(padbuff[0],padbuff[1]);
	PadStartCom();

	// ReInit Dual Shock if required
	printf("%d\n",*storedMode);
	VSync(5);
	maxID = PadInfoMode(0x00,InfoModeIdTable,-1);
	printf("Max:%d\n",maxID);
	VSync(5);

	for(offs=0;offs<maxID;offs++)
	{
		printf("Entry:%d Searching for:%d, Mode:%d\n",offs,*storedMode,PadInfoMode(0x00,InfoModeIdTable,offs));
	
		if( PadInfoMode(0x00,InfoModeIdTable,offs) == *storedMode)
		{
			printf("Found Match:%d\n",offs);
			VSync(6);
			PadSetMainMode(0x00,offs,2);
			break;
		}
	}

	// Wait till it's stable
	set = 0;
	while(!set)
	{
		if(PadGetState(portNo) == PadStateStable)
		{
			if(PadInfoMode(portNo,InfoModeCurExID,0))
			{
				PadSetAct(0x00,Motor,2);
					while( PadSetActAlign(0x00,align) == 0)
					{
						for(ctr=0;ctr<6;ctr++)
							VSync(0);
					}

			}
			set = 1;
		}
		if(PadGetState(portNo) == PadStateFindCTP1)
		{
			printf("Found Normal Controller\n");
			set = 1;
		}
	}

	printf("Finished Dual Shock Setup\n");
	

	/* reset graphics sysmtem (0:cold,1:warm); `E\̃Zbg */
	ResetGraph(0);		
	
	/* set debug mode (0:off,1:monitor,2:dump): fobO[h̐ݒ */
	SetGraphDebug(0);	
	
	/* set callback: V-sync̃R[obN֐̐ݒ */
	VSyncCallback(cbvsync);	

	/* inititlalize environment for double buffer
	: `E\_uobt@pɐݒ
	(0,  0)-(320,240)ɕ`悵ĂƂ(0,240)-(320,480)\(db[0])
	(0,240)-(320,480)ɕ`悵ĂƂ(0,  0)-(320,240)\(db[1])
	*/
	SetDefDrawEnv(&db[0].draw, 0,   0, 320, 240);
	SetDefDrawEnv(&db[1].draw, 0, 240, 320, 240);
	SetDefDispEnv(&db[0].disp, 0, 240, 320, 240);
	SetDefDispEnv(&db[1].disp, 0,   0, 320, 240);

	/* init font environment; tHg̐ݒ */
#ifdef KANJI	/* KANJI */
	KanjiFntOpen(160, 16, 256, 200, 704, 0, 768, 256, 0, 512);
#endif	
	/* :{tHgp^[t[obt@Ƀ[h */
	FntLoad(960, 256);	
	
	/* :tHg̕\ʒu̐ݒ */
	SetDumpFnt(FntOpen(16, 16, 256, 200, 0, 512));	

	/* initialize primitive buffer: v~eBuobt@̏ݒ(db[0])*/
	init_prim(&db[0]);	
	
	/* initialize primitive buffer: v~eBuobt@̏ݒ(db[1])*/
	init_prim(&db[1]);	
	
	/* set initial geometries: {[̓Ɋւ鏉ݒ */
	init_point(pos);	

	/* enable to display: fBXvCւ̕\Jn */
	SetDispMask(1);		/* 0:inhibit,1:enable: OFs  PF */

	/* ; C[v */

	while ((nobj = pad_read(nobj)) > 0) {
		/* swap double buffer ID: _uobt@|C^̐؂ւ */
		cdb  = (cdb==db)? db+1: db;	
#ifdef DEBUG
		/* dump DB environment */
		DumpDrawEnv(&cdb->draw);
		DumpDispEnv(&cdb->disp);
		DumpTPage(cdb->draw.tpage);
#endif

 		/* clear ordering table: I[_Oe[ũNA */
		ClearOTag(cdb->ot, OTSIZE);

		/* update sprites :
		   {[̈ʒuPvZĂnsɓo^Ă */
		ot = cdb->ot;
		sp = cdb->sprt;
		pp = pos;
		for (i = 0; i < nobj; i++, sp++, pp++) {
			/* detect reflection:
			   Wl̍XVщʏł̈ʒǔvZ */
			if ((x = (pp->x += pp->dx) % WALL_X*2) >= WALL_X)
				x = WALL_X*2 - x;
			if ((y = (pp->y += pp->dy) % WALL_Y*2) >= WALL_Y)
				y = WALL_Y*2 - y;

			/* update vertex: vZWlZbg */
			setXY0(sp, x, y);	
			
			/* apend to OT: ns֓o^ */
			AddPrim(ot, sp);	
		}
		/* wait for end of drawing: `̏I҂ */
		DrawSync(0);		
		
		/* cnt = VSync(1);	/* check for count */
		/* cnt = VSync(2);	/* wait for V-BLNK (1/30) */
		cnt = VSync(0);		/* wait for V-BLNK (1/60) */

		/*: _uobt@̐ؑւ */
		/* update display environment: \̍XV */
		PutDispEnv(&cdb->disp); 
		
		/* update drawing environment: `̍XV */
		PutDrawEnv(&cdb->draw); 
		
		/*: nsɓo^ꂽv~eBu̕` */
		DrawOTag(cdb->ot);	
#ifdef DEBUG
		DumpOTag(cdb->ot);
#endif
		/*: {[̐ƌoߎԂ̃vg */
#ifdef KANJI
		KanjiFntPrint("ʂ̐%d\n",nobj);
		KanjiFntPrint("=%d\n",cnt);
		KanjiFntFlush(-1);
#endif
		FntPrint("sprite = %d\n", nobj);
		FntPrint("total time = %d\n", cnt);
		FntFlush(-1);
	}

	PadStopCom();
	printf("Pad Stopped, pretending to take a long time to load..\n");
	// pause for at least four seconds to simulate long load
	VSync(240);

	ResetGraph(3); 
	StopCallback();
#ifdef DEAD_PARENT
	/* load parent again, because parent was destroyed already. ::
	   ɐe͎ł̂ŁAxeLoadExec() */
	_96_init();
	LoadExec("cdrom:\\EXECMENU\\EXECMENU.EXE;1",0x801ffff0,0);
	/* this setting of stack pointer is meaningless, because EXECMENU.EXE
	   was linked with 2MBYTE.OBJ. ::
	   EXECMENU.EXE ɂ 2MBYTE.OBJ NĂ̂ŁAł̃X^bN
	   |C^l̐ݒ͈ӖȂAꉞ 0x801ffff0 ƂĂB*/
#else
	return(0);
#endif
}

/*
 * Initialize drawing Primitives: v~eBuobt@̏ݒ
 */
#include "balltex.h"	/* {[̃eNX`p^[Ăt@C */

/* DB *db; v~eBuobt@*/
static void init_prim(DB *db)
{
	u_short	clut[32];		/* CLUT entry: eNX` CLUT */
	SPRT_16	*sp;			/* work */
	int	i;			/* work */

	/* set bg color: wiF̃Zbg */
	db->draw.isbg = 1;
	setRGB0(&db->draw, 60, 120, 120);

	/* load texture pattern: eNX`̃[h */
	db->draw.tpage = LoadTPage(ball16x16, 0, 0, 640, 0, 16, 16);
#ifdef DEBUG
	DumpTPage(db->draw.tpage);
#endif
	/* load texture CLUT: eNX` CLUT̃[h */
	for (i = 0; i < 32; i++) {
		clut[i] = LoadClut(ballcolor[i], 0, 480+i);
#ifdef DEBUG
		DumpClut(clut[i]);
#endif
	}

	/* initialize sprite: XvCg̏ */
	for (sp = db->sprt, i = 0; i < MAXOBJ; i++, sp++) {
		/* set SPRT_16: 16x16XvCgv~eBȕ */
		SetSprt16(sp);		
		
		/* semi-ambient is OFF: It */
		SetSemiTrans(sp, 0);	
		
		/* shaded texture is OFF: VF[fBOsȂ */
		SetShadeTex(sp, 1);	
		
		/* texture point is (0,0): u,v(0,0)ɐݒ */
		setUV0(sp, 0, 0);	
		
		/* set CLUT: CLUT ̃Zbg */
		sp->clut = clut[i%32];	
	}
}

/*
 * Initialize sprite position and verocity:
 : {[̃X^[gʒuƈړʂݒ肷
 */

/* POS	*pos;		{[̓Ɋւ\ */
static init_point(POS *pos)	
{
	int	i;
	for (i = 0; i < MAXOBJ; i++) {
		pos->x  = rand();		/*: X^[gW w */
		pos->y  = rand();		/*: X^[gW x */
		pos->dx = (rand() % 4) + 1;	/*: ړ w (1<=x<=4) */
		pos->dy = (rand() % 4) + 1;	/*: ړ x (1<=y<=4) */
		pos++;
	}
}

/*
 * Read control-pad: Rg[̉
 */
/* int n; XvCg̐ */
static int pad_read(int	n)		
{
	int		padState;
	int		set;
	int		currentPad;
	u_long	button;

	padState = PadGetState(portNo);

	if(padState==PadStateDiscon)
	{
		FntPrint("No Pad Connected\n");
		return n;
	}

	if(padState==PadStateFindPad)
	{
		// Set actuators if Dual Shock
		set = 0;
		while(!set)
		{
			if(PadGetState(portNo) == PadStateStable)
			{
				if(PadInfoMode(portNo,InfoModeCurExID,0))
				{
					PadSetAct(0x00,Motor,2);
					while( PadSetActAlign(0x00,align) == 0)
					{
						for(ctr=0;ctr<6;ctr++)
							VSync(0);
					}
				}
				set = 1;
			}
			if(PadGetState(portNo) == PadStateFindCTP1)
			{
				printf("Found Normal Controller\n");
				set = 1;
			}
		}
		return n;
	}

	currentPad = PadInfoMode(portNo,InfoModeCurExID,0);
	if((currentPad == 4) || (currentPad==7) )
	{
		// Dual Shock connected
		FntPrint("Dual Shock Connected\n");
		FntPrint("\tMotor0 %03d\n",Motor[0]);
		FntPrint("\tMotor1 %03d\n",Motor[1]);
	}
	else
	{
		// Normal controller of some type connected
		currentPad = PadInfoMode(portNo,InfoModeCurID,0) +10;

		switch(currentPad)
		{
		case 14:
		{
			FntPrint("Standard Pad Connected\n");
			break;
		}
		case 17:
		{
			FntPrint("Old Analog Pad Connected\n");
			break;
		}
		default:
		{
			FntPrint("Unhandled Pad Connected\n");
			return n;
		}
		}

	}

	// ignore received data when communication failed
	if(*(padbuff[0]))
	{
		return n;
	}

	button = ~((padbuff[0][2]<<8) | padbuff[0][3]);

	if((button & PADRdown) && ((currentPad == 4) || (currentPad == 7)) )
	{
		// vibrate actuator 0 (can only be on or off)
		if(Motor[0] == 1)
			Motor[0] = 0;
		else
			Motor[0] = 1;

		PadSetAct(0x00,Motor,2);

	}
	if((button & PADRup) && ((currentPad == 4) || (currentPad == 7)) )
	{
		// vibration off
		Motor[0] = 0;
		Motor[1] = 0;
		PadSetAct(0x00,Motor,2);

	}
	if((button & PADRleft) && ((currentPad == 4) || (currentPad == 7))  )
	{
		// vibration
		if(Motor[1] != 0)
			Motor[1] --;

		PadSetAct(0x00,Motor,2);

	}
	if((button & PADRright) && ((currentPad == 4) || (currentPad == 7)) )
	{
		// vibration
		if(Motor[1] != 255)
			Motor[1] ++;
		PadSetAct(0x00,Motor,2);
	}

	if(button & PADLup)		n += 4;
	if(button & PADLdown)	n -= 4;

	if((button & PADselect) || (button & PADstart) )
	{
		if( (currentPad == 4) || (currentPad == 7) )
		{
			*storedMode = PadInfoMode(0x00,InfoModeCurExID,0);
			printf("Storing Dual Shock Mode:%d\n",*storedMode);
		}
		else
		{
			*storedMode = 0;
			printf("Clearing Dual Shock Mode:%d\n",*storedMode);
		}

		return(-1);
	}

	limitRange(n, 1, MAXOBJ-1);
	return(n);
}

/*
 * callback: R[obN
 */
static void cbvsync(void)
{
	/* print absolute VSync count */
	FntPrint("V-BLNK(%d)\n", VSync(-1));	
}

