/* $PSLibId: Run-time Library Release 4.0$ */
#if defined(APD_SAVE) || defined(APD_LOAD)
	static char	*progname="module/execmenu/rcube/rcube.cpe";
#endif
/*
 *	rcube: PS-X Demonstration program
 *
 *	"main.c" Main routine
 *
 *		Version 3.02	Jan, 9, 1995
 *		Version 3.02b	Aug, 3, 1995 yoshi (for EXEC)
 *		Version 3.02c	Mar, 4, 1996 yoshi (added English comment)
 *
 *		Copyright (C) 1993,1994,1995 by Sony Computer Entertainment
 *			All rights Reserved
 */

#include <sys/types.h>
#include <sys/file.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libcd.h>
#include <libpad.h>

#include "table.h"
#include "pos.h"

/*
 * texture data : eNX`
 */
#define TIM_ADDR 0x80108000		/* stored address of the TIM file to be used : 
                                   gpTIMt@C̊i[AhX */
/*#define TIM_ADDR 0x80020000	/* stored address of the TIM file to be used : 
                                   gpTIMt@C̊i[AhX */
#define TIM_HEADER 0x00000010

/*
 * modeling data : fOf[^
 */
#define TMD_ADDR 0x80100000		/* stored address of the TMD file to be used : 
                                   gpTMDt@C̊i[AhX */
/*#define TMD_ADDR 0x80010000		/* stored address of the TMD file to be used : 
                                       gpTMDt@C̊i[AhX */
u_long *TmdBase;			/* address of object within TMD : 
                               TMD̂AIuWFNg̃AhX */
int CurrentTmd; 			/* the TMD number for the TMD being used : 
                               gpTMDԍ */

/*
 * ordering table (OT) : I[_Oe[u (OT)
 */
#define OT_LENGTH  7			/* OT resolution (large) : OT𑜓xi傫j */
GsOT WorldOT[2];			/* OT data (double buffer) : OTi_uobt@j */
GsOT_TAG OTTags[2][1<<OT_LENGTH];	/* OT tag area (double buffer) : 
                                       OT̃^Öi_uobt@j */

/*
 * GPU packet creation area : GPUpPbg̈
 */
#define PACKETMAX 1000			/* maximum packet number in 1 frame : 
                                   1t[̍őpPbg */
PACKET GpuPacketArea[2][PACKETMAX*64];	/* packet area (double buffer) : 
                                           OpPbg̈i_uobt@j */

/*
 *  object (cube) variable : IuWFNgiL[ujϐ
 */
#define NCUBE 44
#define OBJMAX NCUBE
int nobj;				/* number of cubes : L[u */
GsDOBJ2 object[OBJMAX];			/* 3D object variable : 3DIuWFNgϐ */
GsCOORDINATE2 objcoord[OBJMAX];		/* local coordinate variable : [JWϐ */
SVECTOR Rot[OBJMAX];			/* rotation angle : ]p */
SVECTOR RotV[OBJMAX];			/* rotation speed(angular velocity) : ]Xs[hipxj */
VECTOR Trns[OBJMAX];			/* cube position (parallel displacement) :
                                   L[uʒuisړʁj */
VECTOR TrnsV[OBJMAX];			/* displacement speed : ړXs[h */

/*
 *  VIEW (viewpoint) : _iVIEWj
 */
GsRVIEW2  View;				/* viewpoint variable : _ϐ */
int ViewAngleXZ;			/* viewpoint height : _̍ */
int ViewRadial;				/* distance from viewpoint : _̋ */
#define DISTANCE 600			/* initial value for Radial : Radial̏l */

/*
 *  light source : 
 */
GsF_LIGHT pslt[3];			/* light source data variable x  3 : ϐ~3 */

/*
 *  other : ̑...
 */
int Bakuhatu;				/* explosion processing flag : tO */
u_long PadData;				/* controller pad data : Rg[pbh̏ */
u_long oldpad;				/* controller pad data from previous frame : 
                               Pt[Õpbh */
GsFOGPARAM dq;				/* parameter for depth queue (fog) : 
                               fvXL[(tHO)pp[^ */
int dqf;				/* check if fog is ON : tHOONǂ */
int back_r, back_g, back_b;		/* background color : obNOEhF */
#define FOG_R 160
#define FOG_G 170
#define FOG_B 180

/*
 *  function prototype declaration : ֐̃vg^Cv錾
 */
void drawCubes();
int moveCubes();
void initModelingData();
void allocCube();
void initSystem();
void initAll();
void initTexture();
void initView();
void initLight();
void changeFog();
void changeTmd();
int	datafile_search();
int	datafile_read();

/*
 *  file information : t@C
 */
typedef struct{
	char	*fname;
	void	*addr;
	CdlFILE finfo;
} FILE_INFO;

#define DFILENO 2

static FILE_INFO dfile[DFILENO] = {
	{ "\\DATA\\RCUBE.TMD;1",(void *)TMD_ADDR,0 },
	{ "\\DATA\\RCUBE.TIM;1",(void *)TIM_ADDR,0 } 
};


// Dual Shock values
static unsigned char padbuff[2][34];
unsigned char Motor[2];
int portNo = 0x00;
int ctr;
static unsigned char align[6]={0,1,0xFF,0xFF,0xFF,0xFF};

#define DUALSHOCKMODE ((u_long *)0x80010000)
unsigned long *storedMode = DUALSHOCKMODE;

u_long handlePad(void);

/*
 *  main routine : C[`
 */
main()
{
	int offs,maxID,set;

	ResetCallback();
	CdInit();

	PadInitDirect(padbuff[0],padbuff[1]);
	PadStartCom();

	// ReInit Dual Shock if required
	printf("%d\n",*storedMode);
	VSync(30);
	maxID = PadInfoMode(0x00,InfoModeIdTable,-1);
	printf("Max:%d\n",maxID);
	VSync(5);

	for(offs=0;offs<maxID;offs++)
	{
		printf("Entry:%d Searching for:%d, Mode:%d\n",offs,*storedMode,PadInfoMode(0x00,InfoModeIdTable,offs));
	
		if( PadInfoMode(0x00,InfoModeIdTable,offs) == *storedMode)
		{
			printf("Found Match:%d\n",offs);
			VSync(6);
			PadSetMainMode(0x00,offs,2);
			break;
		}
	}

	// Wait till it's stable
	set = 0;
	while(!set)
	{
		if(PadGetState(portNo) == PadStateStable)
		{
			if(PadInfoMode(portNo,InfoModeCurExID,0))
			{
				VSync(20);
                                PadSetAct(0x00,Motor,2);
                                while( PadSetActAlign(0x00,align) == 0)
                                {
                                       for(ctr=0;ctr<6;ctr++)
                                               VSync(0);
                                }
			}
			set = 1;
		}
		if(PadGetState(portNo) == PadStateFindCTP1)
		{
			printf("Found Normal Controller\n");
			set = 1;
		}
	}
	printf("Finished Dual Shock Setup\n");

	datafile_search(dfile,DFILENO);
	datafile_read(dfile,DFILENO);
	/* initialize system : VXȅ */
	initSystem();

	/* other initialization : ̑̏ */
	Bakuhatu = 0;
	PadData = 0;
	CurrentTmd = 0;
	dqf = 0;
	back_r = back_g = back_b = 0;
	initView();
	initLight(0, 0xc0);
	initModelingData(TMD_ADDR);
	initTexture(TIM_ADDR);
	allocCube(NCUBE);
	
	/* main loop : C[v */
	while(1) {
		if(moveCubes())
			break;
		GsSetRefView2(&View);
		drawCubes();

		FntFlush(-1);

	}

	PadStopCom();
	printf("Pad Stopped, pretending to take a long time to load..\n");
	// pause for at least four seconds to simulate long load
	VSync(240);

	ResetGraph(3); /* reset with clearing screen : 
	                  ʂɃZbg */
	StopCallback();
#ifdef DEAD_PARENT
	/* load parent again, because parent was destroyed already. ::
	   ɐe͎ł̂ŁAxeLoadExec() */
	_96_init();
	LoadExec("cdrom:\\EXECMENU\\EXECMENU.EXE;1",0x801ffff0,0);
	/* this setting of stack pointer is meaningless, because EXECMENU.EXE
	   was linked with 2MBYTE.OBJ. ::
	   EXECMENU.EXE ɂ 2MBYTE.OBJ NĂ̂ŁAł̃X^bN
	   |C^l̐ݒ͈ӖȂAꉞ 0x801ffff0 ƂĂB*/
#else
	return(0);
#endif
}


/*
 *  draw 3D object (cube) : 3DIuWFNgiL[uj̕`
 */
void drawCubes()
{
	int i;
	GsDOBJ2 *objp;
	int activeBuff;
	MATRIX LsMtx;

	/* which of the double buffers are active? : 
	   _uobt@̂ǂ炪ANeBuH */
	activeBuff = GsGetActiveBuff();

	/* set GPU packet creation address to the start of the area : 
	   GPUpPbgAhXGA̐擪ɐݒ */
	GsSetWorkBase((PACKET*)GpuPacketArea[activeBuff]);

	/* clear OT contents : OT̓eNA */
	GsClearOt(0, 0, &WorldOT[activeBuff]);

	/* enter 3D object (cube) into OT : 3DIuWFNgiL[ujOTւ̓o^ */
	objp = object;
	for(i = 0; i < nobj; i++) {

		/* rotation angle -> set in matrix : ]p->}gNXɃZbg */
		RotMatrix(Rot+i, &(objp->coord2->coord));
		
		/* reset flag since matrix has been updated : 
		   }gNXXV̂ŃtOZbg */
                objp->coord2->flg = 0;

		/* translation capacity -> set in matrix : sړ->}gNXɃZbg */
                TransMatrix(&(objp->coord2->coord), &Trns[i]);
		
		/* calculate matrix for perspective transformation and set in GTE : 
		   ϊ̂߂̃}gNXvZĂfsdɃZbg */
		GsGetLs(objp->coord2, &LsMtx);
		GsSetLsMatrix(&LsMtx);
		GsSetLightMatrix(&LsMtx);

		/* perform perspective transformation and enter in OT : 
		   ϊOTɓo^ */
		GsSortObject4(objp, &WorldOT[activeBuff], 14-OT_LENGTH,getScratchAddr(0));
		objp++;
	}

	/* include pad data in buffer : pbh̓eobt@Ɏ荞 */
	oldpad = PadData;
	PadData = handlePad();
	
	/* wait for V-BLNK : V-BLNK҂ */
#ifdef APD_LOAD
	APDSetCnt(VSync(0));
#else
	VSync(0);
#endif
	
	/* forcibly stop drawing operation for previous frame : Õt[̕`ƂI */
	ResetGraph(1);

	/* swaap double buffer : _uobt@ꊷ */
	GsSwapDispBuff();

	/* insert screen clear command at start of OT : 
	   OT̐擪ɉʃNA߂} */
	GsSortClear(back_r, back_g, back_b, &WorldOT[activeBuff]);

	/* begin drawing OT contents in background : 
	   OT̓eobNOEhŕ`Jn */
	GsDrawOt(&WorldOT[activeBuff]);
}

/*
 *  move cube : L[üړ
 */
int moveCubes()
{
	int i;
	GsDOBJ2   *objp;
	
	/* process according to pad value : pbh̒lɂď */
	if((PadData & PADLleft)>0) {
		ViewAngleXZ++;
		if(ViewAngleXZ >= 72) {
			ViewAngleXZ = 0;
		}
	}
	if((PadData & PADLright)>0) {
		ViewAngleXZ--;
		if(ViewAngleXZ < 0) {
		  ViewAngleXZ = 71;
		}
	}
	if((PadData & PADLup)>0) View.vpy += 100;
	if((PadData & PADLdown)>0) View.vpy -= 100;
	if((PadData & PADRdown)>0) {
		ViewRadial-=3;
		if(ViewRadial < 8) {
			ViewRadial = 8;
		}
	}
	if((PadData & PADRright)>0) {
		ViewRadial+=3;
		if(ViewRadial > 450) {
			ViewRadial = 450;
		}
	}
	if((PadData & PADk)>0) return(-1);
	if(((PadData & PADRleft)>0)&&((oldpad&PADRleft) == 0)) changeFog();
	if(((PadData & PADRup)>0)&&((oldpad&PADRup) == 0)) changeTmd();
	if(((PadData & PADn)>0)&&((oldpad&PADn) == 0)) Bakuhatu = 1;
	if(((PadData & PADl)>0)&&((oldpad&PADl) == 0)) allocCube(NCUBE);

	View.vpx = rotx[ViewAngleXZ]*ViewRadial;
	View.vpz = roty[ViewAngleXZ]*ViewRadial;

	/* update position data for cube : L[üʒuXV */
	objp = object;
	for(i = 0; i < nobj; i++) {

		/* begin explosion : ̊Jn */
		if(Bakuhatu == 1) {

			/* increase rotation speed : ]x up */
			RotV[i].vx *= 3;
			RotV[i].vy *= 3;
			RotV[i].vz *= 3;

			/* set direction of displacement and velocity : ړ&xݒ */
			TrnsV[i].vx = objp->coord2->coord.t[0]/4+
						(rand()-16384)/200;	
			TrnsV[i].vy = objp->coord2->coord.t[1]/6+
						(rand()-16384)/200-200;
			TrnsV[i].vz = objp->coord2->coord.t[2]/4+
						(rand()-16384)/200;
		}
		/* processing for during explosion : ̏ */
		else if(Bakuhatu > 1) {
			if(Trns[i].vy > 3000) {
				Trns[i].vy = 3000-(Trns[i].vy-3000)/2;
				TrnsV[i].vy = -TrnsV[i].vy*6/10;
			}
			else {
				TrnsV[i].vy += 20*2;	/* free fall : R */
			}

			if((TrnsV[i].vy < 70)&&(TrnsV[i].vy > -70)&&
			   (Trns[i].vy > 2800)) {
				Trns[i].vy = 3000;
				TrnsV[i].vy = 0;

				RotV[i].vx *= 95/100;
				RotV[i].vy *= 95/100;
				RotV[i].vz *= 95/100;
			}


			TrnsV[i].vx = TrnsV[i].vx*97/100;
			TrnsV[i].vz = TrnsV[i].vz*97/100;
		}

		/* update rotation angle (Rotation) : ]p(Rotation)̍XV */
 		Rot[i].vx += RotV[i].vx;
		Rot[i].vy += RotV[i].vy;
		Rot[i].vz += RotV[i].vz;

		/* update translation (Transfer) : sړ(Transfer)̍XV */
 		Trns[i].vx += TrnsV[i].vx;
		Trns[i].vy += TrnsV[i].vy;
		Trns[i].vz += TrnsV[i].vz;

		objp++;
	}

	if(Bakuhatu == 1)
		Bakuhatu++;

	return(0);
}

/*
 *  set cube to initial position : L[uʒuɔzu
 */
void allocCube(n)
int n;
{	
	int x, y, z;
	int i;
	int *posp;
	GsDOBJ2 *objp;
	GsCOORDINATE2 *coordp;

	posp = cube_def_pos;
	objp = object;
	coordp = objcoord;
	nobj = 0;
	for(i = 0; i < NCUBE; i++) {

		/* initialize object structure : IuWFNg\̂̏ */
		GsLinkObject4((u_long)TmdBase, objp, CurrentTmd);
		GsInitCoordinate2(WORLD, coordp);
		objp->coord2 = coordp;
		objp->attribute = 0;
		coordp++;
		objp++;

		/* set initial position (read from pos.h) : ʒu̐ݒ(pos.hǂ) */
		Trns[i].vx = *posp++;
		Trns[i].vy = *posp++;
		Trns[i].vz = *posp++;
		Rot[i].vx = 0;
		Rot[i].vy = 0;
		Rot[i].vz = 0;

		/* initialize velocity : x̏ */
		TrnsV[i].vx = 0;
		TrnsV[i].vy = 0;
		TrnsV[i].vz = 0;
		RotV[i].vx = rand()/300;
		RotV[i].vy = rand()/300;
		RotV[i].vz = rand()/300;

		nobj++;
	}
	Bakuhatu = 0;
}

/*
 *  initialize function group : CjVCY֐Q
 */
void initSystem()
{
	int i;


	/* initialize graphics : OtBbN̏ */
	GsInitGraph(640, 480, 2, 0, 0);
	GsDefDispBuff(0, 0, 0, 0);

	/* initialize OT : OT̏ */
	for(i = 0; i < 2; i++) {	
		WorldOT[i].length = OT_LENGTH;
		WorldOT[i].org = OTTags[i];
	}	

	/* initialize OT : 3DVXȅ */
	GsInit3D();

	FntLoad(960, 256);	
	SetDumpFnt(FntOpen(16, 16, 256, 200, 0, 512));	

}

void initModelingData(tmdp)
u_long *tmdp;
{
	u_long size;
	int i;
	int tmdobjnum;
	
	/* skip header : wb_XLbv */
	tmdp++;

	/* mapping to real address : AhXփ}bsO */
	GsMapModelingData(tmdp);

	tmdp++;
	tmdobjnum = *tmdp;
	tmdp++; 		/* point to object at beginning : 擪̃IuWFNg|Cg */
	TmdBase = tmdp;
}

/*
 *  read in texture(transfer to VRAM) : eNX`̓ǂݍ݁iVRAMւ̓]j
 */
void initTexture(tex_addr)
u_long *tex_addr;
{
	RECT rect1;
	GsIMAGE tim1;
	int i;
	
	while(1) {
		if(*tex_addr != TIM_HEADER) {
			break;
		}
		tex_addr++;	/* skip header (1word) : wb_̃XLbv(1word) */
		GsGetTimInfo(tex_addr, &tim1);
		tex_addr += tim1.pw*tim1.ph/2+3+1;	/* proceed up to next block : 
		                                       ̃ubN܂Ői߂ */
		rect1.x=tim1.px;
		rect1.y=tim1.py;
		rect1.w=tim1.pw;
		rect1.h=tim1.ph;
		LoadImage(&rect1,tim1.pixel);
		if((tim1.pmode>>3)&0x01) {	/* if ther is a CLUT, then transfer : 
		                               CLUTΓ] */
			rect1.x=tim1.cx;
			rect1.y=tim1.cy;
			rect1.w=tim1.cw;
			rect1.h=tim1.ch;
			LoadImage(&rect1,tim1.clut);
			tex_addr += tim1.cw*tim1.ch/2+3;
		}
	}
}

/*
 *  initialize viewpoint : _̏
 */
void initView()
{
	/* set viewpoint variable as initial position : 
	   ʒu_ϐɃZbg */
	ViewAngleXZ = 54;
	ViewRadial = 75;
	View.vpx = rotx[ViewAngleXZ]*ViewRadial;
	View.vpy = -100;
	View.vpz = roty[ViewAngleXZ]*ViewRadial;
	View.vrx = 0; View.vry = 0; View.vrz = 0;
	View.rz=0;

	/* parent coordinates of viewpoints : _̐eW */
	View.super = WORLD;

	/* set : ݒ */
	GsSetRefView2(&View);

	/* Projection */
	GsSetProjection(1000);

	/* mode = normal lighting : [h = 'normal lighting' */
	GsSetLightMode(0);
}

/*
 *  initialize light source : ̏
 */
void initLight(c_mode, factor)
int c_mode;	/* if 0, white light; if 1, coctail lights : 
               ÔƂFAP̂ƂJNeCg */
int factor;	/* brightness factor (0-255) : 邳̃t@N^[(0`255) */
{
	if(c_mode == 0) {
		/* set white light : F̃Zbg */
		pslt[0].vx = 200; pslt[0].vy= 200; pslt[0].vz= 300;
		pslt[0].r = factor; pslt[0].g = factor; pslt[0].b = factor;
		GsSetFlatLight(0,&pslt[0]);
		
		pslt[1].vx = -50; pslt[1].vy= -1000; pslt[1].vz= 0;
		pslt[1].r=0x20; pslt[1].g=0x20; pslt[1].b=0x20;
		GsSetFlatLight(1,&pslt[1]);
		
		pslt[2].vx = -20; pslt[2].vy= 20; pslt[2].vz= 100;
		pslt[2].r=0x0; pslt[2].g=0x0; pslt[2].b=0x0;
		GsSetFlatLight(2,&pslt[2]);
	}
	else {
		/* cocktail lights (using Gouraud) : JNeCgiGouraudŎgpj */
		pslt[0].vx = 200; pslt[0].vy= 100; pslt[0].vz= 0;
		pslt[0].r = factor; pslt[0].g = 0; pslt[0].b = 0;
		GsSetFlatLight(0,&pslt[0]);
		
		pslt[1].vx = -200; pslt[1].vy= 100; pslt[1].vz= 0;
		pslt[1].r=0; pslt[1].g=0; pslt[1].b=factor;
		GsSetFlatLight(1,&pslt[1]);
		
		pslt[2].vx = 0; pslt[2].vy= -200; pslt[2].vz= 0;
		pslt[2].r=0; pslt[2].g=factor; pslt[2].b=0;
		GsSetFlatLight(2,&pslt[2]);
	}	

	/* ambient light : ArGgiӌj */
	GsSetAmbient(ONE/2,ONE/2,ONE/2);
}

/*
 * fog ON/OFF : tHOON/OFF
 */
void changeFog()
{
	if(dqf) {
		/* reset fog : tHÕZbg */
		GsSetLightMode(0);
		dqf = 0;
		back_r = 0;
		back_g = 0;
		back_b = 0;
	}
	else {
		/* set fog : tHO̐ݒ */
		dq.dqa = -600;
		dq.dqb = 5120*4096;
		dq.rfc = FOG_R;
		dq.gfc = FOG_G;
		dq.bfc = FOG_B;
		GsSetFogParam(&dq);
		GsSetLightMode(1);
		dqf = 1;
		back_r = FOG_R;
		back_g = FOG_G;
		back_b = FOG_B;
	}
}

/*
 *  switch TMD data : TMDf[^̐؂ւ
 */
void changeTmd()
{
	u_long *tmdp;
	GsDOBJ2 *objp;
	int i;

	/* switch TMD : TMD؂ւ */
	CurrentTmd++;
	if(CurrentTmd == 4) {
		CurrentTmd = 0;
	}
	objp = object;
	for(i = 0; i < nobj; i++) {
		GsLinkObject4((u_long)TmdBase, objp, CurrentTmd);
		objp++;
	}

	/* switch color/brightness of light source according to 
	   TMD type : TMD̎ނɂ킹Č̐F/邳؂ւ */
	switch(CurrentTmd) {
	    case 0:
                /* normal (flat) : m[} (flat) */
		initLight(0, 0xc0);
		break;
	    case 1:
	        /* semi-transparent (flat) :  (flat) */
		initLight(0, 0xc0);
		break;
	    case 2:
	        /* Gouraud */
		initLight(1, 0xff);
		break;
	    case 3:
	        /* with texture : eNX`t */
		initLight(0, 0xff);
		break;
	}
}



int
datafile_search(file,nf)

FILE_INFO *file;
int nf;
{
	short i,j;

	for (j = 0; j < nf; j++){
		for (i = 0; i < 10; i++) {	/* ten retries : gC 10  */
			if (CdSearchFile( &(file[j].finfo), file[j].fname ) != 0) 
				break;
			else
				printf("%s not find.\n",file[j].fname);
		}
	}
}


int
datafile_read(file,nf)

FILE_INFO *file;
int nf;
{
	int	mode = CdlModeSpeed;
	int	nsector;
	short i,j;
	long cnt;
	unsigned char com;

	for (j = 0; j < nf; j++){
		for (i = 0; i < 10; i++) {	/* ten retries : gC 10  */
			nsector = (file[j].finfo.size + 2047) / 2048;

			/* set target position : ^[Qbg|WVݒ */
			CdControl(CdlSetloc, (u_char *)&(file[j].finfo.pos), 0);

			com = CdlModeSpeed;
			CdControlB( CdlSetmode, &com, 0 );
#ifdef APD_LOAD
			APDSetCnt(VSync(3));
#else
			VSync( 3 );
#endif

			/* begin read : [hJn */
			CdRead(nsector, file[j].addr, mode);

			/* normal operations can be performed behind the read operation.*/
			/* sector count is monitored here until Read is finished :
			/* [h̗Œʏ͎̏słB*/
			/* ł́ARead I܂Ŏc̃ZN^Ď */
			while ((cnt = CdReadSync(1, 0)) > 0 ) {
#ifdef APD_LOAD
				APDSetCnt(VSync(0));
#else
				VSync(0);
#endif
			}

			/* break if normal exit : IȂ΃u[N */
			if (cnt == 0)	break;
		}
	}
}

u_long handlePad(void)
{
	int		padState;
	int		set;
	int		currentPad;
	u_long	button;

	FntPrint("\n\n\n");

	padState = PadGetState(portNo);

	if(padState==PadStateDiscon)
	{
		FntPrint("No Pad Connected\n");
		return 0;
	}

	if(padState==PadStateFindPad)
	{
		// Set actuators if Dual Shock
		set = 0;
		while(!set)
		{
			if(PadGetState(portNo) == PadStateStable)
			{
				if(PadInfoMode(portNo,InfoModeCurExID,0))
				{
					PadSetAct(0x00,Motor,2);
					while( PadSetActAlign(0x00,align) == 0)
					{
						for(ctr=0;ctr<6;ctr++)
							VSync(0);
					}
				}
				set = 1;
			}
			if(PadGetState(portNo) == PadStateFindCTP1)
			{
				printf("Found Normal Controller\n");
				set = 1;
			}
		}
		return 0;
	}		

	currentPad = PadInfoMode(portNo,InfoModeCurExID,0);
	if((currentPad == 4) || (currentPad==7) )
	{
		// Dual Shock connected
		FntPrint("Dual Shock Connected\n");
		FntPrint("\tMotor0 %03d\n",Motor[0]);
		FntPrint("\tMotor1 %03d\n",Motor[1]);
	}
	else
	{
		// Normal controller of some type connected
		currentPad = PadInfoMode(portNo,InfoModeCurID,0) +10;

		switch(currentPad)
		{
		case 14:
		{
			FntPrint("Standard Pad Connected\n");
			break;
		}
		case 17:
		{
			FntPrint("Old Analog Pad Connected\n");
			break;
		}
		default:
		{
			FntPrint("Unhandled Pad Connected\n");
			return 0;
		}
		}

	}

	// ignore received data when communication failed
	if(*(padbuff[0]))
	{
		return 0;
	}

	button = ~((padbuff[0][2]<<8) | padbuff[0][3]);

	if((button & PADRdown) && ((currentPad == 4) || (currentPad == 7)) )
	{
		// vibrate actuator 0 (can only be on or off)
		if(Motor[0] == 1)
			Motor[0] = 0;
		else
			Motor[0] = 1;

		PadSetAct(0x00,Motor,2);

	}
	if((button & PADRup) && ((currentPad == 4) || (currentPad == 7)) )
	{
		// vibration off
		Motor[0] = 0;
		Motor[1] = 0;
		PadSetAct(0x00,Motor,2);

	}
	if((button & PADRleft) && ((currentPad == 4) || (currentPad == 7))  )
	{
		// vibration
		if(Motor[1] != 0)
			Motor[1] --;

		PadSetAct(0x00,Motor,2);

	}
	if((button & PADRright) && ((currentPad == 4) || (currentPad == 7)) )
	{
		// vibration
		if(Motor[1] != 255)
			Motor[1] ++;
		PadSetAct(0x00,Motor,2);
	}

//	if(button & PADLup)		n += 4;
//	if(button & PADLdown)	n -= 4;

	if((button & PADselect) || (button & PADstart) )
	{
		if( (currentPad == 4) || (currentPad == 7) )
		{
			*storedMode = PadInfoMode(0x00,InfoModeCurExID,0);
			printf("Storing Dual Shock Mode:%d\n",*storedMode);
		}
		else
		{
			*storedMode = 0;
			printf("Clearing Dual Shock Mode:%d\n",*storedMode);
		}

		return(-1);
	}

	return(button);
}
