/* ---------------------------------------------------------------------------
 * - (C) Sony Computer Entertainment. All Rights Reserved.
 * -
 * - Project:	Movie Player V2.0	
 * -
 * - Name:		main.h
 * -
 * - Author:	Vince Diesi
 * -
 * - Date:		13th Feb 1997
 * ---------------------------------------------------------------------------
 */

#ifndef __MAIN_H
#define __MAIN_H

/* ---------------------------------------------------------------------------
 * - CONSTANTS
 * ---------------------------------------------------------------------------
 */

// Screen position and dimensions. 
#define	FRAME_X			512

#define	FRAME_Y			256
#define SCREEN_X		0
#define SCREEN_Y		18	

/* ---------------------------------------------------------------------------
 * - DATA TYPE AND STRUCTURE DECLARATIONS
 * ---------------------------------------------------------------------------
 */
 
typedef struct {
	DRAWENV		draw;
	DISPENV		disp;
} DB;

/* ---------------------------------------------------------------------------
 * - GLOBAL DECLARATIONS
 * ---------------------------------------------------------------------------
 */
 
extern DB		db[2];		
extern short	cdb;
extern long		fIdA;				// Aplic font id.

/* ---------------------------------------------------------------------------
 * - LIBSN.LIB GLOBAL DECLARATIONS
 * ---------------------------------------------------------------------------
 */

extern unsigned long __heapbase;
extern unsigned long __heapsize;
extern unsigned long __bss;
extern unsigned long __bsslen;
extern unsigned long __data;
extern unsigned long __datalen;
extern unsigned long __text;
extern unsigned long __textlen;
extern unsigned long _ramsize;
extern unsigned long _stacksize;

// Function prototypes
static void		InitSys(void); 
static void		CloseSys(void);
static void		VSyncCB(void);
static void		ClearVRAM(void);
void			CreatePath(char *filename);
void			InitEnvs(DB *db);
void			SndInit(void);
void			MoveHighlight(int i, int numFiles);
void			ParseFileType(char *string,int currentFile);
void			displayFileDetails(int file);
void			InitStream(int file);
#endif // __MAIN_H 
