/* --------------------------------------------------------------------------
 * - (C) Sony Computer Entertainment. All Rights Reserved.
 * -
 * - Project:	Movie Player V2.0	
 * -
 * - Name:		movie.h
 * -
 * - Author:	Vince Diesi
 * -
 * - Date:		13th Feb 1997
 * ---------------------------------------------------------------------------
 */ 
 
#ifndef __MOVIE_H
#define __MOVIE_H

/* ---------------------------------------------------------------------------
 * - CONSTANTS
 * ---------------------------------------------------------------------------
 */
 
// Streaming modes.
#define STR_MODE24				1
#define STR_MODE16				0


// Border modes.
#define STR_BORDERS_OFF			0
#define STR_BORDERS_ON			1


// PlayStream return values.
#define	PLAYSTR_END				1
#define	PLAYSTR_USER			2
#define	PLAYSTR_ERROR			3

/* ---------------------------------------------------------------------------
 * - DATA TYPE AND STRUCTURE DECLARATIONS
 * ---------------------------------------------------------------------------
 */

typedef struct {
		char		*strName;					// Stream file name.
		CdlLOC		strPos;						// File location
		short		mode;						// 24-Bit or 16-Bit streaming.
		short		drawBorders;				// != 0 if borders on.
		u_short		scrWidth;					// Screen res width.
		u_short		x;							// X,Y position. 
		u_short		y;
		u_short		width;						// Stream width and height.
		u_short		height;
		u_long		endFrame;					// Last frame No.
		u_long		vlcBufSize;					// Size of each VLC buffer (including header).
		u_short		volume;						// Left and Right ADPCM volume.
} StrInfo;

typedef struct
{
        unsigned short id;
        unsigned short type;
        unsigned short secCount;
        unsigned short nSectors;
        unsigned long frameCount;
        unsigned long frameSize;

        unsigned short width;
        unsigned short height;

        unsigned long headm;
        unsigned long headv;
        unsigned long reserved;
        unsigned long data[2048];
}
CdSectorHeader;

/* ---------------------------------------------------------------------------
 * - PUBLIC FUNCTION PROTOTYPES
 * ---------------------------------------------------------------------------
 */
 
short PlayStream(StrInfo *str, short (*keyHandler)(void));

/* ------------------------------------------------------------------------ */

#endif // __MOVIE_H
