#include <sys/types.h>
#include <sys/file.h>
#include <kernel.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libcd.h>
#include <libpad.h>
#include <stdio.h>

#define OTSIZE		2			// size of ordering table
#define MAXOBJ		15			// max polygon number, four dual shock controllers, background
#define MAXFLATS	18			// motors (4 * No controllers) + 2 for total load

typedef struct {
    u_long 	*addr;					//	texture addr in mem
    int		texture_x,texture_y;	//	x, y loaction in tpage
    int		texture_w, texture_h;	//	width and height of texture
    int		clut_x, clut_y;			//	clut x, y location
    int		tpage;					// 	tpage no. from 0-15, 16-31
    int		semi_trans;				//	0 = solid, 1 = semi_trans
    int		mode;					//     bit 0 = 4-bit, bit 1 = 8-bit, 2 = 16-bit
} TEXTURE_INFO;

typedef struct {
	DRAWENV draw;
	DISPENV disp;
	long x,y;
	u_long		ot[OTSIZE];
	POLY_FT4	polys[MAXOBJ];
	POLY_F4		flats[MAXFLATS];
	POLY_G4		backpoly;
} DB;


void	InitGraphics(DB *db0, DB *db1);
void	InitDualShockTexture(void);
void	InitDualShockSprites(DB *db);
int		loadTIM(TEXTURE_INFO *info);
void	drawBackground(u_long *ot,POLY_G4 *backPoly);
void	drawPolys(DB *cdb);
void	drawPadState(int portNo, int padState);
void	drawTitle(int connection);
void	drawBuffer(void);
void	ClearVRAM(void);
