$path = [Environment]::GetEnvironmentVariable("Path", [System.EnvironmentVariableTarget]::User)
$paths = $path -split ";"
$applyChanges = 0

# Paths
$currentDirectory = $pwd
$compilerDirectory = -join($pwd, "\gcc-mipsel-none-elf-12.3.0-windows\bin")
$makeDirectory = -join($pwd, "\make-3.81-bin\bin")

# Ensure paths are in environment variables array
Write-Output "Setting up environment..."
if($paths -contains $currentDirectory) {
    Write-Output "$currentDirectory already added to Path"
} else {
    $paths += $currentDirectory
    $applyChanges = 1
    Write-Output "Added $currentDirectory to Path"
}

if($paths -contains $compilerDirectory) {
    Write-Output "$compilerDirectory already added to Path"
} else {
    $paths += $compilerDirectory
    $applyChanges = 1
    Write-Output "Added $compilerDirectory to Path"
}

if($paths -contains $makeDirectory) {
    Write-Output "$makeDirectory already added to Path"
} else {
    $paths += $makeDirectory
    $applyChanges = 1
    Write-Output "Added $makeDirectory to Path"
}

# Apply environment variables to user
if($applyChanges) {
    Write-Output "Applying environment variables, please wait..."
    [Environment]::SetEnvironmentVariable("Path", $paths -join ";", [System.EnvironmentVariableTarget]::User)
    $env:Path = [System.Environment]::GetEnvironmentVariable("Path","Machine") + ";" + [System.Environment]::GetEnvironmentVariable("Path","User")
    Write-Output "Success!"
} else {
    Write-Output "Everything is already installed"
}



