/*
 * $PSLibId: Runtime Library Release 3.6$
 */
/*
 *          Movie Sample Program
 *
 *      Copyright (C) 1994,5 by Sony Corporation
 *          All rights Reserved
 *
 *  streaming movie from CD-ROM with memory streaming :
 *  CD-ROM 烀[r[Xg[~OTv
 *  pbh̓͂ɂ [Xg[~Oɐ؂ւ
 *
 *   Version    Date
 *  ------------------------------------------
 *  1.00        Sep,26,1995     yutaka
 */

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libcd.h>
#include <r3000.h>
#include <asm.h>
#include <kernel.h>


#define FILE_NAME   "\\DATA\\MOV.STR;1"
#define START_FRAME 1
#define END_FRAME   577
#define POS_X       36
#define POS_Y       24
#define SCR_WIDTH   320
#define SCR_HEIGHT  240

/*
 *  16bit/pixel mode or 24 bit/pixel mode :  
 *  fR[hF̎w(16bit/24bit)
 */
#define IS_RGB24    1   /* 0:RGB16, 1:RGB24 */
#if IS_RGB24==1
#define PPW 3/2     /* pixel/short word :
		       PV[g[hɉsNZ邩 */
#define DCT_MODE    3   /* 24bit decode :24bit [hŃfR[h */
#else
#define PPW 1       /* pixel/short word :
		       PV[g[hɉsNZ邩 */
#define DCT_MODE    2   /* 16 bit decode : 16bit [hŃfR[h */
#endif

/*
 *  decode environment : fR[hϐ
 */
typedef struct {
    u_long  *vlcbuf[2]; /* VLC buffer idoublej*/
    int vlcid;      /* current decode buffer id :
		        VLC fR[hobt@ ID */
    u_short *imgbuf[2]; /* decode image buffer idoublej*/
    int imgid;      /* corrently use buffer id :
		       ݎgp̉摜obt@ID */
    RECT    rect[2];    /* double buffer orign(upper left point) address
			   on the VRAM (double buffer) :
			   VRAMWli_uobt@j */
    int rectid;     /* currently translating buffer id :
		       ݓ]̃obt@ ID */
    RECT    slice;      /* the region decoded by once DecDCTout() :
			   P DecDCTout Ŏö */
    int isdone;     /* the flag of decoding whole frame :
		       Pt[̃f[^ł */
    int onmem;		/* flag for memory streaming :
			   Xg[~Oǂ̃tO */
} DECENV;
static DECENV   dec;        /* instance of DECENV : fR[h̎ */

/*
 *  Ring buffer for STREAMING
 *  minmum size is two frame :
 *  Xg[~OpOobt@
 *  CD-ROM̃f[^XgbN
 *  ŒQt[̗eʂmۂB
 *  Xg[~Ôߑeʃobt@m
 */
#define RING_SIZE   256      /* 32 sectors : Pʂ̓ZN^ */
static u_long   Ring_Buff[RING_SIZE*SECTOR_SIZE];

/*
 *  VLC buffer(double buffer)
 *  stock the result of VLC decode :
 *  VLCobt@i_uobt@j
 *  VLCfR[h̒ԃf[^XgbN
 */
#define VLC_BUFF_SIZE 320/2*256     /* not correct value :
				       Ƃ肠[ȑ傫 */
static u_long   vlcbuf0[VLC_BUFF_SIZE];
static u_long   vlcbuf1[VLC_BUFF_SIZE];

/*
 *  image buffer(double buffer)
 *  stock the result of MDEC
 *  rectangle of 16(width) by XX(height) :
 *  C[Wobt@i_uobt@j
 *  DCTfR[h̃C[Wf[^XgbN
 *  16sNZ̋`ɃfR[h]
 */
#define SLICE_IMG_SIZE 16*PPW*SCR_HEIGHT
static u_short  imgbuf0[SLICE_IMG_SIZE];
static u_short  imgbuf1[SLICE_IMG_SIZE];

/*
 *  ̑̕ϐ
 */
static int  StrWidth  = 0;  /* resolution of movie :
			       [r[摜̑傫iƏcj */
static int  StrHeight = 0;  
static int  Rewind_Switch;  /* the end flag set after last frame :
			       ItO:̃t[܂ōĐƂPɂȂ */

/*
 *  prototypes :  
 *  ֐̃vg^Cv錾
 */
static int  anim();
static void strSetDefDecEnv(DECENV *dec, int x0, int y0, int x1, int y1);
static void strInit(CdlLOC *loc, void (*callback)());
static void strCallback();
static void strNextVlc(DECENV *dec);
static void strSync(DECENV *dec, int mode);
static u_long *strNext(DECENV *dec);
static void strKickCD(CdlLOC *loc);

main()
{
    ResetCallback();
    CdInit();
    PadInit(0);
    ResetGraph(0);
    SetGraphDebug(0);
    
    while(1) {
        if(anim()==0)
	   return 0;     /* animation subroutine :
			    Aj[VTu[` */
    }
}

/*
 *  animation subroutine forground process :  
 *  Aj[VTu[` tHAOEhvZX
 */
static int anim()
{
    DISPENV disp;       /* display buffer : \obt@ */
    DRAWENV draw;       /* drawing buffer : `obt@ */
    int id;     /* display buffer id : \obt@ ID */
    CdlFILE file;
    int padd;
    
    /* search file : t@CT[` */
    if (CdSearchFile(&file, FILE_NAME) == 0) {
        printf("file not found\n");
        PadStop();
	ResetGraph(3);
        StopCallback();
        return 0;
    }
    
    /* set the position of vram : VRAM̍Wlݒ */
    strSetDefDecEnv(&dec, POS_X, POS_Y, POS_X, POS_Y+SCR_HEIGHT);
    
    /* init streaming system & kick cd : Xg[~OJn */
    strInit(&file.pos, strCallback);
    
    /* VLC decode the first frame : ŏ̃t[ VLCfR[hsȂ */
    strNextVlc(&dec);
    
    Rewind_Switch = 0;
    
    while (1) {
        /* start DCT decoding the result of VLC decoded data :      
	   VLC̊f[^DCTGR[hJniMDEC֑Mj */
        DecDCTin(dec.vlcbuf[dec.vlcid], DCT_MODE);
        
        /* prepare for recieving the result of DCT decode :
	   DCTfR[hʂ̎M̏            */
        /* next DecDCTout is called in DecDCToutCallback :	
           ̌̏̓R[obN[`ōsȂ */
        DecDCTout(dec.imgbuf[dec.imgid], dec.slice.w*dec.slice.h/2);
        
        /* decode the next frame's VLC data :
	   ̃t[̃f[^ VLC fR[h */
        strNextVlc(&dec);
        
        /* wait for whole decode process per 1 frame :	
	   Pt[̃fR[hÎ҂ */
        strSync(&dec, 0);
        
        /* wait for V-Vlank : V-BLNK ҂ */
        VSync(0);
        
        /* swap the display buffer : \obt@Xbv     */
        /* notice that the display buffer is the opossite side of
	   decoding buffer :
	   \obt@̓fR[hobt@̋tł邱Ƃɒ */
        id = dec.rectid? 0: 1;
        SetDefDispEnv(&disp, 0, (id)*240, SCR_WIDTH*PPW, SCR_HEIGHT);
/*      SetDefDrawEnv(&draw, 0, (id)*240, SCR_WIDTH*PPW, SCR_HEIGHT);*/
        
#if IS_RGB24==1
        disp.isrgb24 = IS_RGB24;
        disp.disp.w = disp.disp.w*2/3;
#endif
        PutDispEnv(&disp);
/*      PutDrawEnv(&draw);*/
        SetDispMask(1);     /* display enable : \ */
        
        if(Rewind_Switch == 1)
	  break;
        
        if((padd = PadRead(1)) & PADk)
	  /* stop button pressed exit animation routine :
	     Xgbv{^ꂽAj[V𔲂 */
	  break;

	/* start memory straming on pushed o button :
	   {^ꂽ Xg[~OJn */
        if(padd & PADRright)
	  StSetMask(0,0,0);

	/* stop memory streaming on pushed x button :
	   ~{^ꂽ Xg[~O߂ */
        if(padd & PADRdown)
	  {
	    dec.onmem = 0;
	    Rewind_Switch = 1;
	    break;
	  }
      }
    
    /* post processing of animation routine : Aj[V㏈ */
    DecDCToutCallback(0);
    StUnSetRing();
    CdControlB(CdlPause,0,0);
    if(Rewind_Switch==0) {
       PadStop();
       ResetGraph(3);
       StopCallback();
       return 0;
       }
    else
       return 1;
}


/*
 * init DECENV    buffer0(x0,y0),buffer1(x1,y1) :  
 * fR[h
 *  x0,y0 fR[h摜̓]Wiobt@Oj
 *  x1,y1 fR[h摜̓]Wiobt@Pj
 *
 */
static void strSetDefDecEnv(DECENV *dec, int x0, int y0, int x1, int y1)
{
    dec->vlcbuf[0] = vlcbuf0;
    dec->vlcbuf[1] = vlcbuf1;
    dec->vlcid     = 0;

    dec->imgbuf[0] = imgbuf0;
    dec->imgbuf[1] = imgbuf1;
    dec->imgid     = 0;

    /* width and height of rect[] are set dynamicaly according to STR data :
       rect[]̕^STRf[^̒lɂăZbg */
    dec->rect[0].x = x0;
    dec->rect[0].y = y0;
    dec->rect[1].x = x1;
    dec->rect[1].y = y1;
    dec->rectid    = 0;

    dec->slice.x = x0;
    dec->slice.y = y0;
    dec->slice.w = 16*PPW;

    dec->isdone    = 0;
    dec->onmem     = 0;
}


/*
 * init the streaming environment and start the cdrom :  
 * Xg[~OĊJn
 */
static void strInit(CdlLOC *loc, void (*callback)())
{
    static void repeatCallback();
  
    /* cold reset mdec : MDEC Zbg */  
    DecDCTReset(0);
  
    /* set the callback after 1 block MDEC decoding :
       MDECPfR[hubÑR[obN` */
    DecDCToutCallback(callback);
    
    /* set the ring buffer : Oobt@̐ݒ */
    StSetRing(Ring_Buff, RING_SIZE);
    
    /* init the streaming library : Xg[~OZbgAbv */
    /* end frame is set endless : It[=ɐݒ   */
    StSetStream(IS_RGB24, START_FRAME, 0xffffffff, 0, (void *)repeatCallback);
    
    /* start the cdrom : Xg[~O[hJn */
    strKickCD(loc);
}


/*
 *  back ground process
 *  callback of DecDCTout() :
 *  obNOEhvZX 
 *  (DecDCTout() IɌĂ΂R[obN֐)
 */
static void strCallback()
{
  RECT snap_rect;
  int  id;
  
#if IS_RGB24==1
    extern StCdIntrFlag;
    if(StCdIntrFlag) {
        StCdInterrupt();     /* on the RGB24 bit mode , call
			       StCdInterrupt manually at this timing :
			       RGB24̎͂ŋN */
        StCdIntrFlag = 0;
    }
#endif
    
  id = dec.imgid;
  snap_rect = dec.slice;
  
    /* switch the id of decoding buffer : 摜fR[ḧ̐ؑւ */
    dec.imgid = dec.imgid? 0:1;

    /* update slice(rectangle) position :  
       XCXiZ`j̈ЂƂEɍXV */
    dec.slice.x += dec.slice.w;
    
    /* remaining slice ? : c̃XCX邩H */
    if (dec.slice.x < dec.rect[dec.rectid].x + dec.rect[dec.rectid].w) {
        /* prepare for next slice : ̃XCXfR[hJn */
        DecDCTout(dec.imgbuf[dec.imgid], dec.slice.w*dec.slice.h/2);
    }
    /* last slice ; end of 1 frame : ŏIXCXPt[I */
    else {
        /* set the decoding done flag : IƂʒm */
        dec.isdone = 1;
        
        /* update the position on VRAM : ]WlXV */	
        dec.rectid = dec.rectid? 0: 1;
        dec.slice.x = dec.rect[dec.rectid].x;
        dec.slice.y = dec.rect[dec.rectid].y;
    }
  
  /* transfer the decoded data to VRAM :
     fR[hʂt[obt@ɓ] */
  LoadImage(&snap_rect, (u_long *)dec.imgbuf[id]);
}


static void repeatCallback()
{
  dec.onmem = 1;
/*  CdControlF(CdlPause,0);*/
}


/*
 *  execute VLC decoding
 *  the decoding data is the next frame's :
 *  VLCfR[h̎s
 *  1t[̃f[^VLCfR[hsȂ
 */
static void strNextVlc(DECENV *dec)
{
    int cnt = WAIT_TIME;
    u_long  *next;
    static u_long *strNext();

    /* get the 1 frame streaming data : f[^Pt[o */
    while ((next = strNext(dec)) == 0) {
        if (--cnt == 0)
            return;
    }
    
    /* switch the decoding area : VLCfR[ḧ̐ؑւ */
    dec->vlcid = dec->vlcid? 0: 1;

    /* VLC decode */
    DecDCTvlc(next, dec->vlcbuf[dec->vlcid]);

    /* free the ring buffer : Oobt@̃t[̗̈ */
    StFreeRing(next);

    return;
}

/*
 *  get the 1 frame streaming data
 *  return vale     normal end -> top address of 1 frame streaming data
 *                  error      -> NULL :
 *  Oobt@̃f[^̎o
 *  iԂlj  IOobt@̐擪AhX
 *          G[NULL
 */
static u_long *strNext(DECENV *dec)
{
    u_long      *addr;
    StHEADER    *sector;
    int     cnt = WAIT_TIME;
    
    /* get the 1 frame streaming data withe TIME-OUT :    
       f[^oi^CAEgtj
       Xg[~O̎ StGetNextS()pĎo */
    if(dec->onmem)
      while(StGetNextS((u_long **)&addr,(u_long **)&sector)) {
        if (--cnt == 0)
	  return(0);
      }
    else
      while(StGetNext((u_long **)&addr,(u_long **)&sector)) {
        if (--cnt == 0)
	  return(0);
      }

    /* if the frame number greater than the end frame, set the end switch :    
       ݂̃t[ԍwlȂI  */
    if(sector->frameCount >= END_FRAME) {
        Rewind_Switch = 1;
    }
    
    /* if the resolution is differ to previous frame, clear frame buffer :    
       ʂ̉𑜓x Õt[ƈႤȂ ClearImage s */
    if(StrWidth != sector->width || StrHeight != sector->height) {
        
        RECT    rect;
        setRECT(&rect, 0, 0, SCR_WIDTH * PPW, SCR_HEIGHT*2);
        ClearImage(&rect, 0, 0, 0);
        
        StrWidth  = sector->width;
        StrHeight = sector->height;
    }
    
    /* set DECENV according to the data on the STR format :    
       STRtH[}bg̃wb_ɍ킹ăfR[hύX */
    dec->rect[0].w = dec->rect[1].w = StrWidth*PPW;
    dec->rect[0].h = dec->rect[1].h = StrHeight;
    dec->slice.h   = StrHeight;
    
    return(addr);
}


/*
 *  wait for finish decodeing 1 frame with TIME-OUT :  
 *  Pt[̃fR[hI҂
 *  ԂĎă^CAEg`FbN
 */
static void strSync(DECENV *dec, int mode /* VOID */)
{
    volatile u_long cnt = WAIT_TIME;

    /* wait for the decod is done flag set by background process :
       obNOEhvZXisdone𗧂Ă܂ő҂ */
    while (dec->isdone == 0) {
        if (--cnt == 0) {
            /* if timeout force to switch buffer : Iɐؑւ */	  
            printf("time out in decoding !\n");
            dec->isdone = 1;
            dec->rectid = dec->rectid? 0: 1;
            dec->slice.x = dec->rect[dec->rectid].x;
            dec->slice.y = dec->rect[dec->rectid].y;
        }
    }
    dec->isdone = 0;
}


/*
 *  start streaming :
 *  CDROMwʒuXg[~OJn
 */
static void strKickCD(CdlLOC *loc)
{
  u_char param;

  param = CdlModeSpeed;
  
 loop:
  /* seek to the destination : ړIn܂ Seek  */
  while (CdControl(CdlSetloc, (u_char *)loc, 0) == 0);
  while (CdControl(CdlSetmode, &param, 0) == 0);
  VSync(3);  /* wait for 3 VSync when changing the speed :
		{ɐ؂ւĂ RV҂Kv */
    /* out the read command with streaming mode :
       Xg[~O[hǉăR}hs */
  if(CdRead2(CdlModeStream|CdlModeSpeed|CdlModeRT) == 0)
    goto loop;
}
