/*
 * $PSLibId: Runtime Library Release 3.6$
 */
/*
 *	BG`Tv
 *		(GsSortFixBG32()gp)
 *
 *		Version 1.00	Mar, 7, 1995
 *
 *		Copyright (C) 1995 by Sony Computer Entertainment
 *			All rights Reserved
 */

#include	<sys/types.h>
#include	<libetc.h>
#include	<libgte.h>
#include	<libgpu.h>
#include	<libgs.h>

/* GPU Info. */
#define	OT_LENGTH 4
GsOT WorldOT[2];
GsOT_TAG OTTags[2][1<<OT_LENGTH];

/* eNX`ip^[j */
#define TEX_ADDR 0x80180000	/* eNX`擪AhX */
#define	TIM_HEADER 0x00000010	/* TIMwb_̒l */
GsIMAGE TimInfo;

/*
 *  BG
 */
#define N_BG 8			/* pӂBG̖ */
GsBG	BGData[N_BG];		/* BG */
GsMAP	BGMap[N_BG];		/* }bv */
#define CEL_ADDR  0x80140000	/* Zf[^擪AhXieʋʁj */

/* GsSortFixBg32()̂߂̍Ɨ̈̊mہiWʕj */
#define BGWSIZE (((320/32+1)*(240/32+1+1)*6+4)*2+2)
u_long BGPacket[BGWSIZE*N_BG];

/* eʂ̍Ɨ̈ւ̃|C^ */
u_long *BGWork[N_BG];

/* 4ʕ̃}bvf[^(BGDt@C) */
#define BGD0_ADDR 0x80100000	/* }bv#0擪AhX */
#define BGD1_ADDR 0x80101000	/* }bv#1擪AhX */
#define BGD2_ADDR 0x80102000	/* }bv#2擪AhX */
#define BGD3_ADDR 0x80103000	/* }bv#3擪AhX */
unsigned long *BgdAddr[N_BG] = {
	(unsigned long *)BGD0_ADDR,
	(unsigned long *)BGD1_ADDR,
	(unsigned long *)BGD2_ADDR,
	(unsigned long *)BGD3_ADDR
};

/* BG̊eʂǂ̃}bvg̃e[u */
int MapIndex[8] = {
	0, 1, 2, 3, 1, 2, 3, 1	
};
int NumBG;			/* \BGʐ */

/*
 *  ̑...
 */
u_long PadData;			/* Rg[pbhf[^ */
u_long OldPad;			/* Õt[̃f[^ */

/*
 *  C[`
 */
main(void)
{
	/* VXȅ */
	ResetCallback();
	initSystem();

	/* ̑̏ */
	PadData = 0;
	NumBG = 1;
	initTexture();
	initBG();
	GsInitVcount();

	while(1) {
		if(moveBG()) break;
		drawAll();
	}

	PadStop();
	ResetGraph(3);
	StopCallback();
	return 0;
}

/*
 *  `
 */
drawAll()
{
	int activeBuff;
	int i;
	
	/* _uobt@̂ǂ炪ANeBu𓾂 */
	activeBuff = GsGetActiveBuff();

	/* OT̃NA */
	GsClearOt(0, 0, &WorldOT[activeBuff]);

	/* BG̕` */
	for(i = 0; i < NumBG; i++) {	
		GsSortFixBg32(BGData+i, BGWork[i], &WorldOT[activeBuff], N_BG-i);
	}

	/* pbh̓ǂݍ */
	OldPad = PadData;
	PadData = PadRead(1);

	/* V-Sync  */
	VSync(0);

	ResetGraph(1);
	GsSwapDispBuff();

	GsSortClear(0, 0, 0, &WorldOT[activeBuff]);
	GsDrawOt(&WorldOT[activeBuff]);
}

/*
 *  af𓮂
 */
moveBG()
{
	int i;

	/*  = BG\炷 */
	if(((PadData&PADLup)>0)&&
		((OldPad&PADLup)==0)&&
		(NumBG < N_BG)) NumBG++;

	/*  = BG\炷 */
	if(((PadData&PADLdown)>0)&&
		((OldPad&PADLdown)==0)&&
		(NumBG > 1)) NumBG--;

	/* BG\ʒu */
	BGData[0].scrolly += 1;
	BGData[1].scrollx -= 1;
	BGData[1].scrolly -= 1;
	BGData[3].scrollx += 1;
	BGData[4].scrollx -= 1;
	BGData[4].scrolly += 2;
	BGData[5].scrollx += 2;
	BGData[6].scrolly -= 1;

	/* K{^ŏI */
	if((PadData & PADk)>0) return -1;

	return 0;
}

/*
 *  CjVCY
 */
initSystem()
{
	int i;
		
	/* pbh̏ */
	PadInit(0);
	
	/* GPȔ */
	GsInitGraph(320,240,0,0,0);
	GsDefDispBuff(0,0,0,240);

	/* OT̈̏ */
	WorldOT[0].length=OT_LENGTH;
	WorldOT[0].org=OTTags[0];
	WorldOT[1].length=OT_LENGTH;
	WorldOT[1].org=OTTags[1];
	
	/* 3D̏ */
	GsInit3D();
}

/*
 *  Zp^[(Texture pattern)̓ǂݍ
 *  i炩߃ɒuꂽTIMf[^VRAM֓]j
 */
initTexture()
{
	RECT rect;
	u_long *timP;
	int i;

	/* TIMf[^̐擪AhX */	
	timP = (u_long *)TEX_ADDR;

	/* wb_ǂ݂Ƃ΂ */
	timP++;

	/* TIMf[^̈ʒu𓾂 */
	GsGetTimInfo( timP, &TimInfo );

	/* PIXELf[^VRAM֓] */
	timP += TimInfo.pw * TimInfo.ph/2+3+1;
	LoadImage((RECT *)&TimInfo.px, TimInfo.pixel);
		
	/* CLUTVRAM֓] */
	if((TimInfo.pmode>>3)&0x01) {
		LoadImage( (RECT *)&TimInfo.cx, TimInfo.clut );
		timP += TimInfo.cw*TimInfo.ch/2+3;
	}
}

/*
 *  BG̏
 */
initBG()
{
	int i;
	GsCELL *cellP;
        u_char *cel;
        u_char *bgd;
	int ncell;

	/* CELf[^Z𓾂 */
        cel = (u_char *)CEL_ADDR;        
	cel += 4;
	ncell = *(u_short *)cel;	
	cel += 4;

	/* BG̊eʂ̃}bvBG\̂ */
	for(i = 0; i < N_BG; i++) {

		/* BGDf[^}bv𓾂 */
	       	bgd = (u_char *)BgdAddr[MapIndex[i]];
		bgd += 4;

		BGMap[i].ncellw = *bgd++;		/* MAP̑傫 */
		BGMap[i].ncellh = *bgd++;
		BGMap[i].cellw = *bgd++;		/* Z̑傫 */
		BGMap[i].cellh = *bgd++;
		BGMap[i].index = (unsigned short *)bgd; /* }bv{ */
		BGMap[i].base = (GsCELL *)cel;		/* Zzւ̃|C^ */
		
		/* Ɨ̈(PrimitiveGA)̊mہ */
		BGWork[i] = BGPacket+i*BGWSIZE;
		GsInitFixBg32(&BGData[i], BGWork[i]);

		/* ̑(attribute) */
		BGData[i].attribute = (0<<24)|GsROTOFF;
		BGData[i].scrollx = BGData[i].scrolly = 0;
		BGData[i].r = BGData[i].g = BGData[i].b = 128;
		BGData[i].map = &(BGMap[i]);
	}
}
