/* $PSLibId: Runtime Library Release 3.6$ */
/*				Fast balls
 *
 *		ʓoEh镡̃{[`悷
 *
 *		Copyright (C) 1993 by Sony Corporation
 *			All rights Reserved
 */

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>

/*
 * definition for speed up: ̂߂̒` 
 */
#define FASTVBLNK	/* shorten VBLNK: VBLNK Z */
#define SMALLDRAWAREA	/* decrease drawing: `炷 */
#define OTENV		/* do PutDrawEnv and DrawOTag at the same time
			   : PutDrawEnv  DrawOTag 𓯎ɍs */

/*
 * Kaji Printf: vg邽߂̒`
 */
#define KANJI

/*#define DEBUG */
/*
 * Primitive Buffer: v~eBu֘Ãobt@
 */
#define OTSIZE		1		/* size of ordering table
					   : I[_Oe[u̐ */
#define MAXOBJ		4000		/* max sprite number :
					   XvCgi{[j̏ */
typedef struct {
	DRAWENV		draw;		/* drawing environment : ` */
	DISPENV		disp;		/* display environment : \ */
	u_long		ot[OTSIZE];	/* ordering table:
					   : I[_Oe[u */
	SPRT_16		sprt[MAXOBJ];	/* 16x16 fixed-size sprite:
					   16x16ŒTCỸXvCg */
} DB;

/*
 * Position Buffer: XvCg̓Ɋւobt@
 */
typedef struct {
	u_short x, y;			/* current point: ݂̈ʒu */
	u_short dx, dy;			/* verocity: x */
} POS;

/*
 * \̈
 */
#define	FRAME_X		640		/* frame size:\̈TCY(320x240)*/
#define	FRAME_Y		480
#define WALL_X		(FRAME_X-16)	/* reflection point
					   : XvCg̉̈TCY */
#define WALL_Y		(FRAME_Y-16)

/* preset unchanged primitve members: v~eBuobt@̏ݒ */
static void init_prim(DB *db);	

/* parse controller: Rg[̉ */
static int  pad_read(int n);	

/* callback for VSync: V-Sync̃R[obN[` */
static void  cbvsync(void);	

/* intitialze position table : {[̃X^[gʒuƈړ̐ݒ */
static int  init_point(POS *pos);

main()
{
	/* {[̍Wlƈړi[obt@ */
	POS	pos[MAXOBJ];	
	
	/* double buffer: _uobt@̂߂Qpӂ */
	DB	db[2];		
	
	/* current double buffer: ݂̃_uobt@obt@̃AhX */
	DB	*cdb;		

	/* object number: \XvCg̐iŏ͂Pj*/
	int	nobj = 1;	
	
	/* current OT: ݂̂ns̃AhX */
	u_long	*ot;		
	
	SPRT_16	*sp;		/* work */
	POS	*pp;		/* work */
	int	i, cnt, x, y;	/* work */

	/* reset PAD: Rg[̃Zbg */
	PadInit(0);		
	
	/* reset graphics sysmtem (0:cold,1:warm); `E\̃Zbg */
	ResetGraph(0);		
	
	/* set debug mode (0:off,1:monitor,2:dump): fobO[h̐ݒ */
	SetGraphDebug(0);	
	
	/* set callback: V-sync̃R[obN֐̐ݒ */
	VSyncCallback(cbvsync);	

	/* inititlalize environment for double buffer
	: `E\_uobt@pɐݒ
	(0,  0)-(320,240)ɕ`悵ĂƂ(0,240)-(320,480)\(db[0])
	(0,240)-(320,480)ɕ`悵ĂƂ(0,  0)-(320,240)\(db[1])
	*/
#ifdef SMALLDRAWAREA
	{
		RECT rect;

		setRECT(&rect, 0, 0, 640, 512);
		ClearImage(&rect, 0, 0, 0);
	}
	SetDefDrawEnv(&db[0].draw, 0, 0, 640, 464);
	SetDefDrawEnv(&db[1].draw, 0, 0, 640, 464);
#else /* SMALLDRAWAREA */
	SetDefDrawEnv(&db[0].draw, 0, 0, 640, 480);
	SetDefDrawEnv(&db[1].draw, 0, 0, 640, 480);
#endif /* SMALLDRAWAREA */
	SetDefDispEnv(&db[0].disp, 0, 0, 640, 480);
	SetDefDispEnv(&db[1].disp, 0, 0, 640, 480);
#ifdef FASTVBLNK
	db[0].disp.screen.h = 242;
	db[1].disp.screen.h = 242;
#endif /* FASTVBLNK */

	/* init font environment; tHg̐ݒ */
#ifdef KANJI	/* KANJI */
	KanjiFntOpen(160, 16, 256, 200, 704, 0, 768, 256, 0, 512);
#endif	
	/* :{tHgp^[t[obt@Ƀ[h */
	FntLoad(960, 256);	
	
	/* :tHg̕\ʒu̐ݒ */
	SetDumpFnt(FntOpen(16, 16, 256, 200, 0, 512));	

	/* initialize primitive buffer: v~eBuobt@̏ݒ(db[0])*/
	init_prim(&db[0]);	
	
	/* initialize primitive buffer: v~eBuobt@̏ݒ(db[1])*/
	init_prim(&db[1]);	
	
	/* set initial geometries: {[̓Ɋւ鏉ݒ */
	init_point(pos);	

	/* enable to display: fBXvCւ̕\Jn */
	SetDispMask(1);		/* 0:inhibit,1:enable: OFs  PF */

	/* ; C[v */
	while ((nobj = pad_read(nobj)) > 0) {
		/* swap double buffer ID: _uobt@|C^̐؂ւ */
		cdb  = (cdb==db)? db+1: db;	
#ifdef DEBUG
		/* dump DB environment */
		DumpDrawEnv(&cdb->draw);
		DumpDispEnv(&cdb->disp);
		DumpTPage(cdb->draw.tpage);
#endif

 		/* clear ordering table: I[_Oe[ũNA */
		ClearOTag(cdb->ot, OTSIZE);

		/* update sprites :
		   {[̈ʒuPvZĂnsɓo^Ă */
		ot = cdb->ot;
		sp = cdb->sprt;
		pp = pos;
		for (i = 0; i < nobj; i++, sp++, pp++) {
			/* detect reflection:
			   Wl̍XVщʏł̈ʒǔvZ */
			if ((x = (pp->x += pp->dx) % WALL_X*2) >= WALL_X)
				x = WALL_X*2 - x;
			if ((y = (pp->y += pp->dy) % WALL_Y*2) >= WALL_Y)
				y = WALL_Y*2 - y;

			/* update vertex: vZWlZbg */
			setXY0(sp, x, y);	
			
			/* apend to OT: ns֓o^ */
			AddPrim(ot, sp);	
		}
		/* wait for end of drawing: `̏I҂ */
		DrawSync(0);		
		
		/* cnt = VSync(1);	/* check for count */
		/* cnt = VSync(2);	/* wait for V-BLNK (1/30) */
		cnt = VSync(0);		/* wait for V-BLNK (1/60) */

		/*: _uobt@̐ؑւ */
		/* update display environment: \̍XV */
		PutDispEnv(&cdb->disp); 
		
		/* update drawing environment: `̍XV */
#ifdef OTENV
		DrawOTagEnv(cdb->ot, &cdb->draw); 
#else /* OTENV */
		PutDrawEnv(&cdb->draw); 
		
		/*: nsɓo^ꂽv~eBu̕` */
		DrawOTag(cdb->ot);	
#endif /* OTENV */
#ifdef DEBUG
		DumpOTag(cdb->ot);
#endif
		/*: {[̐ƌoߎԂ̃vg */
#ifdef KANJI
		KanjiFntPrint("ʂ̐%d\n", nobj);
		KanjiFntPrint("=%d\n", cnt);
		KanjiFntFlush(-1);
#endif
		FntPrint("sprite = %d\n", nobj);
		FntPrint("total time = %d\n", cnt);
		FntFlush(-1);
	}
	PadStop();	/*: Rg[̃N[Y */
	StopCallback();
	return(0);
}

/*
 * Initialize drawing Primitives: v~eBuobt@̏ݒ
 */
#include "balltex.h"	/* {[̃eNX`p^[Ăt@C */

/* DB *db; v~eBuobt@*/
static void init_prim(DB *db)
{
	u_short	clut[32];		/* CLUT entry: eNX` CLUT */
	SPRT_16	*sp;			/* work */
	int	i;			/* work */

	/* set bg color: wiF̃Zbg */
	db->draw.isbg = 1;
	setRGB0(&db->draw, 60, 120, 120);

	/* load texture pattern: eNX`̃[h */
	db->draw.tpage = LoadTPage(ball16x16, 0, 0, 640, 0, 16, 16);
#ifdef DEBUG
	DumpTPage(db->draw.tpage);
#endif
	/* load texture CLUT: eNX` CLUT̃[h */
	for (i = 0; i < 32; i++) {
		clut[i] = LoadClut(ballcolor[i], 640, 480+i);
#ifdef DEBUG
		DumpClut(clut[i]);
#endif
	}

	/* initialize sprite: XvCg̏ */
	for (sp = db->sprt, i = 0; i < MAXOBJ; i++, sp++) {
		/* set SPRT_16: 16x16XvCgv~eBȕ */
		SetSprt16(sp);		
		
		/* semi-ambient is ON:  ONt */
		SetSemiTrans(sp, 1);	
		
		/* shaded texture is OFF: VF[fBOsȂ */
		SetShadeTex(sp, 1);	
		
		/* texture point is (0,0): u,v(0,0)ɐݒ */
		setUV0(sp, 0, 0);	
		
		/* set CLUT: CLUT ̃Zbg */
		sp->clut = clut[i%32];	
	}
}

/*
 * Initialize sprite position and verocity:
 : {[̃X^[gʒuƈړʂݒ肷
 */

/* POS	*pos;		{[̓Ɋւ\ */
static init_point(POS *pos)	
{
	int	i;
	for (i = 0; i < MAXOBJ; i++) {
		pos->x  = rand();		/*: X^[gW w */
		pos->y  = rand();		/*: X^[gW x */
		pos->dx = (rand() % 4) + 1;	/*: ړ w (1<=x<=4) */
		pos->dy = (rand() % 4) + 1;	/*: ړ x (1<=y<=4) */
		pos++;
	}
}

/*
 * Read controll-pad: Rg[̉
 */
/* int n; XvCg̐ */
static int pad_read(int	n)		
{
	u_long	padd = PadRead(1);		/*: Rg[̓ǂݍ */

	if(padd & PADLup)	n += 4;		/*: ̏\L[Abv */
	if(padd & PADLdown)	n -= 4;		/*: ̏\L[_E */

	if (padd & PADL1) 			/*: pause */
		while (PadRead(1)&PADL1);

	if(padd & PADselect) 	return(-1);	/*: vȌI */

	limitRange(n, 1, MAXOBJ-1);	/*: n1<=n<=(MAXOBJ-1)̒lɂ */
					/* see libgpu.h: libgpu.hɋL */
	return(n);
}

/*
 * callback: R[obN
 */
static void cbvsync(void)
{
	/* print absolute VSync count */
	FntPrint("V-BLNK(%d)\n", VSync(-1));	
}


