/* $PSLibId: Runtime Library Release 3.6$ */
/***********************************************
 *	preset.c
 *
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.
 *		All Rights Reserved.
 ***********************************************/
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include "model.h"
#include "preset.h"

/* preset euler angles/translation :*/
/* IC[pƃgX[ṼvZbgl*/
#define BODYLEN (3*384/2)
#define LEGLEN (128*3)
#define ARMLEN (100*3)

PRESET preset[][MIMENUM+1][PARTNUM]={
    {
	{						/* Base */
	    {{  1024,     0,     0}, {     0,     0,     0}},
	    {{  2048,   -50,     0}, {  -100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  2048,    50,     0}, {   100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  2048,   200,     0}, {   180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{  2048,  -200,     0}, {  -180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{     0,     0,     0}, {     0,     0,   626}},
	},
	{					/* MIMe1 */
	    {{  1024,     0,  -250}, {     0,     0,     0}},
	    {{  1928,  -260,     0}, {  -100,     0,     0}},
	    {{   370,     0,     0}, {     0,     0,   384}},
	    {{  1828,   210,     0}, {   100,     0,     0}},
	    {{   360,     0,     0}, {     0,     0,   384}},
	    {{  2008,   540,   -10}, {   180,     0,   576}},
	    {{   200,  -600,     0}, {     0,     0,   300}},
	    {{  2048,  -470,     0}, {  -180,     0,   576}},
	    {{   140,  -310,   100}, {     0,     0,   300}},
	    {{     0,     0,     0}, {     0,     0,   626}},
	},
	{						/* MIMe2 */
	    {{  1044,     0,   -30}, {     0,     0,     0}},
	    {{ -1998,   -10,     0}, {  -100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  2048,   420,     0}, {   100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  2048,   360,     0}, {   180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{  2048,  -440,     0}, {  -180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{   -50,   160,    30}, {     0,     0,   626}},
	},
	{					/* MIMe3 */
	    {{  -956, -2036, -1970}, {     0,     0,     0}},
	    {{  1478,   -50,     0}, {  -100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{ -1778,    50,     0}, {   100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  1738,   200,     0}, {   180,     0,   576}},
	    {{  -630,     0,     0}, {     0,     0,   300}},
	    {{ -1628,  -260,     0}, {  -180,     0,   576}},
	    {{  -900,  -210,   190}, {     0,     0,   300}},
	    {{     0,     0,     0}, {     0,   -20,   726}},
	},
	{						/* MIMe4 */
	    {{  1054,    90,   100}, {   -20,     0,     0}},
	    {{  1938, -1280,   110}, {  -100,     0,     0}},
	    {{     0,   -10,     0}, {     0,     0,   384}},
	    {{  1968,   100,     0}, {   100,     0,     0}},
	    {{   110,    50,     0}, {     0,     0,   384}},
	    {{  2048,   510,     0}, {   180,     0,   576}},
	    {{     0,  -680,     0}, {     0,     0,   300}},
	    {{  1808,  -650,     0}, {  -180,     0,   576}},
	    {{     0,  -390,     0}, {     0,     0,   300}},
	    {{     0,   250,     0}, {     0,     0,   626}},
	},
    },
    {
	{						/* BASE */
	    {{  1024,     0,  -240}, {     0,     0,     0}},
	    {{  2048,   -50,     0}, {  -100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  2048,    50,     0}, {   100,     0,     0}},
	    {{     0,     0,     0}, {     0,     0,   384}},
	    {{  2048,   200,     0}, {   180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{  2048,  -200,     0}, {  -180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{     0,     0,     0}, {     0,     0,   626}},
	},
	{					/* MIMe1 */
	    {{  1024,     0,  -240}, {     0,    20,     0}},
	    {{  1758,    50,     0}, {  -100,     0,     0}},
	    {{  1330,     0,     0}, {     0,     0,   384}},
	    {{  1848,    50,     0}, {   100,     0,     0}},
	    {{   210,     0,     0}, {     0,     0,   384}},
	    {{  1938,   200,     0}, {   180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{  1918,  -200,     0}, {  -180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{     0,     0,     0}, {     0,     0,   626}},
	},
	{						/* MIMe2 */
	    {{  1024,     0,  -240}, {     0,    20,     0}},
	    {{  2028,   -50,     0}, {  -100,     0,     0}},
	    {{   190,     0,     0}, {     0,     0,   384}},
	    {{  1908,    50,     0}, {   100,     0,     0}},
	    {{  1140,     0,     0}, {     0,     0,   384}},
	    {{  1908,   200,    40}, {   180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{ -1938,  -200,     0}, {  -180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{     0,     0,     0}, {     0,     0,   646}},
	},
	{						/* MIMe3 */
	    {{  1024,     0,  -240}, {     0,  -120, 0}},
	    {{ -1278,   -50,     0}, {  -100,     0,     0}},
	    {{   140,     0,     0}, {     0,     0,   384}},
	    {{  1268,    50,     0}, {   100,     0,     0}},
	    {{   590,     0,     0}, {     0,     0,   384}},
	    {{ -1358,   200,     0}, {   180,     0,   576}},
	    {{  -370,     0,     0}, {     0,     0,   300}},
	    {{  1688,  -200,     0}, {  -180,     0,   576}},
	    {{  -780,     0,     0}, {     0,     0,   300}},
	    {{     0,    30,     0}, {     0,     0,   626}},
	},
	{						/* MIMe4 */
	    {{  1024,     0,  -240}, {     0,  -140, 0}},
	    {{  1428,   -50,     0}, {  -100,     0,     0}},
	    {{   350,     0,     0}, {     0,     0,   384}},
	    {{ -1258,    50,     0}, {   100,     0,     0}},
	    {{   260,     0,     0}, {     0,     0,   384}},
	    {{  1658,   200,    40}, {   180,     0,   576}},
	    {{  -710,     0,     0}, {     0,     0,   300}},
	    {{ -1158,  -200,     0}, {  -180,     0,   576}},
	    {{     0,     0,     0}, {     0,     0,   300}},
	    {{     0,   -70,     0}, {     0,     0,   646}},
	},
    },
    {						/* ㋣Z */
	{					/* BASE */
	    {{1024,0,0,0},	    {0,0,0,0},},
	    {{2048,-50,0,0},	    {-100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,50,0,0},	    {100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,200,0,0},	    {180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{2048,-200,0,0},	    {-180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* MIME1 */
	    {{  1024,     0,     0},     {0,0,0,0},},
	    {{ -1968,  -630,    20},    {-100, 0, 0, 0},},
	    {{     0,   540,     0},    {0,  0,  LEGLEN, 0},},
	    {{  2048,   350,    20},    {100, 0, 0, 0},},
	    {{     0,   800,     0},    {0,  0,  LEGLEN, 0},},
	    {{  2048,   500,  -500},    {180,  0,  BODYLEN, 0},},
	    {{     0,   200,     0},    {0,  0,  ARMLEN, 0},},
	    {{  2048,  -500,   500},    {-180,  0,  BODYLEN, 0},},
	    {{  -930,     0,     0},    {0,  0,  ARMLEN, 0},},
	    {{     0,   580,     0},    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* MIME2 */
	    {{  1174,    10,     0},     {0,0,0, 0},},
	    {{ -2038,   -40,   100},    {-100, 0, 0, 0},},
	    {{   990,   -10,     0},    {0,  0,  LEGLEN, 0},},
	    {{  1718,   190,  -100},    {100, 0, 0, 0},},
	    {{     0,    40,     0},    {0,  0,  LEGLEN, 0},},
	    {{  2048,  1320,     0},    {180,  0,  BODYLEN, 0},},
	    {{     0,     0,    50},    {0,  0,  ARMLEN, 0},},
	    {{  2048, -1210,     0},    {-180,  0,  BODYLEN, 0},},
	    {{     0,     0,     0},    {0,  0,  ARMLEN, 0},},
	    {{     0,  -510,     0},    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* t */
	    {{   994, -2030, -1160}, {  -560,  -460,     0}},
	    {{  2048,  -100,    20}, {  -100,     0,     0}},
	    {{     0,   100,     0}, {     0,     0,LEGLEN}},
	    {{  2048,   100,    20}, {   100,     0,     0}},
	    {{     0,   500,     0}, {     0,     0,LEGLEN}},
	    {{   362,  -100,  -500}, {   180,     0,BODYLEN}},
	    {{     0,   200,     0}, {     0,     0,ARMLEN}},
	    {{  -288,  -130,   500}, {  -180,     0,BODYLEN}},
	    {{  1970,  2016,   -20}, {     0,     0,ARMLEN}},
	    {{     0,     0,     0}, {     0,     0,BODYLEN+50}},
	},
	{					/* K */
	    {{   794,   430,  -800}, {   320,   720,     0}},
	    {{  1058,   -90,   100}, {  -100,     0,     0}},
	    {{   610,     0,     0}, {     0,     0,LEGLEN}},
	    {{  1138,    50,  -100}, {   100,     0,     0}},
	    {{   640,    60,     0}, {     0,     0,LEGLEN}},
	    {{ -1298,   170,     0}, {   180,     0,BODYLEN}},
	    {{     0,     0,    50}, {     0,     0,ARMLEN}},
	    {{ -1218,  -210,     0}, {  -180,     0,BODYLEN}},
	    {{     0,     0,     0}, {     0,     0,ARMLEN}},
	    {{     0,     0,     0}, {     0,     0,BODYLEN+50}},
	},
    },
    {						/* last */
	{					/* BASE */
	    {{1024,0,0,0},        {0,0,0,0},},
	    {{2048,-50,0,0},	    {-100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,50,0,0},	    {100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,200,0,0},	    {180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{2048,-200,0,0},	    {-180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* MIME1 */
	    {{1024,0,0,0},         {0,0,0,0},},
	    {{2048,-50,0,0},	    {-100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,50,0,0},	    {100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,200,0,0},	    {180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{2048,-200,0,0},	    {-180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* MIME2 */
	    {{1024,0,0,0},         {0,0,0,0},},
	    {{2048,-50,0,0},	    {-100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,50,0,0},	    {100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,200,0,0},	    {180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{2048,-200,0,0},	    {-180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* MIME3 */
	    {{1024,0,0,0},         {0,0,0,0},},
	    {{2048,-50,0,0},	    {-100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,50,0,0},	    {100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,200,0,0},	    {180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{2048,-200,0,0},	    {-180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  BODYLEN+50, 0},},
	},
	{					/* MIME4 */
	    {{1024,0,0,0},         {0,0,0,0},},
	    {{2048,-50,0,0},	    {-100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,50,0,0},	    {100, 0, 0, 0},},
	    {{0,0,0,0},		    {0,  0,  LEGLEN, 0},},
	    {{2048,200,0,0},	    {180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{2048,-200,0,0},	    {-180,  0,  BODYLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  ARMLEN, 0},},
	    {{0,0,0,0},		    {0,  0,  BODYLEN+50, 0},},
	},
    },
    {{{-30000}}}, /* end of data */
};
