/* $PSLibId: Runtime Library Release 3.6$ */
/*
 * low_level: GsDOBJ4 object viewing rotine with low_level access 
 *
 * "tuto3.c" ******** simple GsDOBJ4 Viewing routine using GsTMDfast only for
 * gouraud polygon model (mipmap version)
 *
 * Copyright (C) 1996 by Sony Computer Entertainment All rights Reserved 
 */

#include <sys/types.h>

#include <libetc.h>		/* for Control Pad /*
				  PADg߂ɃCN[hKv */
#include <libgte.h>		/* LIBGS uses libgte /*
				  LIGSg߂ɃCN[hKv */
#include <libgpu.h>		/* LIBGS uses libgpu /*
				  LIGSg߂ɃCN[hKv */
#include <libgs.h>		/* for LIBGS /* OtBbNCu g߂
				  \̂Ȃǂ`Ă */

#define PACKETMAX 1000		/* Max GPU packets */

#define OBJECTMAX 100		/* Max Objects /*
	  RD̃f͘_IȃIuWFNg 邱̍ő吔` */

#define PACKETMAX2 (PACKETMAX*24)	/* size of PACKETMAX (byte) 
										packet size may be 24 byte(6 word) */

#define TEX_ADDR   0x80120000	/* Top Address of texture data1 (TIM FORMAT)
				  /* eNX`f[^iTIMtH[}bgjAhX */

#define TEX_ADDR1   0x80140000	/* Top Address of texture data1 (TIM FORMAT) */
#define TEX_ADDR2   0x80160000	/* Top Address of texture data1 (TIM FORMAT) */


#define MODEL_ADDR 0x80100000	/* Top Address of modeling data (TMD FORMAT)
				  /* fOf[^iTMDtH[}bgjAhX */

#define OT_LENGTH  7		/* bit length of OT /*
				  I[_Oe[ủ𑜓x */


GsOT    Wot[2];			/* Handler of OT Uses 2 Hander for Double buffer 
				/* I[_Oe[unh_uobt@̂߂QKv */

GsOT_TAG zsorttable[2][1 << OT_LENGTH];	/* Area of OT /* I[_Oe[u */

GsDOBJ2 object[OBJECTMAX];	/* Array of Object Handler /*
				 IuWFNgnh. IuWFNg̐Kv */

u_long  Objnum;			/* variable of number of Objects /*
				 fOf[^̃IuWFNg̐ێ */


GsCOORDINATE2 DWorld;		/* Coordinate for GsDOBJ2 /*
				 IuWFNgƂ̍Wn */

SVECTOR PWorld;			/* work short vector for making Coordinate parmeter /*
				 * Wn邽߂̃[e[VxN^[ */

extern MATRIX GsIDMATRIX;	/* Unit Matrix /* Pʍs */

GsRVIEW2 view;			/* View Point Handler /* _ݒ肷邽߂̍\ */
GsF_LIGHT pslt[3];		/* Flat Lighting Handler /*
				  sݒ肷邽߂̍\ */
u_long  padd;			/* Controler data /* Rg[̃f[^ێ */

PACKET  out_packet[2][PACKETMAX2];	/* GPU PACKETS AREA */


/************* MAIN START ******************************************/
main()
{
	int     i;
	GsDOBJ2 *op;		/* pointer of Object Handler /*
				  IuWFNgnhւ̃|C^ */
	int     outbuf_idx;	/* double buffer index */
	MATRIX  tmpls, tmplw;
	int     vcount;
	int     p;

	ResetCallback();
	GsInitVcount();

	init_all();
	GsSetFarClip(1000);

	FntLoad(960, 256);
	SetDumpFnt(FntOpen(0, -64, 256, 200, 0, 512));

	while (1) {
		if (obj_interactive() == 0)
			return 0;	/* interactive parameter get /*
					  pbhf[^瓮̃p[^ */
		GsSetRefView2(&view);	/* Calculate World-Screen Matrix /*
					  [hXN[}gbNXvZ */
		outbuf_idx = GsGetActiveBuff();	/* Get double buffer index /*
					  _uobt@̂ǂ炩𓾂 */

		/* Set top address of Packet Area for output of GPU PACKETS */
		GsSetWorkBase((PACKET *) out_packet[outbuf_idx]);

		GsClearOt(0, 0, &Wot[outbuf_idx]);	/* Clear OT for using buffer /*
							  I[_Oe[uNA */

		for (i = 0, op = object; i < Objnum; i++) {
			/* Calculate Local-World Matrix /*
			 [J^[hEXN[}gbNXvZ */
			GsGetLws(op->coord2, &tmplw, &tmpls);

			/* Set LWMATRIX to GTE Lighting Registers /*
			 Cg}gbNXGTEɃZbg */
			GsSetLightMatrix(&tmplw);

			/* Set LSAMTRIX to GTE Registers /*
			 XN[^[J}gbNXGTEɃZbg */
			GsSetLsMatrix(&tmpls);

			/* Perspective Translate Object and Set OT :
			 IuWFNg𓧎ϊI[_Oe[uɓo^ */
			SortTMDobject(op, &Wot[outbuf_idx], 14 - OT_LENGTH);
			op++;
		}

		DrawSync(0);
		VSync(0);	/* Wait VSYNC /* VuN҂ */
		/* ResetGraph(1); */
		padd = PadRead(1);	/* Readint Control Pad data /*
					 pbh̃f[^ǂݍ */
		GsSwapDispBuff();/* Swap double buffer /* _uobt@ؑւ */

		/* Set SCREEN CLESR PACKET to top of OT /*
		 ʂ̃NAI[_Oe[u̍ŏɓo^ */
		GsSortClear(0x0, 0x0, 0x0, &Wot[outbuf_idx]);

		/* Drawing OT /*
		 I[_Oe[uɓo^ĂpPbg̕`Jn */
		GsDrawOt(&Wot[outbuf_idx]);
		FntFlush(-1);
	}
}

obj_interactive()
{
	SVECTOR v1;
	MATRIX  tmp1;

	/* Rotate Y /* IuWFNgY] */
	if ((padd & PADRleft) > 0)
		PWorld.vy -= 5 * ONE / 360;
	/* Rotate Y /* IuWFNgY] */
	if ((padd & PADRright) > 0)
		PWorld.vy += 5 * ONE / 360;
	/* Rotate X /* IuWFNgX] */
	if ((padd & PADRup) > 0)
		PWorld.vx += 5 * ONE / 360;
	/* Rotate X /* IuWFNgX] */
	if ((padd & PADRdown) > 0)
		PWorld.vx -= 5 * ONE / 360;

	/* Translate Z /* IuWFNgZɂē */
	if ((padd & PADm) > 0)
		DWorld.coord.t[2] -= 100;
	/* Translate Z /* IuWFNgZɂē */
	if ((padd & PADl) > 0)
		DWorld.coord.t[2] += 100;
	/* Translate Z /* IuWFNgXɂē */
	if ((padd & PADLleft) > 0)
		DWorld.coord.t[0] += 10;
	/* Translate Z /* IuWFNgXɂē */
	if ((padd & PADLright) > 0)
		DWorld.coord.t[0] -= 10;
	/* Translate Z /* IuWFNgYɂē */
	if ((padd & PADLdown) > 0)
		DWorld.coord.t[1] += 10;
	/* Translate Z /* IuWFNgYɂē */
	if ((padd & PADLup) > 0)
		DWorld.coord.t[1] -= 10;

	/* exit program /* vOIăj^ɖ߂ */
	if ((padd & PADk) > 0) {
		PadStop();
		ResetGraph(3);
		StopCallback();
		return 0;
	}
	/* Set the matrix of Coordinate 2 */
	/* IuWFNg̃p[^}gbNXvZWnɃZbg */
	set_coordinate(&PWorld, &DWorld);
	return 1;
}

/*
 * Initialize routine /* [`Q 
 */
init_all()
{
	GsFOGPARAM  fgp;

	ResetGraph(0);		/* Reset GPU /* GPUZbg */
	PadInit(0);		/* Reset Controller /* Rg[ */
	padd = 0;		/* Controller value initialize /* Rg[l */

	GsInitGraph(640, 480, GsINTER | GsOFSGPU, 1, 0);
	/* resolution set , interlace mode /* 𑜓xݒiC^[[X[hj */

	GsDefDispBuff(0, 0, 0, 0);/* Double buffer setting /* _uobt@w */

#if 0
	GsInitGraph(640, 240, GsINTER | GsOFSGPU, 1, 0);
	/* resolution set , non interlace mode /*
	 𑜓xݒimC^[[X[hj */
	GsDefDispBuff(0, 0, 0, 240); /* Double buffer setting 
						/* _uobt@w */
#endif

	GsInit3D();		/* Init 3D system /* RDVXe */

	Wot[0].length = OT_LENGTH;	/* Set bit length of OT handler /*
					 I[_Oe[unhɉ𑜓xݒ */
	Wot[0].offset = 0x7ff;

	Wot[0].org = zsorttable[0];	/* Set Top address of OT Area to OT handler /*
					 I[_Oe[unhɃI[_Oe[u
					 ̎̐ݒ */

	/* same setting for anoter OT handler /*
	_uobt@̂߂ɂݒ */
	Wot[1].length = OT_LENGTH;
	Wot[1].org = zsorttable[1];

	Wot[1].offset = 0x7ff;

	coord_init();		/* Init coordinate /* W` */
	model_init();		/* Reading modeling data /* fOf[^ǂݍ */
	view_init();		/* Setting view point /* _ݒ */
	light_init();		/* Setting Flat Light /* sݒ */

	texture_init(TEX_ADDR);/* texture load of TEX_ADDR */
	texture_init(TEX_ADDR1);/* texture load of TEX_ADDR1 */
	texture_init(TEX_ADDR2);/* texture load of TEX_ADDR2 */

}


view_init()
{				/* Setting view point /* _ݒ */
	/*---- Set projection,view ----*/
	GsSetProjection(1000);	/* Set projection /* vWFNVݒ */

	/* Setting view point location /* _p[^ݒ */
	view.vpx = 0;
	view.vpy = 0;
	view.vpz = 2000;

	/* Setting focus point location /* _p[^ݒ */
	view.vrx = 0;
	view.vry = 0;
	view.vrz = 0;

	/* Setting bank of SCREEN /* _̔Pp[^ݒ */
	view.rz = 0;

	/* Setting parent of viewing coordinate /* _Wp[^ݒ */
	view.super = WORLD;

	/* Calculate World-Screen Matrix from viewing paramter /*
	 _p[^Q王_ݒ肷郏[hXN[
	 }gbNXvZ */
	GsSetRefView2(&view);

	GsSetNearClip(100);	/* Set Near Clip /* jANbvݒ */

}


light_init()
{				/* init Flat light /* sݒ */

	/* Setting Light ID 0 /* CgIDO ݒ */
	/* Setting direction vector of Light0 /* sp[^ݒ */
	pslt[0].vx = 20;
	pslt[0].vy = -100;
	pslt[0].vz = -100;

	/* Setting color of Light0 /* sFp[^ݒ */
	pslt[0].r = 0xd0;
	pslt[0].g = 0xd0;
	pslt[0].b = 0xd0;

	/* Set Light0 from parameters /* p[^ݒ */
	GsSetFlatLight(0, &pslt[0]);

	/* Setting Light ID 1 /* CgIDP ݒ */
	pslt[1].vx = 20;
	pslt[1].vy = -50;
	pslt[1].vz = 100;
	pslt[1].r = 0x80;
	pslt[1].g = 0x80;
	pslt[1].b = 0x80;
	GsSetFlatLight(1, &pslt[1]);

	/* Setting Light ID 2 /* CgIDQ ݒ */
	pslt[2].vx = -20;
	pslt[2].vy = 20;
	pslt[2].vz = -100;
	pslt[2].r = 0x60;
	pslt[2].g = 0x60;
	pslt[2].b = 0x60;
	GsSetFlatLight(2, &pslt[2]);

	/* Setting Ambient /* ArGgݒ */
	GsSetAmbient(0, 0, 0);

	/* Setting default light mode /* vZ̃ftHg̕ݒ */
	GsSetLightMode(0);
}

coord_init()
{				/* Setting coordinate /* Wnݒ */
	/* Setting hierarchy of Coordinate /* W̒` */
	GsInitCoordinate2(WORLD, &DWorld);

	/* Init work vector 
	/* }gbNXvZ[Ñ[e[VxN^[ */
	PWorld.vx = PWorld.vy = PWorld.vz = 0;

	/* the org point of DWold is set to Z = -40000 /*
	 IuWFNǧ_[hZ = -4000ɐݒ */
	DWorld.coord.t[2] = -4000;
}


/* Set coordinte parameter from work vector /*
 [eVxN^}gbNX쐬WnɃZbg */
set_coordinate(pos, coor)
	SVECTOR *pos;		/* work vector /* [eVxN^ */
	GsCOORDINATE2 *coor;	/* Coordinate /* Wn */
{
	MATRIX  tmp1;

	/* Set translation /* sړZbg */
	tmp1.t[0] = coor->coord.t[0];
	tmp1.t[1] = coor->coord.t[1];
	tmp1.t[2] = coor->coord.t[2];

	/* Rotate Matrix /* }gbNXɃ[e[VxN^p */
	RotMatrix(pos, &tmp1);

	/* Set Matrix to Coordinate /* ߂}gbNXWnɃZbg */
	coor->coord = tmp1;

	/* Clear flag becase of changing parameter /*
	 }gbNXLbVtbV */
	coor->flg = 0;
}

/* Load texture to VRAM /* eNX`f[^VRAMɃ[h */
texture_init(addr)
	u_long  addr;
{
	RECT    rect1;
	GsIMAGE tim1;

	/* Get texture information of TIM FORMAT /*
	 TIMf[^̃wb_eNX`̃f[^^Cv̏𓾂 */
	GsGetTimInfo((u_long *) (addr + 4), &tim1);

	rect1.x = tim1.px;	/* X point of image data on VRAM /* 
				 eNX`VRAMłXW */
	rect1.y = tim1.py;	/* Y point of image data on VRAM /* 
				 eNX`VRAMłYW */
	rect1.w = tim1.pw;	/* Width of image /* eNX` */
	rect1.h = tim1.ph;	/* Height of image /* eNX` */

	/* Load texture to VRAM /* VRAMɃeNX`[h */
	LoadImage(&rect1, tim1.pixel);

	/* Exist Color Lookup Table /* J[bNAbve[u݂ */
	if ((tim1.pmode >> 3) & 0x01) {
		rect1.x = tim1.cx;	/* X point of CLUT data on VRAM /*
					 NbgVRAMłXW */
		rect1.y = tim1.cy;	/* Y point of CLUT data on VRAM /*
					 NbgVRAMłYW */
		rect1.w = tim1.cw;	/* Width of CLUT /* Nbg̕ */
		rect1.h = tim1.ch;	/* Height of CLUT /* Nbg̍ */

		/* Load CULT data to VRAM /* VRAMɃNbg[h */
		LoadImage(&rect1, tim1.clut);
	}
}


/* Read modeling data (TMD FORMAT) /* fOf[^̓ǂݍ */
model_init()
{
	u_long *dop;
	GsDOBJ2 *objp;		/* handler of object /* fOf[^nh */
	int     i;

	dop = (u_long *) MODEL_ADDR;	/* Top Address of MODELING DATA(TMD FORMAT)
					/* fOf[^i[ĂAhX */
					
	dop++;			/* hedder skip */

	GsMapModelingData(dop);	/* Mapping real address /*
				 fOf[^iTMDtH[}bgjAhXɃ}bv */

	dop++;
	Objnum = *dop;		/* Get number of Objects /*
				 IuWFNgTMD̃wb_瓾 */

	dop++;			/* Adjusting for GsLinkObject4 /*
				 GsLinkObject4ŃN邽߂TMD̃IuWFNg
				 ̐擪ɂĂ */

	/* Link ObjectHandler and TMD FORMAT MODELING DATA /*
	 TMDf[^ƃIuWFNgnhڑ */
	for (i = 0; i < Objnum; i++)
		GsLinkObject4((u_long) dop, &object[i], i);

	for (i = 0, objp = object; i < Objnum; i++) {
		/* Set Coordinate of Object Handler /*
		 ftHg̃IuWFNg̍Wn̐ݒ */
		objp->coord2 = &DWorld;
		objp->attribute = 0;	/* Normal Light */
		objp++;
	}
}

extern PACKET *FastG4L();	/* see g4l.c */
extern PACKET *FastTG4Lmip(); /* see tg4lmip.c */

/************************* SAMPLE for GsTMDobject *****************/
SortTMDobject(objp, otp, shift)
	GsDOBJ2 *objp;
	GsOT   *otp;
	int     shift;
{
	u_long *vertop, *nortop, *primtop, primn;
	int     code;		/* polygon type */
	int		light_mode;

	/* get various informations from TMD foramt */
	vertop = ((struct TMD_STRUCT *) (objp->tmd))->vertop;
	nortop = ((struct TMD_STRUCT *) (objp->tmd))->nortop;
	primtop = ((struct TMD_STRUCT *) (objp->tmd))->primtop;
	primn = ((struct TMD_STRUCT *) (objp->tmd))->primn;

	/* attribute decoding */
	/* GsMATE_C=objp->attribute&0x07; not use */
	GsLMODE = (objp->attribute >> 3) & 0x03;
	GsLIGNR = (objp->attribute >> 5) & 0x01;
	GsLIOFF = (objp->attribute >> 6) & 0x01;
	GsNDIV = (objp->attribute >> 9) & 0x07;
	GsTON = (objp->attribute >> 30) & 0x01;

	if(GsLIOFF == 1)
		light_mode = GsLMODE_LOFF;
	else
		if((GsLIGNR == 0 && GsLIGHT_MODE == 1) ||
			(GsLIGNR == 1 && GsLMODE == 1))
			light_mode = GsLMODE_FOG;
		else
			light_mode = GsLMODE_NORMAL;

	/* primn > 0 then loop (making packets) */
	while (primn) {
		code = ((*primtop) >> 24 & 0xfd);	/* pure polygon type */
		switch (code) {
			case GPU_COM_G4:
				GsOUT_PACKET_P = (PACKET *) FastG4L
					((TMD_P_G4 *)primtop,(VERT *)vertop,(VERT *)nortop,
					GsOUT_PACKET_P,*((u_short *) primtop),shift,otp);
				primn -= *((u_short *) primtop);
				primtop += sizeof(TMD_P_G4)/4 * *((u_short *)primtop);
				break;
			case GPU_COM_TG4:	
				GsOUT_PACKET_P = (PACKET *) FastTG4Lmip
					((TMD_P_TG4 *)primtop,(VERT *)vertop,(VERT *)nortop,
					GsOUT_PACKET_P,*((u_short *) primtop),shift,otp);
				primn -= *((u_short *) primtop);
				primtop += sizeof(TMD_P_TG4)/4 * *((u_short *)primtop);
				break;
			default:
				printf("This program supports only gouraud polygon.\n");
				printf("<%x,%x,%x>\n", code, GPU_COM_G4, GPU_COM_TG4);
				break;
		}
	}
}
