/* $PSLibId: Runtime Library Release 3.6$ */
/*
 *	PMD VIEWING ROUTINE
 *
 *
 *		Version 1.00	Jul,  26, 1994
 *
 *		Copyright (C) 1994  Sony Computer Entertainment
 *		All rights Reserved
 */

#include <sys/types.h>

#include <libetc.h>		/* for Control Pad :
				   PADg߂ɃCN[hKv */
#include <libgte.h>		/* LIBGS uses libgte :
				   LIGSg߂ɃCN[hKv*/
#include <libgpu.h>		/* LIBGS uses libgpu :
				   LIGSg߂ɃCN[hKv */
#include <libgs.h>		/* for LIBGS :
				   OtBbNCu g߂
				   \̂Ȃǂ`Ă */


#define OBJECTMAX 100		/* Max Objects :
				   RD̃f͘_IȃIuWFNg
                                   邱̍ő吔 ` */

#define TEX_ADDR   0xa0010000	/* Top Address of texture data1 (TIM FORMAT) :
				   eNX`f[^iTIMtH[}bgj
				   AhX */

#define TIM_HEADER 0x00000010

#define MODEL_ADDR 0xa0040000	/* Top Address of modeling data (TMD FORMAT) :
				   fOf[^iTMDtH[}bgj
				   AhX */

#define OT_LENGTH  10		/* bit length of OT :
				   I[_Oe[ủ𑜓x */


GsOT            Wot[2];		/* Handler of OT
                                   Uses 2 Hander for Dowble buffer :
				   I[_Oe[unh
				   _uobt@̂߂QKv */

GsOT_TAG	zsorttable[2][1<<OT_LENGTH]; /* Area of OT:
						I[_Oe[u */

GsDOBJ3		object[OBJECTMAX]; /* Array of Object Handler :
				      IuWFNgnh
				      IuWFNg̐Kv */

u_long          Objnum;		/* valibable of number of Objects :
				   fOf[^̃IuWFNg̐
				   ێ */

/* object coordinate : IuWFNgWn */
GsCOORDINATE2   DWorld;


SVECTOR         PWorld; /* work short vector for making Coordinate parmeter :
			   Wn邽߂̃[e[VxN^[ */

extern MATRIX GsIDMATRIX;	/* Unit Matrix : Pʍs */

GsRVIEW2  view;			/* View Point Handler :
				   _ݒ肷邽߂̍\ */
GsF_LIGHT pslt[3];		/* Flat Lighting Handler :
				   sݒ肷邽߂̍\ */
u_long padd;			/* Controler data :
				   Rg[̃f[^ێ */

/************* MAIN START ******************************************/
main()
{
  int     i;
  GsDOBJ3 *op;			/* pointer of Object Handler :
				   IuWFNgnhւ̃|C^ */
  int     outbuf_idx;		/* double buffer index */
  MATRIX  tmpls;
  
  ResetCallback();
  init_all();
  
  while(1)
    {
      if(obj_interactive()==0)
          return 0;	/* interactive parameter get :
			   pbhf[^瓮̃p[^ */
      GsSetRefView2(&view);	/* Calculate World-Screen Matrix :
				   [hXN[}gbNXvZ */
      outbuf_idx=GsGetActiveBuff();/* Get double buffer index :
				      _uobt@̂ǂ炩𓾂 */

      GsClearOt(0,0,&Wot[outbuf_idx]); /* Clear OT for using buffer :
					  I[_Oe[uNA */

      for(i=0,op=object;i<Objnum;i++)
	{
	  /* Calculate Local-World Matrix :
	     [h^[J}gbNXvZ */
	  GsGetLw(op->coord2,&tmpls);
	  
	  /* Set LWMATRIX to GTE Lighting Registers :
	     Cg}gbNXGTEɃZbg */
	  GsSetLightMatrix(&tmpls);
	  
	  /* Calculate Local-Screen Matrix :
	     XN[^[J}gbNXvZ */
	  GsGetLs(op->coord2,&tmpls);

	  /* Set LSAMTRIX to GTE Registers :
	     XN[^[J}gbNXGTEɃZbg */
	  GsSetLsMatrix(&tmpls);
	  
	  /* Perspective Translate Object and Set OT :
	     IuWFNg𓧎ϊI[_Oe[uɓo^ */
	  GsSortObject3(op,&Wot[outbuf_idx],14-OT_LENGTH);
	  op++;
	}

      VSync(0);			/* Wait VSYNC : VuN҂ */
      padd=PadRead(1);		/* Readint Control Pad data :
				   pbh̃f[^ǂݍ */
      GsSwapDispBuff();		/* Swap double buffer :
				   _uobt@ؑւ */
      
      /* Set SCREEN CLESR PACKET to top of OT :
	 ʂ̃NAI[_Oe[u̍ŏɓo^ */
      GsSortClear(0x0,0x0,0x0,&Wot[outbuf_idx]);
      
      /* Drawing OT :
	 I[_Oe[uɓo^ĂpPbg̕`Jn */
      GsDrawOt(&Wot[outbuf_idx]);
    }
}


obj_interactive()
{
  SVECTOR v1;
  MATRIX  tmp1;
  
  /* Rotate Y  :
     IuWFNgY] */
  if((padd & PADRleft)>0) PWorld.vy -=5*ONE/360;

  /* Rotate Y :
     IuWFNgY] */
  if((padd & PADRright)>0) PWorld.vy +=5*ONE/360;

  /* Rotate X :
     IuWFNgX] */
  if((padd & PADRup)>0) PWorld.vx+=5*ONE/360;

  /* Rotate X :
     IuWFNgX] */
  if((padd & PADRdown)>0) PWorld.vx-=5*ONE/360;
  
  /* Translate Z :
     IuWFNgZɂē */
  if((padd & PADm)>0) DWorld.coord.t[2]-=100;
  
  /* Translate Z :
     IuWFNgZɂē */
  if((padd & PADl)>0) DWorld.coord.t[2]+=100;

  /* Translate X :
     IuWFNgXɂē */
  if((padd & PADLleft)>0) DWorld.coord.t[0] +=10;

  /* Translate X :
     IuWFNgXɂē */
  if((padd & PADLright)>0) DWorld.coord.t[0] -=10;

  /* Translate Y :
     IuWFNgYɂē */
  if((padd & PADLdown)>0) DWorld.coord.t[1]+=10;

  /* Translate Y :
     IuWFNgYɂē */
  if((padd & PADLup)>0) DWorld.coord.t[1]-=10;

  /* exit program :
     vOIăj^ɖ߂ */
  if((padd & PADk)>0) {PadStop();ResetGraph(3);StopCallback();return 0;}
  
  /* Calculate Matrix from Object Parameter and Set Coordinate :
     IuWFNg̃p[^}gbNXvZWnɃZbg */
  set_coordinate(&PWorld,&DWorld);
  
  /* Clear flag of Coordinate for recalculation :
     ČvẐ߂̃tONA */
  DWorld.flg = 0;
  return 1;
}

/* Initialize routine : [`Q */
init_all()
{
  ResetGraph(0);		/* Reset GPU /* GPUZbg */
  PadInit(0);			/* Reset Controller /* Rg[ */
  padd=0;			/*/* Rg[l */
  
  GsInitGraph(640,480,GsINTER|GsOFSGPU,1,0);
  /* rezolution set , interrace mode :
     𑜓xݒiC^[[X[hj */
    
  GsDefDispBuff(0,0,0,0);	/* Double buffer setting
                                /* _uobt@w */
#if 0    
  GsInitGraph(320,240,GsNONINTER|GsOFSGPU,0,0);
  /* rezolution set , non interrace mode :
     𑜓xݒiC^[[X[hj */
  GsDefDispBuff(0,0,0,240);	/* Double buffer setting :
				   _uobt@w */
#endif
  
  GsInit3D();			/* Init 3D system : RDVXe */
  
  Wot[0].length=OT_LENGTH;	/* Set bit length of OT handler :
				   I[_Oe[unhɉ𑜓xݒ */

  Wot[0].org=zsorttable[0];	/* Set Top address of OT Area to OT handler :
				   I[_Oe[unh
				   I[_Oe[u̎̐ݒ */
    
  /* same setting for anoter OT handler :
     _uobt@̂߂ɂݒ */
  Wot[1].length=OT_LENGTH;
  Wot[1].org=zsorttable[1];
  
  coord_init();			/* Init coordinate : W` */
  model_init();			/* Reading modeling data :
				   fOf[^ǂݍ */  
  view_init();			/* Setting view point : _ݒ */
  light_init();			/* Setting Flat Light : sݒ */
  
  initTexture1();	        /* texture load of TEX_ADDR */
}

view_init()			/* Setting view point : _ݒ */
{
  /*---- Set projection,view ----*/
  GsSetProjection(1000);	/* Set projection : vWFNVݒ */
  
  /* Setting view point location : _p[^ݒ */
  view.vpx = 0; view.vpy = 0; view.vpz = 2000;
  
  /* Setting focus point location : _p[^ݒ */
  view.vrx = 0; view.vry = 0; view.vrz = 0;
  
  /* Setting bank of SCREEN : _̔Pp[^ݒ */
  view.rz=0;

  /* Setting parent of viewing coordinate : _Wp[^ݒ */
  view.super = WORLD;
  
  /* Calculate World-Screen Matrix from viewing paramter :
     _p[^Q王_ݒ肷
     [hXN[}gbNXvZ */
  GsSetRefView2(&view);
}


light_init()			/* init Flat light : sݒ */
{
  /* Setting Light ID 0 : CgIDO ݒ */
  /* Setting direction vector of Light0 :
     sp[^ݒ */
  pslt[0].vx = 20; pslt[0].vy= -100; pslt[0].vz= -100;
  
  /* Setting color of Light0 :
     sFp[^ݒ */
  pslt[0].r=0xd0; pslt[0].g=0xd0; pslt[0].b=0xd0;
  
  /* Set Light0 from parameters :
     p[^ݒ */
  GsSetFlatLight(0,&pslt[0]);

  
  /* Setting Light ID 1 : CgIDP ݒ */
  pslt[1].vx = 20; pslt[1].vy= -50; pslt[1].vz= 100;
  pslt[1].r=0x80; pslt[1].g=0x80; pslt[1].b=0x80;
  GsSetFlatLight(1,&pslt[1]);
  
  /* Setting Light ID 2 : CgIDQ ݒ */
  pslt[2].vx = -20; pslt[2].vy= 20; pslt[2].vz= -100;
  pslt[2].r=0x60; pslt[2].g=0x60; pslt[2].b=0x60;
  GsSetFlatLight(2,&pslt[2]);
  
  /* Setting Ambient : ArGgݒ */
  GsSetAmbient(0,0,0);

  /* Setting default light mode : vZ̃ftHg̕ݒ */
  GsSetLightMode(0);
}

coord_init()			/* Setting coordinate : Wnݒ */
{
  /* Setting hierarchy of Coordinate : W̒` */
  GsInitCoordinate2(WORLD,&DWorld);
  
  /* Init work vector :
     }gbNXvZ[Ñ[e[VxN^[ */
  PWorld.vx=PWorld.vy=PWorld.vz=0;
  
  /* the org point of DWold is set to Z = -40000 :
     IuWFNǧ_[hZ = -4000ɐݒ */
  DWorld.coord.t[2] = -4000;
}


/* Set coordinte parameter from work vector :
   [eVxN^}gbNX쐬WnɃZbg */
set_coordinate(pos,coor)
SVECTOR *pos;			/* work vector : [eVxN^ */
GsCOORDINATE2 *coor;		/* Coordinate : Wn */
{
  MATRIX tmp1;
  
  /* Set translation : sړZbg */
  tmp1.t[0] = coor->coord.t[0];
  tmp1.t[1] = coor->coord.t[1];
  tmp1.t[2] = coor->coord.t[2];
  
  /* Rotate Matrix :
     }gbNXɃ[e[VxN^p */
  RotMatrix(pos,&tmp1);
  
  /* Set Matrix to Coordinate :
     ߂}gbNXWnɃZbg */
  coor->coord = tmp1;

  /* Clear flag becase of changing parameter :
     }gbNXLbVtbV */
  coor->flg = 0;
}


initTexture1()
{
        RECT rect1;
        GsIMAGE tim1;
        u_long *tex_addr;
        int i;

        tex_addr = (u_long *)TEX_ADDR;          /* Top of TIM data address */
        while(1) {
                if(*tex_addr != TIM_HEADER) {
                        break;
                }
                tex_addr++;     /* Skip TIM file header (1word) */
                GsGetTimInfo(tex_addr, &tim1);
                tex_addr += tim1.pw*tim1.ph/2+3+1;    /* Next Texture address*/
                rect1.x=tim1.px;
                rect1.y=tim1.py;
                rect1.w=tim1.pw;
                rect1.h=tim1.ph;
                printf("XY:(%d,%d) WH:(%d,%d)\n",tim1.px,tim1.py,
                                                tim1.pw,tim1.ph);
                LoadImage(&rect1,tim1.pixel);
                DrawSync(0);
                if((tim1.pmode>>3)&0x01) {      /* if clut exist */
                        rect1.x=tim1.cx;
                        rect1.y=tim1.cy;
                        rect1.w=tim1.cw;
                        rect1.h=tim1.ch;
                        LoadImage(&rect1,tim1.clut);
                        DrawSync(0);
                        tex_addr += tim1.cw*tim1.ch/2+3;
                printf("CXY:(%d,%d) CWH:(%d,%d)\n",tim1.cx,tim1.cy,
                                                tim1.cw,tim1.ch);
                }
        }
}


/* Read modeling data (TMD FORMAT) : fOf[^̓ǂݍ */
model_init()
{
  u_long *dop;
  GsDOBJ3 *objp;		/* handler of object :
				   fOf[^nh */
  int i;
  
  dop=(u_long *)MODEL_ADDR;	/* Top Address of MODELING DATA(TMD FORMAT) :
				   fOf[^i[ĂAhX */

  /* Link ObjectHandler and TMD FORMAT MODELING DATA :
     TMDf[^ƃIuWFNgnhڑ */
  Objnum = GsLinkObject3((unsigned long)dop,object);

  for(i=0,objp=object;i<Objnum;i++)
    {	
      /* Set Coordinate of Object Handler :
	 ftHg̃IuWFNg̍Wn̐ݒ */
      objp->coord2 =  &DWorld;
      
      objp->attribute = 0;	/* init attribute */
      objp++;
    }
}
