/* $PSLibId: Runtime Library Release 3.6$ */
/*
 *	tmdview5: GsDOBJ5 object viewing rotine (multi view)
 *
 *		Version 1.00	Jul,  27, 1994
 *
 *		Copyright (C) 1993 by Sony Computer Entertainment
 *		All rights Reserved
 */

#include <sys/types.h>

#include <libetc.h>		/* for Control Pad :
				   PADg߂ɃCN[hKv */
#include <libgte.h>		/* LIBGS uses libgte :
				   LIGSg߂ɃCN[hKv*/
#include <libgpu.h>		/* LIBGS uses libgpu :
				   LIGSg߂ɃCN[hKv */
#include <libgs.h>		/* for LIBGS :
				   OtBbNCu g߂
				   \̂Ȃǂ`Ă */

#define XRES 640		/* X resolution */
#define YRES 240		/* Y resolution */

#define OBJECTMAX 100		/* Max Objects :
				   RD̃f͘_IȃIuWFNg
                                   邱̍ő吔 ` */

#define TEX_ADDR   0x80010000	/* Top Address of texture data1 (TIM FORMAT) :
				   eNX`f[^iTIMtH[}bgj
				   AhX */

#define TEX_ADDR1   0x80020000  /* Top Address of texture data1 (TIM FORMAT) */
#define TEX_ADDR2   0x80030000  /* Top Address of texture data2 (TIM FORMAT) */


#define MODEL_ADDR 0x80040000	/* Top Address of modeling data (TMD FORMAT) :
				   fOf[^iTMDtH[}bgj
				   AhX */

#define OT_LENGTH  12		/* bit length of OT :
				   I[_Oe[ủ𑜓x */


/* Ot Handler of upper screen :
   I[_Oe[uPiʏ㕔jnh */
GsOT            Wot1[2];

/* Ot Handler of lower screen :
   I[_Oe[uQiʉjnh */
GsOT            Wot2[2];

GsOT_TAG	zsorttable1[2][1<<OT_LENGTH]; /* substance of OT1 :
						 I[_Oe[u1 */
GsOT_TAG	zsorttable2[2][1<<OT_LENGTH]; /* substatce of OT2 :
						 I[_Oe[u2 */

GsDOBJ5		object[OBJECTMAX]; /* Array of Object Handler :
				      IuWFNgnh
				      IuWFNg̐Kv */

u_long          Objnum;		/* valibable of number of Objects :
				   fOf[^̃IuWFNg̐
				   ێ */


GsCOORDINATE2   DWorld;  /* Coordinate for GsDOBJ5 :
			    IuWFNgƂ̍Wn */

SVECTOR         PWorld; /* work short vector for making Coordinate parameter :
			   Wn邽߂̃[e[VxN^[ */

GsRVIEW2  view;			/* View Point Handler :
				   _ݒ肷邽߂̍\ */
GsF_LIGHT pslt[3];		/* Flat Lighting Handler :
				   sݒ肷邽߂̍\ */
u_long padd;			/* Controler data :
				   Rg[̃f[^ێ */

/* work area of PACKET DATA used double size for packet double buffer :
   pPbgf[^쐬邽߂̃[N_uobt@̂2{Kv */
u_long PacketArea[0x10000];

/* work area of PACKET DATA of sub divide for double buffer :
   ppPbgf[^쐬邽߂̃[N
   _uobt@̂2{Kv */
u_long PacketAreaDiv[2][0x8000];



/************* MAIN START ******************************************/
main()
{
  int     i;
  GsDOBJ5 *op;
  int     outbuf_idx;
  MATRIX  tmpls;
  RECT    clip;
  DRAWENV upEnv,downEnv;

  ResetCallback();
  init_all();
  
  while(1)
    {
      if(obj_interactive()==0)
         return 0;	/* interactive parameter get
				: pbhf[^瓮̃p[^ */
      outbuf_idx=GsGetActiveBuff();/* Get double buffer index
	                           : _uobt@̂ǂ炩𓾂 */
	                        /* auto divide packet work setting
	                        : ppPbg[Nݒ */
      GsSetWorkBase((PACKET*)PacketAreaDiv[outbuf_idx]);
      
      /* OT1 (upper screen) Clear : OT1iʏ㕔pjNA */
      GsClearOt(0,0,&Wot1[outbuf_idx]);
      
      /* OT2 (lower screen) Clear : OT2iʉpjNA */
      GsClearOt(0,0,&Wot2[outbuf_idx]);

      /* set viewpoint of front : O猩_ݒ */
      view_init1();
      
      for(i=0,op=object;i<Objnum;i++)
	{
	  /* Calculate Local-World Matrix :
	     [h^[J}gbNXvZ */
	  GsGetLw(op->coord2,&tmpls);
	  
	  /* Set LWMATRIX to GTE Lighting Registers :
	     Cg}gbNXGTEɃZbg */
	  GsSetLightMatrix(&tmpls);
	  
	  /* Calculate Local-Screen Matrix :
	     XN[^[J}gbNXvZ */
	  GsGetLs(op->coord2,&tmpls);
	  
	  /* Set LSAMTRIX to GTE Registers :
	     XN[^[J}gbNXGTEɃZbg */
	  GsSetLsMatrix(&tmpls);
	  
	  /* Perspective Translate Object and Set OT :
	     IuWFNg𓧎ϊI[_Oe[uɓo^ */
	  GsSortObject5(op,&Wot1[outbuf_idx],14-OT_LENGTH,getScratchAddr(0));
	  op++;
	}
      
      view_init2();		/* set view point from lower side :
				   猩_ݒ */
      
      for(i=0,op= &object[Objnum];i<Objnum;i++)
	{
	  /* Calculate Local-World Matrix :
	     [h^[J}gbNXvZ */
	  GsGetLw(op->coord2,&tmpls);
	  
	  /* Set LWMATRIX to GTE Lighting Registers :
	     Cg}gbNXGTEɃZbg */
	  GsSetLightMatrix(&tmpls);
	  
	  /* Calculate Local-Screen Matrix :
	     XN[^[J}gbNXvZ */
	  GsGetLs(op->coord2,&tmpls);

	  /* Set LSAMTRIX to GTE Registers :
	     XN[^[J}gbNXGTEɃZbg */
	  GsSetLsMatrix(&tmpls);
	  
	  /* Perspective Translate Object and Set OT :
	     IuWFNg𓧎ϊI[_Oe[uɓo^ */
	  GsSortObject5(op,&Wot2[outbuf_idx],14-OT_LENGTH,getScratchAddr(0));
	  op++;
	}
      
      DrawSync(0);
      VSync(0);			/* Wait VSYNC : VuN҂ */
      padd=PadRead(1);		/* Readint Control Pad data :
				   pbh̃f[^ǂݍ */
      GsSwapDispBuff();		/* Swap double buffer :
				   _uobt@ؑւ */

      /* Set SCREEN CLESR PACKET to top of OT :
	 ʂ̃NAI[_Oe[u̍ŏɓo^ */
      GsSortClear(0x0,0x0,0x0,&Wot1[outbuf_idx]);
      
      /* Start Drawing :
	 I[_Oe[uɓo^ĂpPbg̕`Jn */

      /* Set offset of upper screen : ʏ㕔pItZbgݒ */
      GsSetOffset(XRES/2,YRES/4);
      /* Set clipping for upper screen : ʏ㕔NbsOݒ */
      clip.x = 0;clip.y= 0;clip.w=XRES;clip.h=YRES/2;
      GsSetClip(&clip);
      /* Start Drawing upper screen : ʏ㕔`Jn */
      GsDrawOt(&Wot1[outbuf_idx]);
      
      /* Set offset of upper screen : ʉpItZbgݒ */
      GsSetOffset(XRES/2,YRES*3/4);
      
      /* Set clipping for lower screen : ʉNbsOݒ */
      clip.x = 0;clip.y=YRES/2;clip.w=XRES;clip.h=YRES/2;
      GsSetClip(&clip);
      
      /* Start Drawing lower screen : ʉ`Jn */
      GsDrawOt(&Wot2[outbuf_idx]);
    }
}


obj_interactive()
{
  SVECTOR v1;
  MATRIX  tmp1;
  
  /* Rotate Y :
     IuWFNgY] */
  if((padd & PADRleft)>0) PWorld.vy -=5*ONE/360;

  /* Rotate Y :
     IuWFNgY] */
  if((padd & PADRright)>0) PWorld.vy +=5*ONE/360;

  /* Rotate X :
     IuWFNgX] */
  if((padd & PADRup)>0) PWorld.vx+=5*ONE/360;

  /* Rotate X :
     IuWFNgX] */
  if((padd & PADRdown)>0) PWorld.vx-=5*ONE/360;
  
  /* Transfer Z :
     IuWFNgZɂē */
  if((padd & PADm)>0) DWorld.coord.t[2]-=100;
  
  /* Transfer Z :
     IuWFNgZɂē */
  if((padd & PADl)>0) DWorld.coord.t[2]+=100;

  /* Transfer X :
     IuWFNgXɂē */
  if((padd & PADLleft)>0) DWorld.coord.t[0] +=10;

  /* Transfer X :
     IuWFNgXɂē */
  if((padd & PADLright)>0) DWorld.coord.t[0] -=10;

  /* Transfer Y :
     IuWFNgYɂē */
  if((padd & PADLdown)>0) DWorld.coord.t[1]+=10;

  /* Transfer Y :
     IuWFNgYɂē */
  if((padd & PADLup)>0) DWorld.coord.t[1]-=10;

  /* exit program :
     vOIăj^ɖ߂ */
  if((padd & PADk)>0) {PadStop();ResetGraph(3);StopCallback();return 0;}
  
  /* Calculate Matrix from Object Parameter and Set Coordinate :
     IuWFNg̃p[^}gbNXvZWnɃZbg */
  set_coordinate(&PWorld,&DWorld);
  return 1;
}


init_all()			/* initialize rotines : [`Q */
{
  ResetGraph(0);		/* reset GPU : GPUZbg */
  PadInit(0);			/* init controler : Rg[ */
  padd=0;			/* init contorler value :
				   Rg[l */

  if(YRES==480)
    {
      GsInitGraph(XRES,YRES,GsINTER|GsOFSGPU,1,0);
      /* set the resolution of screen (interrace mode) :
	 𑜓xݒiC^[[X[hj */
      GsDefDispBuff(0,0,0,0);	/* set the double buffers :
				   _uobt@w */
    }
  else
    {
      GsInitGraph(XRES,YRES,GsNONINTER|GsOFSGPU,1,0);
      /* set the resolution of screen (on interrace mode) :
	 𑜓xݒimC^[[X[hj */
      GsDefDispBuff(0,0,0,YRES);  /* set the double buffers :
				     _uobt@w */
    }

  
  GsInit3D();			/* init 3d part of libgs :
				   RDVXe */
  
  Wot1[0].length=OT_LENGTH;	/* set the length of OT1 : OTPɉ𑜓xݒ */
  Wot1[0].org=zsorttable1[0];	/* set the top address of OT1 tags :
				   OTPɃI[_Oe[u̎̐ݒ */
  /* set anoter OT for double buffer :
     _uobt@̂߂ɂݒ */
  Wot1[1].length=OT_LENGTH;
  Wot1[1].org=zsorttable1[1];

  Wot2[0].length=OT_LENGTH;	/* set the length of OT2 : OTQɉ𑜓xݒ */
  Wot2[0].org=zsorttable2[0];	/* set the top address of OT2 tags :
				   OTQɃI[_Oe[u̎̐ݒ */
  /* set anoter OT for double buffer :
     _uobt@̂߂ɂݒ */
  Wot2[1].length=OT_LENGTH;
  Wot2[1].org=zsorttable2[1];

  coord_init();			/* initialize the coordinate system :
				   W` */
  model_init();			/* set up the modeling data :
				   fOf[^ǂݍ */
  light_init();			/* set the flat light : sݒ */
  
  texture_init(TEX_ADDR);	/* 16bit texture load */
  texture_init(TEX_ADDR1);	/* 8bit  texture load */
  texture_init(TEX_ADDR2);	/* 4bit  texture load */
}


view_init1()			/* set the vieowpoint of upper screen :
				   _ݒiʏ㕔pj */
{
  /* set the viewpoint parameter : _p[^ݒ */
  view.vpx = 0; view.vpy = 0; view.vpz = 4000;
  /* set the refarence point parameter : _p[^ݒ */
  view.vrx = 0; view.vry = 0; view.vrz = -4000;
  /* set the roll pameter of viewpoint : _̔Pp[^ݒ */
  view.rz=0;
  
  view.super = WORLD;		/* set the view coordinate :
				   _Wp[^ݒ */
  
  /* set the view point from parameters (libgs caliculate World-Screen Matrix)
     : _p[^Q王_ݒ肷
       [hXN[}gbNXvZ */
  GsSetRefView2(&view);
}


view_init2()			/* set the viewpoint of lower screen :
				   _ݒiʉpj */
{
  /* set the viewpoint parameter : _p[^ݒ */
  view.vpx = 0; view.vpy = 8000; view.vpz = -4000;
  /* set the refarence point parameter : _p[^ݒ */
  view.vrx = 0; view.vry = 0; view.vrz = -4000;
  /* set the roll pameter of viewpoint : _̔Pp[^ݒ */
  view.rz=0;
  
  view.super = WORLD;		/* set the view coordinate :
				   _Wp[^ݒ */
  
  /* set the view point from parameters (libgs caliculate World-Screen Matrix)
     : _p[^Q王_ݒ肷
       [hXN[}gbNXvZ */
  GsSetRefView2(&view);
}


light_init()			/* init Flat light : sݒ */
{
  /* Setting Light ID 0 : CgIDO ݒ */
  /* Setting direction vector of Light0 :
     sp[^ݒ */
  pslt[0].vx = 20; pslt[0].vy= -100; pslt[0].vz= -100;
  
  /* Setting color of Light0 :
     sFp[^ݒ */
  pslt[0].r=0xd0; pslt[0].g=0xd0; pslt[0].b=0xd0;
  
  /* Set Light0 from parameters :
     p[^ݒ */
  GsSetFlatLight(0,&pslt[0]);
  
  /* Setting Light ID 1 : CgIDP ݒ */
  pslt[1].vx = 20; pslt[1].vy= -50; pslt[1].vz= 100;
  pslt[1].r=0x80; pslt[1].g=0x80; pslt[1].b=0x80;
  GsSetFlatLight(1,&pslt[1]);
  
  /* Setting Light ID 2 : CgIDQ ݒ */
  pslt[2].vx = -20; pslt[2].vy= 20; pslt[2].vz= -100;
  pslt[2].r=0x60; pslt[2].g=0x60; pslt[2].b=0x60;
  GsSetFlatLight(2,&pslt[2]);
  
  /* Setting Ambient : ArGgݒ */
  GsSetAmbient(0,0,0);

  /* Setting default light mode : vZ̃ftHg̕ݒ */
  GsSetLightMode(0);
}

coord_init()			/* Setting coordinate : Wnݒ */
{
  /* Setting hierarchy of Coordinate : W̒` */
  GsInitCoordinate2(WORLD,&DWorld);
  
  /* Init work vector :
     }gbNXvZ[Ñ[e[VxN^[ */
  PWorld.vx=PWorld.vy=PWorld.vz=0;
  
  /* the org point of DWold is set to Z = -40000 :
     IuWFNǧ_[hZ = -4000ɐݒ */
  DWorld.coord.t[2] = -4000;
}


/* Set coordinte parameter from work vector :
   [eVxN^}gbNX쐬WnɃZbg */
set_coordinate(pos,coor)
SVECTOR *pos;			/* work vector : [eVxN^ */
GsCOORDINATE2 *coor;		/* Coordinate : Wn */
{
  MATRIX tmp1;
  
  /* Set translation : sړZbg */
  tmp1.t[0] = coor->coord.t[0];
  tmp1.t[1] = coor->coord.t[1];
  tmp1.t[2] = coor->coord.t[2];
  
  /* Rotate Matrix :
     [e[VxN^]}gbNX쐬 */
  RotMatrix(pos,&tmp1);
  
  /* Set Matrix to Coordinate :
     ߂}gbNXWnɃZbg */
  coor->coord = tmp1;

  /* Clear flag becase of changing parameter :
     }gbNXLbVtbV */
  coor->flg = 0;
}

/* Load texture to VRAM :
   eNX`f[^VRAMɃ[h */
texture_init(addr)
u_long addr;
{
  RECT rect1;
  GsIMAGE tim1;

  /* Get texture information of TIM FORMAT :
     TIMf[^̃wb_eNX`̃f[^^Cv̏𓾂 */
  GsGetTimInfo((u_long *)(addr+4),&tim1);
  
  rect1.x=tim1.px;		/* X point of image data on VRAM :
				   eNX`VRAMłXW */
  rect1.y=tim1.py;		/* Y point of image data on VRAM :
				   eNX`VRAMłYW */
  rect1.w=tim1.pw;		/* Width of image : eNX` */
  rect1.h=tim1.ph;		/* Height of image : eNX` */
  
  /* Load texture to VRAM : VRAMɃeNX`[h */
  LoadImage(&rect1,tim1.pixel);
  
  /* Exist Color Lookup Table : J[bNAbve[u݂ */  
  if((tim1.pmode>>3)&0x01)
    {
      rect1.x=tim1.cx;		/* X point of CLUT data on VRAM :
				   NbgVRAMłXW */
      rect1.y=tim1.cy;		/* Y point of CLUT data on VRAM :
				   NbgVRAMłYW */
      rect1.w=tim1.cw;		/* Width of CLUT : Nbg̕ */
      rect1.h=tim1.ch;		/* Height of CLUT : Nbg̍ */

      /* Load CULT data to VRAM : VRAMɃNbg[h */
      LoadImage(&rect1,tim1.clut);
    }
}


model_init()
{				/* set up the modeling data :
				   fOf[^̓ǂݍ */
  u_long *dop;
  GsDOBJ5 *objp;		/* the handler or modeling data :
				   fOf[^nh */
  int i;
  u_long *oppp;
  
  dop=(u_long *)MODEL_ADDR;	/* the top address of modeling data :
				   fOf[^i[ĂAhX */
  dop++;			/* hedder skip */
  
  GsMapModelingData(dop);	/* map the modeling data to real address :
				  fOf[^iTMDtH[}bgj
				   AhXɃ}bv */
  dop++;
  Objnum = *dop;		/* get the number of objects :
				   IuWFNgTMD̃wb_瓾 */
  dop++;			/* inc the address to link to the handler :
				   GsLinkObject5ŃN邽߂TMD
				   IuWFNg̐擪ɂĂ */
  
  /* Link TMD data and Object Handler for upper screen :
     TMDf[^ƃIuWFNgnhڑiʏ㕔pj*/
  for(i=0;i<Objnum;i++)
    GsLinkObject5((u_long)dop,&object[i],i);
  
  /* Link TMD data and Object Handler for lower screen
     Note that tmd data is same as data of upper screen :
     TMDf[^ƃIuWFNgnhڑiʉpj*/
  for(i=0;i<Objnum;i++)
    GsLinkObject5((u_long)dop,&object[i+Objnum],i);
  
  oppp = PacketArea;		/* preset packet area :
				   packet̘ggAhX */
  
  /* Preset upper and lower Object Handler :
     vZbǵAʏ㕔ƉsȂ */
  for(i=0,objp=object;i<Objnum*2;i++)
    { /* default object coordinate : ftHg̃IuWFNg̍Wn̐ݒ */
      objp->coord2 =  &DWorld;
      /* objp->attribute = 0; */
      objp->attribute = GsDIV3;
      oppp = GsPresetObject(objp,oppp);
      objp++;
    }
}
