/*
 * $PSLibId: Runtime Library Release 3.6$
 */
/* 
 * 	janken: sample program using TOD data
 * 
 *	"main.c" main routine
 *
 * 		Version 2.00	Feb, 3, 1995
 * 
 * 		Copyright (C) 1994, 1995 by Sony Computer Entertainment
 * 		All rights Reserved
 */

/*****************/
/* Include files */
/*****************/
#include <sys/types.h>
#include <libetc.h>		/* PADg߂ɃCN[hKv */
#include <libgte.h>		/* LIGSg߂ɃCN[hKv */
#include <libgpu.h>		/* LIGSg߂ɃCN[hKv */
#include <libgs.h>		/* OtBbNCu g߂
				   \̂Ȃǂ`Ă */
#include "tod.h"		/* TOD֐̐錾 */
#include "te.h"			/* TMD-ID Xg (rsdlinkō쐬) */

/**********/
/* For OT */
/**********/
#define OT_LENGTH	12		 /* OT𑜓x12biti傫j */
GsOT		WorldOT[2];		 /* OTi_uobt@j */
GsOT_TAG	OTTags[2][1<<OT_LENGTH]; /* OT̃^Öi_uobt@j */

/***************/
/* For Objects */
/***************/
#define OBJMAX	50			/* őIuWFNg */
GsDOBJ2		obj_area[OBJMAX];	/* IuWFNgϐ̈ */
GsCOORDINATE2	obj_coord[OBJMAX];	/* [JWϐ̈ */
GsCOORD2PARAM	obj_cparam[OBJMAX];	/* [JWϐ̈ */
TodOBJTABLE	objs;			/* IuWFNge[u */

/***************/
/* For Packets */
/***************/
#define PACKETMAX	6000		/* 1t[̍őpPbg */
#define PACKETMAX2	(PACKETMAX*24)	/* 1pPbgσTCY24ByteƂ */
PACKET	GpuPacketArea[2][PACKETMAX2];	/* pPbg̈i_uobt@j */

/***************/
/* For Viewing */
/***************/
#define VPX	-8000
#define VPY	-2000
#define VPZ	-5000
#define VRX	-900
#define VRY	-1500
#define VRZ	0
GsRVIEW2	view;			/* _ */

/************************/
/* For Lights ( three ) */
/************************/
GsF_LIGHT	pslt[3];		/* ~R */

/*********************/
/* For Modeling data */
/*********************/
#define MODEL_ADDR	0x800c0000
u_long		*TmdP;			/* fOf[^|C^ */

/**********************/
/* For Animation data */
/**********************/
#define TOD_ADDR0	0x800e0000
#define TOD_ADDR1	0x80100000
#define TOD_ADDR2	0x80120000
#define TOD_ADDR3	0x80140000
#define TOD_ADDR4	0x80160000
#define TOD_ADDR5	0x80180000
#define TOD_ADDR6	0x801a0000
#define TOD_ADDR7	0x801c0000
#define TOD_ADDR8	0x801e0000
#define NUMTOD		9
u_long		*TodP[NUMTOD];		/* Aj[Vf[^|C^z */
int		NumFrame[NUMTOD];	/* Aj[Vf[^t[z */
int		StartFrameNo[NUMTOD];	/* Aj[VX^[gt[ԍz */

/******************/
/* For Controller */
/******************/
u_long		padd;

/*******************/
/* For Janken type */
/*******************/
int		pose;

/*************************/
/* Prototype Definitions */
/*************************/
int	exitProgram();
void	drawObject();
void	initSystem();
void	initView();
void	initLight();
void	initModelingData();
void	initTod();
void	initPose();
int	obj_interactive();


/*
 * Main routine
/* CE[`
 *
 */
main()
{
    /* Initialize 
       /* CjVCY */
    ResetCallback();
    initSystem();
    initView();
    initLight();
    initModelingData();
    initTod();
    initPose();
    
    FntLoad(960, 256);
    SetDumpFnt(FntOpen(32-320, 32-120, 256, 200, 0, 512));

    while( 1 ) {

	/* Read the pad data */
	padd = PadRead( 1 );
	/* play TOD data according to the pad data */
	if(obj_interactive()) break;
    }

    PadStop();
    ResetGraph(3);
    StopCallback();
    return 0;
}

/*
 * Draw 3D objects
/* 3DIuWFNg`揈
 *
 */
void
drawObject()
{
    int		i;
    int		activeBuff;
    GsDOBJ2	*objp;
    MATRIX	LsMtx;
    int         load_count1,load_count2,load_count3,load_org;

    activeBuff = GsGetActiveBuff();

    /* Set the address at which drawing command will be put
       /* `R}hi[AhXݒ肷 */
    GsSetWorkBase( (PACKET*)GpuPacketArea[activeBuff] );

    /* Initialize OT 
       /* OT ̏ */
    GsClearOt( 0, 0, &WorldOT[activeBuff] );

    /* Set the pointer to the object array 
       /* IuWFNgzւ̃|C^Zbg */
    objp = objs.top;

    load_count1=load_count2=load_count3=0;
    for( i = 0; i < objs.nobj; i++ ) { 

	/* flag whether the coord has changed or not
	   /* coord ꂽǂ̃tO */
	objp->coord2->flg = 0;

	if ( ( objp->id != TOD_OBJ_UNDEF ) && ( objp->tmd != 0 ) ) {

	    /* Calculate the local screen matrix 
	       /* [JXN[}gbNXvZ */
	    load_org = VSync(1);
	    GsGetLs( objp->coord2, &LsMtx );
	    load_count1+= VSync(1)-load_org;
	    /* Set the local screen matrix to GTE 
	       /* [JXN[}gbNX GTE ɃZbg */
	    GsSetLsMatrix( &LsMtx );
	    
	    /* Set the light matrix to GTE 
	       /* Cg}gbNX GTE ɃZbg */
	    GsSetLightMatrix( &LsMtx );
	    
	    /* Transform the object perspectively and assign it to the OT
	       /* IuWFNg𓧎ϊI[_Oe[uɊt */
	    load_org = VSync(1);
	    GsSortObject4( objp, 		/* Pointer to the object */
			   &WorldOT[activeBuff],/* Pointer to the OT */
			   14-OT_LENGTH,getScratchAddr(0) );	/* number of bits to be shifted*/
	    load_count2+= VSync(1)-load_org;
	}

	objp++;
    }
    FntPrint("%d %d\n",load_count1,load_count2);

    VSync( 0 );				/* Wait for V-BLNK */
    ResetGraph( 1 );			/* Cancel the current display */
    GsSwapDispBuff();			/* Switch the double buffer */

    /* Resister the clear command to OT 
       /* ʃNAR}h OT ɓo^ */
    GsSortClear( 0x0,				/* R of the background */
		 0x0,				/* G of the background */
		 0x0,				/* B of the background */
		 &WorldOT[activeBuff] );	/* Pointer to the OT */

    /* Do the drawing commands assigned to the OT 
       /* OT Ɋtꂽ`R}h̕` */
    GsDrawOt( &WorldOT[activeBuff] );
    FntFlush(-1);
}

/*
 * Initialize system
/* [`Q
 *
 */
void
initSystem()
{
  /* Initialize the controll pad
     /* Rg[pbh̏ */
  PadInit( 0 );
  padd = 0;
	
  /* Initialize the GPU 
     /* GPȔ */
  GsInitGraph( 640, 240, GsOFSGPU|GsNONINTER, 1, 0 );
  GsDefDispBuff( 0, 0, 0, 240 );
	
  /* Initialize the OT 
     /* OT̏ */
  WorldOT[0].length = OT_LENGTH;
  WorldOT[0].org = OTTags[0];
  WorldOT[0].offset = 0;
  WorldOT[1].length = OT_LENGTH;
  WorldOT[1].org = OTTags[1];
  WorldOT[1].offset = 0;
	
  /* Initialize the 3D library 
     /* 3DCȕ */
  GsInit3D();
}

/*
 * Set the location of the view point
/* _ʒu̐ݒ
 *
 */
void
initView()
{
    /* Set the view angle 
       /* vWFNVipj̐ݒ */
    GsSetProjection( 1000 );

    /* Set the view point and the reference point 
       /* _ʒu̐ݒ */
    view.vpx = VPX; view.vpy = VPY; view.vpz = VPZ;
    view.vrx = VRX; view.vry = VRY; view.vrz = VRZ;
    view.rz = 0;
    view.super = WORLD;
    GsSetRefView2( &view );

    /* Set the value of Z clip 
       /* ZNbvlݒ */
    GsSetNearClip( 100 );
}

/*
 * Set the light ( the direction and the color )
/* ̐ݒiƎ˕Fj
 *
 */
void
initLight()
{
    /* Light #0 , direction (100,100,100) 
       /* #0 (100,100,100)̕֏Ǝ */
    pslt[0].vx = 100; pslt[0].vy= 100; pslt[0].vz= 100;
    pslt[0].r=0xd0; pslt[0].g=0xd0; pslt[0].b=0xd0;
    GsSetFlatLight( 0,&pslt[0] );
	
    /* Light #1 ( not used ) 
       /* #1igpj */
    pslt[1].vx = 100; pslt[1].vy= 100; pslt[1].vz= 100;
    pslt[1].r=0; pslt[1].g=0; pslt[1].b=0;
    GsSetFlatLight( 1,&pslt[1] );
	
    /* Light #2 ( not used ) 
       /* #2igpj */
    pslt[2].vx = 100; pslt[2].vy= 100; pslt[2].vz= 100;
    pslt[2].r=0; pslt[2].g=0; pslt[2].b=0;
    GsSetFlatLight( 2,&pslt[2] );
	
    /* Set the ambient light 
       /* ArGgiӌj̐ݒ */
    GsSetAmbient( ONE/2,ONE/2,ONE/2 );

    /* Set the light mode 
       /* [h̐ݒiʏ/FOGȂj */
    GsSetLightMode( 0 );
}

/*
 * Get TMD data from the memory ( use only the top one )
/* TMDf[^̓ǂݍ (擪̂P̂ݎgpj
 *
 */
void
initModelingData()
{
    /* Top address of the TMD data 
       /* TMDf[^̐擪AhX */
    TmdP = ( u_long * )MODEL_ADDR;

    /* Skip the file header 
       /* t@Cwb_XLbv */
    TmdP++;

    /* Map to the real address 
       /* AhXփ}bv */
    GsMapModelingData( TmdP );

    /* Initialize the object table 
       /* IuWFNge[ȕ */
    TodInitObjTable( &objs, obj_area, obj_coord, obj_cparam, OBJMAX );
}


/*
 * Set TOD data from the memory
/* TODf[^̓ǂݍ
 *
 */
void
initTod()
{
	TodP[0] = ( u_long * )TOD_ADDR0;
	TodP[0]++;
	NumFrame[0] = *TodP[0]++;
	StartFrameNo[0] = *( TodP[0] + 1 );

	TodP[1] = ( u_long * )TOD_ADDR1;
	TodP[1]++;
	NumFrame[1] = *TodP[1]++;
	StartFrameNo[1] = *( TodP[1] + 1 );

	TodP[2] = ( u_long * )TOD_ADDR2;
	TodP[2]++;
	NumFrame[2] = *TodP[2]++;
	StartFrameNo[2] = *( TodP[2] + 1 );

	TodP[3] = ( u_long * )TOD_ADDR3;
	TodP[3]++;
	NumFrame[3] = *TodP[3]++;
	StartFrameNo[3] = *( TodP[3] + 1 );

	TodP[4] = ( u_long * )TOD_ADDR4;
	TodP[4]++;
	NumFrame[4] = *TodP[4]++;
	StartFrameNo[4] = *( TodP[4] + 1 );

	TodP[5] = ( u_long * )TOD_ADDR5;
	TodP[5]++;
	NumFrame[5] = *TodP[5]++;
	StartFrameNo[5] = *( TodP[5] + 1 );

	TodP[6] = ( u_long * )TOD_ADDR6;
	TodP[6]++;
	NumFrame[6] = *TodP[6]++;
	StartFrameNo[6] = *( TodP[6] + 1 );

	TodP[7] = ( u_long * )TOD_ADDR7;
	TodP[7]++;
	NumFrame[7] = *TodP[7]++;
	StartFrameNo[7] = *( TodP[7] + 1 );

	TodP[8] = ( u_long * )TOD_ADDR8;
	TodP[8]++;
	NumFrame[8] = *TodP[8]++;
	StartFrameNo[8] = *( TodP[8] + 1 );
}

/*
 * Draw the initial pose
/* oꂩ珉|[YƂ܂
 *
 */
void
initPose()
{
    int		i;
    int		j;
    int		frameNo;
    int		oldFrameNo;

    /* ŏ̃t[ TODf[^̏ */
    TodP[0] = TodSetFrame( StartFrameNo[0], TodP[0], &objs, te_list, 
			   TmdP, TOD_CREATE );
    drawObject();
    oldFrameNo = StartFrameNo[0];

    /* ȍ~̃t[ TODf[^̏ */
    for ( i = 1 ; i < NumFrame[0] ; i++ ) {

	frameNo = *( TodP[0] + 1 );

	for ( j = 0 ; j < frameNo - oldFrameNo - 1 ; j++ ) {
	    drawObject();
	}

	/* 1t[ TODf[^̏ */
	TodP[0] = TodSetFrame( frameNo, TodP[0], &objs, te_list, 
			       TmdP, TOD_CREATE );
	drawObject();
	oldFrameNo = frameNo;
    }
    drawObject();

    pose = -1;
}

/*
 * play TOD data according to the pad data 
/* pbhɂATODf[^\
 *
 */
int obj_interactive()
{
    int		i;
    u_long	*TodPtmp;		/* pointer to TOD data  */
    int		step;
    
    /* u[v( ) */
    if ( ( padd & PADRright ) > 0 ) {

	/* ݂̃|[YUn߂̒ʒuɖ߂ */
	if ( pose > 0 ) {
	    TodPtmp = TodP[pose+3];
	    for ( i = StartFrameNo[pose+3] 
		  ; i < NumFrame[pose+3] + StartFrameNo[pose+3] 
		  ; i++ ) {

		TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				       TmdP, TOD_CREATE );
		drawObject();
	    }
	    drawObject();
	}

	/* u`񂯁`vƈ茝U */
	TodPtmp = TodP[1];
	for ( i = StartFrameNo[1] ; i < NumFrame[1] + StartFrameNo[1] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	/* ʒuu[vo */
	TodPtmp = TodP[2];
	for ( i = StartFrameNo[2] ; i < NumFrame[2] + StartFrameNo[2] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	pose = 2;
    }

    /* uρ[v */
    if ( ( padd & PADRleft ) > 0 ) {

	/* ݂̃|[YUn߂̒ʒuɖ߂ */
	if ( pose > 0 ) {
	    TodPtmp = TodP[pose+3];
	    for ( i = StartFrameNo[pose+3] 
		  ; i < NumFrame[pose+3] + StartFrameNo[pose+3] 
		  ; i++ ) {

		TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				       TmdP, TOD_CREATE );
		drawObject();
	    }
	    drawObject();
	}

	/* u`񂯁`vƈ茝U */
	TodPtmp = TodP[1];
	for ( i = StartFrameNo[1] ; i < NumFrame[1] + StartFrameNo[1] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	/* ʒuuρ[vo */
	TodPtmp = TodP[4];
	for ( i = StartFrameNo[4] ; i < NumFrame[4] + StartFrameNo[4] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	pose = 4;
    }

    /* u傫v */
    if ( ( padd & PADRup ) > 0 ) {

	/* ݂̃|[YUn߂̒ʒuɖ߂ */
	if ( pose > 0 ) {
	    TodPtmp = TodP[pose+3];
	    for ( i = StartFrameNo[pose+3] 
		  ; i < NumFrame[pose+3] + StartFrameNo[pose+3] 
		  ; i++ ) {

		TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				       TmdP, TOD_CREATE );
		drawObject();
	    }
	    drawObject();
	}

	/* u`񂯁`vƈ茝U */
	TodPtmp = TodP[1];
	for ( i = StartFrameNo[1] ; i < NumFrame[1] + StartFrameNo[1] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	/* ʒuu傫vo */
	TodPtmp = TodP[3];
	for ( i = StartFrameNo[3] ; i < NumFrame[3] + StartFrameNo[3] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	pose = 3;
    }

    /* u[vu傫vuρ[v̂ꂩ_ɏo */
    if ( ( padd & PADRdown ) > 0 ) {

	/* ݂̃|[YUn߂̒ʒuɖ߂ */
	if ( pose > 0 ) {
	    TodPtmp = TodP[pose+3];
	    for ( i = StartFrameNo[pose+3] 
		  ; i < NumFrame[pose+3] + StartFrameNo[pose+3] 
		  ; i++ ) {

		TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				       TmdP, TOD_CREATE );
		drawObject();
	    }
	    drawObject();
	}

	/* u`񂯁`vƈ茝U */
	TodPtmp = TodP[1];
	for ( i = StartFrameNo[1] ; i < NumFrame[1] + StartFrameNo[1] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	/* ʒuu[vu傫vuρ[v̂ꂩ_ɏo */
	pose = rand()%3 + 2;
	TodPtmp = TodP[pose];
	for ( i = StartFrameNo[pose] 
	      ; i < NumFrame[pose] + StartFrameNo[pose] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();
    }

    /* _̕ύX */
    if ( ( padd & PADn ) > 0 ) {
	view.vpz += 100;
	GsSetRefView2( &view );
	drawObject();
    }
    if ( ( padd & PADo ) > 0 ) {
	view.vpz -= 100;
	GsSetRefView2( &view );
	drawObject();
    }
    if ( ( padd & PADLleft ) > 0 ) {
	view.vpx -= 100;
	GsSetRefView2( &view );
	drawObject();
    }
    if ( ( padd & PADLright ) > 0 ) {
	view.vpx += 100;
	GsSetRefView2( &view );
	drawObject();
    }
    if ( ( padd & PADLdown ) > 0 ) {
	view.vpy += 100;
	GsSetRefView2( &view );
	drawObject();
    }
    if ( ( padd & PADLup ) > 0 ) {
	view.vpy -= 100;
	GsSetRefView2( &view );
	drawObject();
    }
    
    /* Move the view point to the initial place 
       /* _ɖ߂ */
    if ( ( padd & PADh ) > 0 ) {
	initView();
	drawObject();
    }

    /* Exit the program 
       /* vOI */
    if ( ( padd & PADk ) > 0 ) {

	/* |[Yɖ߂ */
	if ( pose > 0 ) {

	    TodPtmp = TodP[pose+3];
	    for ( i = StartFrameNo[pose+3] 
		  ; i < NumFrame[pose+3] + StartFrameNo[pose+3] 
		  ; i++ ) {

		TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				       TmdP, TOD_CREATE );
		drawObject();
	    }
	    drawObject();
	}

	/* _̈ʒuɖ߂ */
	step = ( ( VPX - view.vpx ) * ( VPX - view.vpx )
		 + ( VPY - view.vpy ) * ( VPY - view.vpy )
		 + ( VPZ - view.vpz ) * ( VPZ - view.vpz ) ) / 500000;
	if ( step > 50 ) {
	    step = 50;
	}
	for ( i = 1 ; i <= step ; i++ ) {
	    view.vpx = view.vpx + ( i * ( VPX - view.vpx ) ) / step;
	    view.vpy = view.vpy + ( i * ( VPY - view.vpy ) ) / step;
	    view.vpz = view.vpz + ( i * ( VPZ - view.vpz ) ) / step;
	    GsSetRefView2( &view );
	    drawObject();
	}

	/* ޏ */
	TodPtmp = TodP[8];
	for ( i = StartFrameNo[8] ; i < NumFrame[8] + StartFrameNo[8] 
	      ; i++ ) {

	    TodPtmp = TodSetFrame( i, TodPtmp, &objs, te_list, 
				   TmdP, TOD_CREATE );
	    drawObject();
	}
	drawObject();

	/* vȌI */
	return -1;
    }

    return 0;
}
