/* $PSLibId: Runtime Library Release 3.6$ */
/*
 *
 *	TOD functions (part1)
 : 	TODAj[V֐QîPj
 *
 *
 *		Version 1.30	Apr,  17, 1996
 *
 *		Copyright (C) 1995 by Sony Computer Entertainment Inc.
 *			All rights Reserved
 */

#include <sys/types.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include "tod.h"

/*
 *  Prototype definition
 :  vg^Cv錾
 */
void TodInitObjTable();
GsDOBJ2 *TodSearchObjByID();
GsDOBJ2 *TodCreateNewObj();
GsDOBJ2 *TodRemoveObj();
u_long *TodSearchTMDByID();

/*
 *  Initialize Object table
 :  IuWFNge[ȕ
 *       GsDOBJ2,GsCOORDINATE2, GsCOORD2PARAM gɂėp
 */
void TodInitObjTable(tblP, objAreaP, objCoordP, objParamP, nObj)
TodOBJTABLE *tblP;		/* : e[uւ̃|C^ */
GsDOBJ2 *objAreaP;		/* : IuWFNg(DOBJ2)̈ */
GsCOORDINATE2 *objCoordP;	/* : [JẄ */
GsCOORD2PARAM *objParamP;	/* : [JW̃p[^̈ */
int nObj;			/* Maximum number of object
				 : őOBJie[ȗ傫j */
{
	int i;

	tblP->nobj = 0;		/* number of available object: LIuWFNg */
	tblP->maxobj = nObj;	/* maximum number of object: őIuWFNg */
	tblP->top = objAreaP;	/* object area: IuWFNg̈ */
	i = 0;
	for(i = 0; i < nObj; i++) {
		/* Initialize members: IuWFNg\̂̃o */
		objAreaP->attribute = 0x80000000;
		objAreaP->id = TOD_OBJ_UNDEF;
		objAreaP->coord2 = objCoordP;
		objAreaP->coord2->param = objParamP;
		objAreaP->tmd = NULL;
		objAreaP++;
		objCoordP++;
		objParamP++;
	}
}

/*
 *  Search object in the object table by ID
 :  IuWFNge[uIDԍŌ
 */
GsDOBJ2 *TodSearchObjByID(tblP, id)
TodOBJTABLE *tblP;	/* : IuWFNge[uփ|C^ */
u_long id;		/* ID number for search: IuWFNgIDԍ */
{
	GsDOBJ2 *objP;
	int i;

	objP = tblP->top;
	for(i = 0; i < tblP->nobj; i++) {
		if(id == objP->id) break;
		objP++;
	}
	if(i == tblP->nobj) {
		/* Not Found */
		return(NULL);
	}
	else {
		/* Return pointer */
		return(objP);
	}
}

/*
 *  Create new object in the object table
 :  VIuWFNge[uɐ
 */
GsDOBJ2 *TodCreateNewObj(tblP, id)
TodOBJTABLE *tblP;	/* IuWFNge[uփ|C^ */
u_long id;		/* ID number to create: IuWFNgIDԍ */
{
	GsDOBJ2 *objP;
	int i;

	/* Search undefined area in the table(ID=TOD_OBJ_UNDEF)
	 : 󂫗̈(ID==TOD_OBJ_UNDEF)T */
	objP = tblP->top;
	for(i = 0; i < tblP->nobj; i++) {
		if(objP->id == TOD_OBJ_UNDEF) break;
		objP++;
	}

	/* Search deleted area
	 : Deleted̗̈()邩H */
	if(i < tblP->nobj) {
		objP->id = id;
		objP->attribute = 0;
		GsInitCoordinate2(WORLD, objP->coord2);
		objP->tmd = NULL;
		return(objP);
	}
	else {
		/* Add new object to bottom of the table
		 : e[u̍ŌɐVKIuWFNgǉ */
		if(i < tblP->maxobj) {		/* Table is Full? */
			objP = tblP->top+tblP->nobj;
			tblP->nobj++;
			objP->id = id;
			objP->attribute = 0;
			GsInitCoordinate2(WORLD, objP->coord2);
			objP->tmd = NULL;
			return(objP);
		}
		else {
			/* Table is full: e[uςȂNULLԂ */
			return(NULL);
		}
	}
}

/*
 *  Delete object from object table
 :  e[uIuWFNg폜
 */
GsDOBJ2 *TodRemoveObj(tblP, id)
TodOBJTABLE *tblP;	/* Object table: IuWFNge[uփ|C^ */
u_long id;		/* ID number to delete: 폜IuWFNgIDԍ */
{
	GsDOBJ2 *objP;
	int i;

	/* Search object: IDԍŃIuWFNgT */
	objP = tblP->top;
	for(i = 0; i < tblP->nobj; i++) {
		if(objP->id == TOD_OBJ_UNDEF) break;
		objP++;
	}

	/* Delete it: YIuWFNgTč폜 */
	if(i < tblP->nobj) {
		objP->id = TOD_OBJ_UNDEF;
		if(i == tblP->nobj-1) {
			while(objP->id == TOD_OBJ_UNDEF) {
				tblP->nobj--;
				objP--;
			}
		}

		/* return object addr: AhXԂ */
		return(objP);
	}
	else {
		/* retuen NULL when not found: ȂNULLԂ */
		return(NULL);
	}
}

/*
 *  Search modeling data in TMD
 :  TMD̃fOf[^IDԍŌ
 */
u_long *TodSearchTMDByID(tmdP, idListP, id)
u_long *tmdP;
int *idListP;
u_long id;
{
	int n;

	tmdP++;		/* Skip header: wb_ǂݔ΂ */
	n = *tmdP++;	/* Number of object: fOf[^̐ */

	while(n > 0) {
		if(id == *idListP) break;
		tmdP += 7;	/* next object: |C^i߂ */
		idListP++;
		n--;
	}
	if(n == 0) {
		/* return NULL when not found: ȂNULLԂ */
		return(NULL);
	}
	else {
		/* return TMD addr: AhXԂ */
		return(tmdP);
	}
}
