/* $PSLibId: Runtime Library Release 3.6$ */
/*
 *	TOD functions (part2)
 :	TODAj[V֐QîQj
 *
 *
 *		Version 1.30	Apr, 17, 1996
 *
 *		Copyright (C) 1995 by Sony Computer Entertainment Inc.
 *			All rights Reserved
 */

#include <sys/types.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include "tod.h"

extern GsF_LIGHT pslt[3];		/* Light source: ~R */

/*
 *  Prototype definitions: vg^Cv錾
 */
u_long *TodSetFrame();
u_long *TodSetPacket();

/*
 *  TOD process for 1 frame
 :  Pt[TODf[^̏
 */
u_long *TodSetFrame(currentFrame, todP, objTblP, tmdIdP, tmdTblP, mode)
int currentFrame;	/* Current time:݂̎it[ԍj */
u_long *todP;		/* Current TOD:ĐTODf[^ւ̃|C^ */
TodOBJTABLE *objTblP;	/* Object table:IuWFNge[uւ̃|C^ */
int *tmdIdP;		/* TMD ID list:fOf[^IDXg */
u_long *tmdTblP;	/* TMD data addr:TMDf[^ւ̃|C^ */
int mode;		/* Playing mode:Đ[h */
{
	u_long hdr;
	u_long nPacket;
	u_long frame;
	int i;

	/* Get frame info.:t[𓾂 */
	hdr = *todP;			/* :t[wb_𓾂 */
	nPacket = (hdr>>16)&0x0ffff;	/* Number of packet:pPbg */
	frame = *(todP+1);		/* :it[ԍj */

	/* Wait until specified frame time
	 : ݎ̃t[łȂΉȂ
	 */
	if(frame > currentFrame) return todP;

	/* Execute each packet in a frame
	 : t[̒̊epPbg */
	todP += 2;
	for(i = 0; i < nPacket; i++) {
		todP = TodSetPacket(todP, objTblP, tmdIdP, tmdTblP, mode);
	}

	/* Return next frame addr.
	 : ̃t[ւ̃|C^Ԃ */
	return todP;	
}

/*
 *  Execute single packet
 :  PpPbg̏
 */
u_long *TodSetPacket(packetP, tblP, tmdIdP, tmdTblP, mode)
u_long *packetP;
TodOBJTABLE *tblP;
int *tmdIdP;
u_long *tmdTblP;
int mode;
{
	u_long *dP;		/* Current TOD addr:TODւ̃|C^ */

	u_long hdr;
	u_long id;
	u_long flag;
	u_long type;
	u_long len;

	/* Current object: IuWFNg */
	GsDOBJ2 *objP;		/* IuWFNgւ̃|C^ */
	GsCOORD2PARAM *cparam;	/* Coordinate value(RST): Wp[^(R,S,T) */
	MATRIX *coordp;		/* Coordinate matrix: W}gNX */
	GsDOBJ2 *parentP;	/* Parent object: eIuWFNg */
	VECTOR v;
	SVECTOR sv;

	/* Dummy object: _~[IuWFNgϐ */
	GsDOBJ2 dummyObj;
	MATRIX dummyObjCoord;
	GsCOORD2PARAM dummyObjParam;


	/* Get Packet Info: pPbg𓾂 */
	dP = packetP;
	hdr = *dP++;
	id = hdr&0x0ffff;	/* ID number */
	type = (hdr>>16)&0x0f;	/* Packet type (TOD_???) */
	flag = (hdr>>20)&0x0f;	/* Flags */
	len = (hdr>>24)&0x0ff;	/* Word lengthfor packet: pPbg̃[h */

	/* Search specified object from ID
	 : IDԍŊYIuWFNgT[` */
	objP = TodSearchObjByID(tblP, id);
	if(objP == NULL) {
		/* Use dummy object when not found
		 : Ȃꍇ̓_~[IuWFNgg */
		objP = &dummyObj;
		coordp = &dummyObjCoord;
		cparam = &dummyObjParam;
	}
	else {
		coordp = &(objP->coord2->coord);
		cparam = (objP->coord2->param);
		objP->coord2->flg = 0;
	}

	/* pPbg̃^Cvʂɏ */
	switch(type) {
	    case TOD_ATTR:/* Update attribute: Agr[gύX */
		objP->attribute = (objP->attribute&*dP)|*(dP+1);	
		dP += 2;
		break;

	    case TOD_COORD:/* Update Coordinate value
			    : WύXiړ^]^gj */

		/* Update 'coordinate' member of current object
		   using 'cparam' member.
		 : YIuWFNgcoordinate̓eXV
		   XVp[^cparamoɕۊǂĂ */

		if(flag&0x01) {

			/* Differencial value: Ot[̍̏ꍇ */

			/* Rotation */
			if(flag&0x02) {
				cparam->rotate.vx += (*(((long *)dP)+0))/360;
				cparam->rotate.vy += (*(((long *)dP)+1))/360;
				cparam->rotate.vz += (*(((long *)dP)+2))/360;
				dP += 3;
			}
			/* Scaling */
			if(flag&0x04) {
				cparam->scale.vx
				 = (cparam->scale.vx**(((short *)dP)+0))/4096;
				cparam->scale.vy
				 = (cparam->scale.vy**(((short *)dP)+1))/4096;
				cparam->scale.vz
				 = (cparam->scale.vz**(((short *)dP)+2))/4096;
				dP += 2;
			}
			/* Transfer */
			if(flag&0x08) {
				cparam->trans.vx += *(((long *)dP)+0);
				cparam->trans.vy += *(((long *)dP)+1);
				cparam->trans.vz += *(((long *)dP)+2);
				dP += 3;
			}

			RotMatrix(&(cparam->rotate), coordp);
			ScaleMatrix(coordp, &(cparam->scale));
			TransMatrix(coordp, &(cparam->trans));
		}
		else {
			/* Immediate value: Βl̏ꍇ */

			/* Rotation */
			if(flag&0x02) {
				cparam->rotate.vx = (*(((long *)dP)+0))/360;
				cparam->rotate.vy = (*(((long *)dP)+1))/360;
				cparam->rotate.vz = (*(((long *)dP)+2))/360;
				dP += 3;
				RotMatrix(&(cparam->rotate), coordp);
			}

			/* Scaling */
			if(flag&0x04) {
				cparam->scale.vx = *(((short *)dP)+0);
				cparam->scale.vy = *(((short *)dP)+1);
				cparam->scale.vz = *(((short *)dP)+2);
				dP += 2;
				if(!(flag&0x02))
					RotMatrix(&(cparam->rotate), coordp);
				ScaleMatrix(coordp, &(cparam->scale));
			}
			/* Transfer */
			if(flag&0x08) {
				cparam->trans.vx = *(((long *)dP)+0);
				cparam->trans.vy = *(((long *)dP)+1);
				cparam->trans.vz = *(((long *)dP)+2);
				dP += 3;
				TransMatrix(coordp, &(cparam->trans));
			}
		}
		break;

	    case TOD_TMDID:	/* Link to TMD: TMDƂ̃Nݒ */
		if(tmdTblP != NULL) {
			GsLinkObject4((u_long)TodSearchTMDByID(tmdTblP, tmdIdP,
					(unsigned long)(*dP&0xffff)), objP, 0);

		}
		break;

	    case TOD_PARENT:	/* Set parent: eIuWFNg̐ݒ */
		if(mode != TOD_COORDONLY) {
			if((*dP == NULL)||(*dP == 0xffff)) {
				objP->coord2->super = NULL;
				dP++;
			}
			else {
				parentP = TodSearchObjByID(tblP, *dP++);
				objP->coord2->super = parentP->coord2;
			}
		}
		break;

	    case TOD_OBJCTL:
		/* in the objtable: e[uIuWFNg̊Ǘ */
		if(tblP != NULL) {
			switch(flag) {
			    case 0:
				/* Create new object: VKIuWFNg̐ */
				TodCreateNewObj(tblP, id);
				break;
			    case 1:
				/* Delete object: IuWFNg̍폜 */
				TodRemoveObj(tblP, id);
				break;
			}
		}
		break;

	    case TOD_LIGHT:
		/* Light source control: ̐ݒ */
		if(flag&0x02) {
			if(flag&0x01) {
				pslt[id].vx += *(((long *)dP)+0);
				pslt[id].vy += *(((long *)dP)+1);
				pslt[id].vz += *(((long *)dP)+2);
			}
			else {
				pslt[id].vx = *(((long *)dP)+0);
				pslt[id].vy = *(((long *)dP)+1);
				pslt[id].vz = *(((long *)dP)+2);
			}
			dP += 3;
		}
		if(flag&0x04) {
			if(flag&0x01) {
				pslt[id].r += *(((u_char *)dP)+0);
				pslt[id].g += *(((u_char *)dP)+1);
				pslt[id].b += *(((u_char *)dP)+2);
			}
			else {
				pslt[id].r = *(((u_char *)dP)+0);
				pslt[id].g = *(((u_char *)dP)+1);
				pslt[id].b = *(((u_char *)dP)+2);
			}
			       dP++;
		}
		GsSetFlatLight(id, &pslt[id]);
		break;

	    case TOD_USER0:
		/* Describe user process here
		 : Ƀ[U`pPbg̏Lq  */
		break;
	}
	/* Return next packet addr: ̃pPbgւ̃|C^Ԃ */
	return packetP+len;
}

