/* $PSLibId: Runtime Library Release 3.6$ */
/*				tuto1: OT
 *
 *         Copyright (C) 1993-1995 by Sony Computer Entertainment
 *			All rights Reserved
 *
 *			  simple sample to use OT
 :			nsgp`̃eXg
 */
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>

/*
 * Primitive double buffer.
 * Primitive buffer should be 2 buffers for CPU and GPU.
 : v~eBu_uobt@
 * ` CPU Ŏs邽߂ɂ͂Qg̃obt@Kv
 */	
typedef struct {		
	DRAWENV		draw;		/* Drawing Environment : ` */
	DISPENV		disp;		/* Display Environment	: \ */
	u_long		ot[9];		/* Ordering Table : ns */
	SPRT_16		ball[8][8][8];	/* sprite buffer : XvCg */
					/* Z-direction	: s: W */
					/* X-direction	: :     W */
					/* Y-direction	: c:     W */
} DB;

static void init_prim(DB *db);
static int pad_read(int *dx, int *dy);

main()
{
	DB	db[2];		/* primitive double buffer
				   : v~eBu_uobt@ */
	DB	*cdb;		/* current primitive buffer pointer
				   : ݒpPbgobt@փ|C^ */
	SPRT_16	*bp;		/* work */
	int	ox, oy;		/* work */
	int	dx = 0, dy = 0;	/* work */
	int	depth;		/* work */
	int	x, y;		/* work */
	int	ix, iy;		/* work */

	/* reset controller: Rg[̃Zbg */
	PadInit(0);		
	
	/* reset graphic subsystem: `E\̃Zbg */
	ResetGraph(0);		
	FntLoad(960, 256);	
	SetDumpFnt(FntOpen(16, 16, 256, 64, 0, 512));
	
	/* define frame double buffer :  _uobt@̒` */
	/*	buffer #0:	(0,  0)-(320,240) (320x240)
	 *	buffer #1:	(0,240)-(320,480) (320x240)
	 */
	SetDefDrawEnv(&db[0].draw, 0,   0, 320, 240);
	SetDefDrawEnv(&db[1].draw, 0, 240, 320, 240);
	SetDefDispEnv(&db[0].disp, 0, 240, 320, 240);
	SetDefDispEnv(&db[1].disp, 0,   0, 320, 240);

	/* set primitive members of each buffer
	   : ꂼ̃v~euobt@̓ȅlݒ */
	init_prim(&db[0]);	/* pPbgobt@ # 0 */
	init_prim(&db[1]);	/* pPbgobt@ # 1 */

	/* display enable : \Jn */
	SetDispMask(1);

	/* main loop : C[v */
	while (pad_read(&dx, &dy) == 0) {

		/* swap db[0], db[1]: _uobt@|C^̐؂ւ */
		cdb = (cdb==db)? db+1: db;

		/* clear ordering table (8 entry)
		   : ns iGgWj*/
		ClearOTag(cdb->ot,8);

		/* calculate postion of sprites : XvCg̈ʒuvZ */
		for (depth = 0; depth < 8; depth++) {
			/* Far sprites move slowly, and near sprites
			 * move fast.
			 : ̃XvCgقǒxA
			 * ߂̃XvCgقǑ悤ɐݒ
			 */
			/* left upper corner (Y): Wl (Y) */
			oy =  56 + dy*(depth+1);	
			
			/* left upeer corner (X): Wl (X) */
			ox =  96 + dx*(depth+1);	
 			for (iy = 0, y = oy; iy < 8; iy++, y += 16) 
			for (ix = 0, x = ox; ix < 8; ix++, x += 16) {

				bp = &cdb->ball[depth][iy][ix];

				/* set upper-left corner of sprites
				   : XvCg̉E_w */
				setXY0(bp, x, y);

				/* add primitives to OT
				   ot[depth+1] ɓo^ */
				AddPrim(&cdb->ot[depth], bp);
			}
		}
		/* wait for previous 'DrawOTag' 
		   : obNOEhőĂ`̏I҂ */
		DrawSync(0);

		/* wait for next V-BLNK
		   : V-BLNK ̂҂ */
		VSync(0);

		/* swap frame double buffer:
		 *  set the drawing environment and display environment.
		 : t[_uobt@
		 * JgpPbgobt@̕`E\ݒ肷B
		 */
		PutDrawEnv(&cdb->draw);
		PutDispEnv(&cdb->disp);

		/* start Drawing
		   : ns̃v~eBuobNOEhŕ`悷B*/
		DrawOTag(cdb->ot);
		FntPrint("tuto1: OT\n");
		FntFlush(-1);
	}
        PadStop();
	ResetGraph(1);
	StopCallback();
	return;
}

/* Intitalize the members of primitives in each primitive-buffer.
 * All of unchanged parameters are set here.
 : v~eBu_uobt@̊eȍ
 * C[vŕύXȂׂ̂͂Ăł炩ߐݒ肵ĂB
 */	
/* DB	*db;	v~eBuobt@ */
static void init_prim(DB *db)
{
	/* 16x16 ball texture pattern: 16x16 eNX`p^[i{[j*/
	extern u_long	ball16x16[];	
	
	/* ball CLUT (16 colorsx32):  {[ CLUT (16Fx32) */
	extern u_long	ballclut[][8];	

	SPRT_16	*bp;
	u_short	clut;
	int	depth, x, y;

	/* Translate 4bit-texture pattern to (640, 0) on the frame-buffer
	 * and set the default texture page.
	 : 4bit [h̃{[̃eNX`p^[t[obt@
	 * ]B̎̃eNX`y[WftHgeNX`y[W
	 * ݒ肷B	 
	 */	 
	db->draw.tpage = LoadTPage(ball16x16, 0, 0, 640, 0, 16, 16);

	/* background clear enable : wiNA[hɂ */
	/* wiNA[hɂ */
	db->draw.isbg = 1;
	/* : wiF̐ݒ */
	setRGB0(&db->draw, 60, 120, 120);	

	/* Initialize 8x8x8=256 sprites at this point.
	 * CLUT of each texture is changed accroding to the sprites' depth.
	 : 8x8x8=256 ̃XvCg܂Ƃ߂ďB
	 * CLUT ́AsɉĐؑւB	 
	 */	 
	for (depth = 0; depth < 8; depth++) {
		/* load CLUT on frame buffer (notice the CLUT address)
		   : CLUT [h CLUT [hAhXɒ */
		clut = LoadClut(ballclut[depth], 0, 480+depth);

		/* Unchanged members of primitives are set here 
		   : v~eBũoŕωȂ̂Őݒ肷B*/
		for (y = 0; y < 8; y++) 
			for (x = 0; x < 8; x++) {
				bp = &db->ball[depth][y][x];
			
				/* SPRT_16 primitve: 16x16̃XvCg */
				SetSprt16(bp);		
			
				/* ShadeTex disable: VF[fBO֎~ */
				SetShadeTex(bp, 1);	
			
				/* (u0,v0) = (0, 0) */
				setUV0(bp, 0, 0);	
			
				/* set texture CLUT ID: eNX`CLUT ID  */
				bp->clut = clut;	
			}
	}
}

/*: Rg[̉
 */
/* int	*dx;	XvCg̍Wl̃L[[hiwj */
/* int	*dy;	XvCg̍Wl̃L[[hixj */

static int pad_read(int *dx, int *dy)
{
	/* get controller value: Rg[f[^ǂݍ */
	u_long	padd = PadRead(1);	

	/* exit program: vȌI */
	if (padd & PADselect)	return(-1);

	/* move sprite position: XvCg̈ړ */
	if (padd & PADLup)	(*dy)--;
	if (padd & PADLdown)	(*dy)++;
	if (padd & PADLleft)	(*dx)--;
	if (padd & PADLright)	(*dx)++;

	return(0);
}

