/* $PSLibId: Runtime Library Release 3.6$ */
/* 			tuto8: 1D scroll
 *
 *         Copyright (C) 1993-1995 by Sony Computer Entertainment
 *			All rights Reserved
 *
 *		    Sample of 1-D BG scroll
 :		   1D XN[ BG ̎
 */
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>

/* depth of OT is 8: I[_Oe[u̐[́AW */
#define OTSIZE		8

/* 
 * Sprite primiteives have no texture page member. 
 * We define new primitive type which has a texture pages.
 : ʏ̃XvCǵAeNX`y[WȂ̂ŁAŁA
 * VeNX`y[WtXvCg`B
 */
typedef struct {
	DR_MODE	mode;	/* mode primitive: [hݒv~eBu */
	SPRT	sprt;	/* sprite primitive: XvCg v~eBu */
} TSPRT;

/* Structures which contains a information about texture location.
   : eNX`֌W̏W߂\ */

typedef struct {
	/* texture address on main memory: eNX`p^[AhX */
	u_long	*addr;	
	
	/* texture addres on frame buffer: eNX`p^[[hꏊ*/
	short	tx, ty;	
	
	/* texture address on frame buffer: eNX` CLUT [hꏊ */
	short	cx, cy;	
	
	/* texture page ID: eNX`y[W ID iォvZj*/
	u_short	tpage;	
	
	/* texture CLUT ID: eNX` CLUT ID iォvZj*/
	u_short	clut;	
} TEX;

/* primitive double buffer :v~eBu_uobt@ */
typedef struct {
	DRAWENV		draw;		/* drawing environment: ` */
	DISPENV		disp;		/* display environment: \ */
	u_long		ot[OTSIZE];	/* OT: I[_Oe[u */
	TSPRT		far0, far1;	/* far mountains: ̎RX */
	TSPRT		near0, near1;	/* near mountains: ߂̎RX */
	TSPRT		window;		/* train window: dԂ̑ */
} DB;

static int update(DB *db,int padd);
static void add_sprite(u_long *ot,TSPRT *tsprt,
			int x0,int y0,int u0,int v0,int w,int h,TEX *tex);
static int SetTSprt(TSPRT *tsprt,int dfe,int dtd,int tpage,RECT *tw);

main()
{
	/* packet double buffer: pPbg_uobt@ */
	DB		db[2];		
							  
	/* current burrer: ݂̃obt@AhX */
	DB		*cdb;		
	
	/* controller data: Rg[pbh̃f[^ */
	int	padd;		

	/* reset controller: Rg[̃Zbg */
	PadInit(0);             
	
	/* reset graphic system: `E\̃Zbg */
	ResetGraph(0);		
	
	/* set debug mode: fobO[h̐ݒ */
	SetGraphDebug(0);	

	/* eNX`f[^t[obt@ɓ] */
	load_tex();		

	/* set double buffer environment: _uobt@p̊ݒ */
	/*	buffer #0:	(0,  0)-(255,239) (256x240)
	 *	buffer #1:	(0,240)-(255,479) (256x240)
	*/
	SetDefDrawEnv(&db[0].draw, 0,   0, 256, 240);
	SetDefDrawEnv(&db[1].draw, 0, 240, 256, 240);
	SetDefDispEnv(&db[0].disp, 0, 240, 256, 240);
	SetDefDispEnv(&db[1].disp, 0,   0, 256, 240);
	db[0].draw.isbg = db[1].draw.isbg = 1;

	SetDispMask(1);		/* \Jn */

	while (((padd = PadRead(1)) & PADselect) == 0) {

		/* swap double buffer ID: db[0], db[1]  */
		cdb = (cdb==db)? db+1: db;	

		/* update coordinates: WAbvf[g */
		update(cdb, padd);		

		DrawSync(0);	/* wait for end of drawing: `̏I҂ */
		VSync(0);	/* wait for VBLNK: ҂ */

		/* swap double buffer: _uobt@̐ؑւ */
		PutDrawEnv(&cdb->draw);	/* update DRAWENV: `̍XV */
		PutDispEnv(&cdb->disp);	/* update DISPENV: \̍XV */
		DrawOTag(cdb->ot);	/* draw: ` */
	}

	/* quit: I */
	PadStop();	
	ResetGraph(1);
	StopCallback();
	return;
}

/* 
 * 5 8bit texture pages are used here.
 * Both Polygons used for far-landscape and close-landscape use 256x256
 * These pages are used for far landscae, near landescape and train window.
 * 2 pages (512x256) are used for each landscape. 1 page is used for
 * train window.
 * Each landscape is rap-rounded by 512 pixel.
 * Details of the sprite is as follows:
 : eNX`y[W͂Tgpi8bit [h)
 * iAߌiƂA256x256 QɂȂׂĂ̈ꕔ\B
 * iF̓bvEhB
 * ey[W̓e͈ȉ̒ʂ
 */
extern u_long far0[];		/* far mountains(left):   ̎RX()*/
extern u_long far1[];		/* far mountains(right):  ̎RX(E)*/
extern u_long near0[];		/* near mountains(left):  ߂̎RX()*/
extern u_long near1[];		/* near mountains(right): ߂̎RX(E)*/
extern u_long window[];		/* train window: DԂ̑ */

/* define ID to every textures: eeNX`ɒʂԍ`B*/
#define TEX_FAR0	0
#define TEX_FAR1	1
#define TEX_NEAR0	2
#define TEX_NEAR1	3
#define TEX_WINDOW	4

/* Initial value of the texture structure: eNX`\̂̏l */
static TEX tex[] = {
	/*addr   tx   ty cx   cy tpage clut			*/
	/*--------------------------------------------------------------*/ 
	far0,   512,   0, 0, 481,    0,   0,	/* far0    */ 
	far1,   512, 256, 0, 482,    0,   0,	/* far1    */ 
	near0,  640,   0, 0, 483,    0,   0,	/* near0   */ 
	near1,  640, 256, 0, 484,    0,   0,	/* near1   */ 
	window, 768,   0, 0, 485,    0,   0,	/* window  */ 
	0,					/* terminator: I[ */
};

/* Load all texture data to V-RAM at once.
   : eNX`y[W܂Ƃ߂ăt[obt@֓]B*/
load_tex(void)
{
	int	i;

	/* loop while addr is not 0 : 'addr'  0 łȂ胋[v */
	for (i = 0; tex[i].addr; i++) {	

		/* Load texture pattern : eNX`p^[[h */
		tex[i].tpage = LoadTPage(tex[i].addr+0x80, 1, 0,
					 tex[i].tx, tex[i].ty,  256, 256);
		
		/* Load texture clut : eNX` CLUT [h */
		tex[i].clut = LoadClut(tex[i].addr, tex[i].cx, tex[i].cy);
	}
}

/* Read controller and update the scroll parameters*
   : Rg[pbhǂŃXN[̃p[^肷B*/

/* DB	*db,	primitive buffer: v~eBuobt@ */
/* int	padd	controller data:  Rg[̃f[^ */
static int update(DB *db, int padd)
{
	
	static int 	ofs_x = 0;	/* position: ïړ */
	static int	v     = 0;	/* verosicy: ړx */
	
	/* texture: eNX`f[^ */
	TEX	*tp[2];			
	
	/* direction 0:right to left, 1:reverse: ړ 0:E, 1:E */
	int	side;			
	
	/* flag to disaplay near mountains: ߌi\ 1:, else:Ȃ */
	int	isnear   = 1;		
	
	/* flag to display window:  ̕\ 1:, else:Ȃ */
	int	iswindow = 1;		
	
	int	d;

	/* update speed: Rg[̉ */
	if (padd & PADLright)	v++;	/* speed up: Xs[hAbv */
	if (padd & PADLleft)	v--;	/* speed down: Xs[h_E */
	ofs_x += v;			/* total amount: ړʂ̗ݐςƂ */

	/* if needed, it is surpressed to display landscapes or a window.  
	   : ꍇɂẮAߌiADԂ̑̕\֎~B*/
	if (padd & PADR1)	isnear   = 0;
	if (padd & PADL1)	iswindow = 0;

	/* clear OT: ns̃NA */
	ClearOTag(db->ot, OTSIZE);

	/* display far landscape. (The period of rap-round is 512 pixel) 
	   : ̎RX\BiF͉ 512 ŃbvEh */
    display_far:

	side = (ofs_x/4)&0x100;	/* decide L->R or R->L: \ */
	d    = (ofs_x/4)&0x0ff;	/* limited between 0-256:
				   ړʂ 256 ŐK */

	/* Put TSPRT primite into OT.
	 * The scroll is achived by changing (u0,v0) not (x0, y0).
	 * Left primitive draws the area of (0,0)-(256-d,240)
	 * Right primitive draws the area of (256-d,0)-(256,240)
	 * 'd' is valid according to the  scroll position.
	 *
	 : TSPRT  nsɓo^֐R[ 
	 * x0, y0 ł͂ȂAu0, v0 𓮂ăXN[sȂ
	 * Ëꖇ́A (256-d,0)-(256,240) S
	 * ̈ꖇ́A (0, 0)-(256-d,240) SB
	 */
	tp[0] = &tex[side==0? TEX_FAR0: TEX_FAR1];	/* right hand */
	tp[1] = &tex[side==0? TEX_FAR1: TEX_FAR0];	/* left hand */

	add_sprite(db->ot, &db->far0, 0,     16, d, 0, 256-d, 168, tp[0]);
	add_sprite(db->ot, &db->far1, 256-d, 16, 0, 0, d,     168, tp[1]);

	/* Display near landscape.( The cycle of lap-round is 512 pixel  
	   : ߂̎RX\BiF͉ 512 ŃbvEh */
    display_near:
	if (isnear == 0) goto display_window;

	side = (ofs_x/2)&0x100;	
	d    = (ofs_x/2)&0x0ff;

	tp[0] = &tex[side==0? TEX_NEAR0: TEX_NEAR1];
	tp[1] = &tex[side==0? TEX_NEAR1: TEX_NEAR0];

	add_sprite(db->ot+1, &db->near0, 0,     32, d, 0, 256-d, 168, tp[0]);
	add_sprite(db->ot+1, &db->near1, 256-d, 32, 0, 0, d,     168, tp[1]);

	/* draw window: ` */
    display_window:
	if (iswindow == 0) return;

	add_sprite(db->ot+2,
		   &db->window, 0, 0, 0, 0, 256, 200, &tex[TEX_WINDOW]);
}

/* Put TSPR primitive into OT : TSPRT nsɓo^ */
/* u_long *ot,	  OT: OT */
/* TSPRT  *tsprt, TSPRT primitive: o^eNX`XvCgv~eBu */
/* int	  x0,y0	  left-upper corner of TSPRT: XvCg̍Wl */
/* int	  u0,v0	  left-upper corner of TSPRT(U): eNX`̍Wlij*/
/* int	  w,h	  size of texture pattern: eNX`̃TCY*/
/* TEX	  *tex	  texture attributes: eNX`f[^ */

static void add_sprite(u_long *ot,TSPRT *tsprt,
			int x0,int y0,int u0,int v0,int w,int h,TEX *tex)
{
	/* initialize TSPRT primitive: TSPRT v~eBu */
	SetTSprt(tsprt, 1, 1, tex->tpage, 0);

	/* shading off: VF[fBOIt */
	SetShadeTex(&tsprt->sprt, 1);	
	
	/* set left-upper corner point of (x,y): XvCg̍Wl */
	setXY0(&tsprt->sprt, x0, y0);	
	
	/* set left-upper corner point of (u,v): eNX`̍Wl */
	setUV0(&tsprt->sprt, u0, v0);	
	
	/* set size of sprite: XvCg̃TCY */
	setWH(&tsprt->sprt, w, h);	
	
	/* set CLUT ID: eNX`CLUT ID */
	tsprt->sprt.clut = tex->clut;	

	/* add to OT: OT ɓo^ */
	AddPrim(ot, &tsprt->mode);	
}

/* TSPRT *tsprt, TSPRT pointer: lZbg TSPRT \̂ւ̃|C^ */
/* int	 dfe,	 same as DRAWENV.dfe: \̈ւ̕`  0:sA1: */
/* int	 dtd,	 same as DRAWENV.dtd: fBU  0:ȂA1: */
/* int	 tpage,	 texture page: eNX`y[W */
/* RECT	 *tw	 texture window: eNX`EBhE */

static int SetTSprt(TSPRT *tsprt,int dfe,int dtd,int tpage,RECT *tw)
{
	/* initialize MODE primitive: MODE v~eBu */
 	SetDrawMode(&tsprt->mode, dfe, dtd, tpage, tw);

	/* initialize SPRT primitive: SPRT v~eBu */
	SetSprt(&tsprt->sprt);

	/* Merge 2 primitives to one.
	 * Merging primitives should be located on the continuous
	 * memory area.
	 * The total size of 2 primitives must be under 16 words.
	 : Q̃v~eBu}[WB
	 * }[Wv~eBúA̘ÄɒuȂ
	 *  ͂ȂB}[Wv~eBũTCY 16 [hȉ
	 */
	if (MargePrim(&tsprt->mode, &tsprt->sprt) != 0) {
		printf("Marge failed!\n");
		return(-1);
	}
	return(0);
}

