/*
 * $PSLibId: Runtime Library Release 3.6$
 */
/*
 *          Movie Sample Program
 *
 *      Copyright (C) 1994,5 by Sony Corporation
 *          All rights Reserved
 *
 *  CD-ROM 烀[r[Xg[~OTv
 *
 *   Version    Date
 *  ------------------------------------------
 *  1.00        Jul,14,1994     yutaka
 *  1.10        Sep,01,1994     suzu
 *  1.20        Oct,24,1994     yutaka(anim subroutine)
 *  1.30        Jun,02,1995     yutaka(㏈)
 *  1.40        Jul,10,1995     masa(imgbuf_uobt@)
 *  1.50        Jul,20,1995     ume(ʃNA)
 *  1.50a	Aug,03,1996     yoshi (for overlay)
 *  1.50b	Mar,04,1996     yoshi (added English comments)
 *====================================================================
 *    This was rewritten as a child process. Compile conditionally with OVERLAY.
 *    Called while parent is emitting sound.
 *    Playback is performed at 24bits. :
 * qvZXpɏBOVERLAYŏRpCB
 * eŃTEh炵܂܂̏ԂŌĂ΂B
 * Đ 24bit  ōsĂB
 */

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libcd.h>
#include <r3000.h>
#include <asm.h>
#include <kernel.h>


#define FILE_NAME   "\\DATA\\MOV.STR;1"
#define START_FRAME 1
#define END_FRAME   577
#define POS_X       36
#define POS_Y       24
#define SCR_WIDTH   320
#define SCR_HEIGHT  240

/*
 *  specification of the number of colors to decode (16bit/24bit) : 
 *  fR[hF̎w(16bit/24bit)
 */
#define IS_RGB24    1   /* 0:RGB16, 1:RGB24 */
#if IS_RGB24==1
#define PPW 3/2     /* how many pixels in 1 short word? : 
                       PV[g[hɉsNZ邩 */
#define DCT_MODE    3   /* decode in 24bit mode : 24bit [hŃfR[h */
#else
#define PPW 1       /* how many pixels in 1 short word? : 
                       PV[g[hɉsNZ邩 */
#define DCT_MODE    2   /* decode in 16 bit mode : 16bit [hŃfR[h */
#endif

/*
 *  decode environment variable : fR[hϐ
 */
typedef struct {
    u_long  *vlcbuf[2]; /* VLC buffer (double buffer) : VLC obt@i_uobt@j */
    int vlcid;      /* Cureent buffer ID for VLC decode operation : 
                        VLC fR[hobt@ ID */
    u_short *imgbuf[2]; /* decode image buffer (double buffer) : 
                           fR[h摜obt@i_uobt@j*/
    int imgid;      /* ID of image buffer being used currently : 
                       ݎgp̉摜obt@ID */
    RECT    rect[2];    /* coordinates on VRAM (double buffer) : 
                           VRAMWli_uobt@j */
    int rectid;     /* area retrieved for one DecDCTout : ݓ]̃obt@ ID */
    RECT    slice;      /* area retrieved for one DecDCTout : 
                           P DecDCTout Ŏö */
    int isdone;     /* is one frame's worth of data prepared? : 
                       Pt[̃f[^ł */
} DECENV;
static DECENV   dec;        /* actual decode environment : 
                               fR[h̎ */

/*
 * ring buffer for streaming
 * stocks data from the CD-ROM
 * reserve capacity for at least 2 frames' worth
 *  Xg[~OpOobt@
 *  CD-ROM̃f[^XgbN
 *  ŒQt[̗eʂmۂB
 */
#define RING_SIZE   32      /* Pʂ̓ZN^ */
static u_long   Ring_Buff[RING_SIZE*SECTOR_SIZE];

/*
 *  VLC buffer (double buffer)
 *  stock intermediate data after VLC decoding
 *  VLCobt@i_uobt@j
 *  VLCfR[h̒ԃf[^XgbN
 */
#define VLC_BUFF_SIZE 320/2*256     /* Ƃ肠[ȑ傫 */
static u_long   vlcbuf0[VLC_BUFF_SIZE];
static u_long   vlcbuf1[VLC_BUFF_SIZE];

/*
 * image buffer (double buffer)
 * stock image data from after DCT decoding
 * decode and transfer for rectangles 16 pixels wide
 *  C[Wobt@i_uobt@j
 *  DCTfR[h̃C[Wf[^XgbN
 *  16sNZ̋`ɃfR[h]
 */
#define SLICE_IMG_SIZE 16*PPW*SCR_HEIGHT
static u_short  imgbuf0[SLICE_IMG_SIZE];
static u_short  imgbuf1[SLICE_IMG_SIZE];
    
/*
 *  other variables : ̑̕ϐ
 */
static int  StrWidth  = 0;  /* size of movie image (horizontal and vertical) : 
                               [r[摜̑傫iƏcj */
static int  StrHeight = 0;  
static int  Rewind_Switch;  /* end flag: set to 1 when playback has reached a specified frame : 
                               ItO:̃t[܂ōĐƂPɂȂ */

/*
 *  function prototype declaration : ֐̃vg^Cv錾
 */
static void anim();
static void strSetDefDecEnv(DECENV *dec, int x0, int y0, int x1, int y1);
static void strInit(CdlLOC *loc, void (*callback)());
static void strCallback();
static void strNextVlc(DECENV *dec);
static void strSync(DECENV *dec, int mode);
static u_long *strNext(DECENV *dec);
static void strKickCD(CdlLOC *loc);

#ifdef OVERLAY
child_anim()
#else
main()
#endif
{
    RECT rct;

    /* initialization other than animation are all the same : 
       Aj[V ȊO ʂ̏ */
#ifdef OVERLAY
/* some tricks are used to allow smooth screen translation : 
   ʐ؂ւX[Yɍs悤ɏHvĂ */
    VSync(0);
    SetDispMask(0);
    ResetGraph(1);
    setRECT(&rct,0,0,1024,512);
    ClearImage(&rct,0,0,0);
    DrawSync(0);
#else
    ResetCallback();
    CdInit();
    PadInit(0);     /* reset PAD : PAD Zbg */
    ResetGraph(0);      /* reset GPU : GPU Zbg */
    SetGraphDebug(0);   /* set debug level : fobOxݒ */
#endif
    
    anim();     /* animation subroutine : Aj[VTu[` */

	return(0);
}


/*
 *  animation subroutine foreground process : 
 *  Aj[VTu[` tHAOEhvZX
 */
static void anim()
{
    DISPENV disp;       /* display buffer : \obt@ */
    DRAWENV draw;       /* drawing buffer : `obt@ */
    int id;     /* ID of display buffer : \obt@ ID */
    CdlFILE file;
    
    /* search file : t@CT[` */
    if (CdSearchFile(&file, FILE_NAME) == 0) {
        printf("file not found\n");
        StopCallback();
        PadStop();
        exit();
    }
    
    /* set coordinates on VRAM : VRAM̍Wlݒ */
    strSetDefDecEnv(&dec, POS_X, POS_Y, POS_X, POS_Y+SCR_HEIGHT);

    /* initalize and begin streaming : Xg[~OJn */
    strInit(&file.pos, strCallback);
    
    /* peform VLC decoding of the initial frame : 
       ŏ̃t[ VLCfR[hsȂ */
    strNextVlc(&dec);
    
    Rewind_Switch = 0;
    
    while (1) {
        /* DCT encoding is begun on the data for which VLC has been completed 
           (send to MDEC) : 
           VLC̊f[^DCTGR[hJniMDEC֑Mj */
        DecDCTin(dec.vlcbuf[dec.vlcid], DCT_MODE);
        
        /* prepare to receive DCT decode results*/
        /* processing after this is performed with call back routines : 
           DCTfR[hʂ̎M̏            
             ̌̏̓R[obN[`ōsȂ */
        DecDCTout(dec.imgbuf[dec.imgid], dec.slice.w*dec.slice.h/2);
        
        /* VLC decoding of the data for the next frame : 
           ̃t[̃f[^ VLC fR[h */
        strNextVlc(&dec);
        
        /* wait for decoding of one frame to finish :
           Pt[̃fR[hÎ҂ */
        strSync(&dec, 0);
        
        /* wait for V-BLNK : V-BLNK ҂ */
        VSync(0);
        
        /* swap display buffer  
           note that the display buffer is the reverse of the buffer being decoded :
           \obt@Xbv                                
             \obt@̓fR[hobt@̋tł邱Ƃɒ */
        id = dec.rectid? 0: 1;
        SetDefDispEnv(&disp, 0, (id)*240, SCR_WIDTH*PPW, SCR_HEIGHT);
/*      SetDefDrawEnv(&draw, 0, (id)*240, SCR_WIDTH*PPW, SCR_HEIGHT);*/
        
#if IS_RGB24==1
        disp.isrgb24 = IS_RGB24;
        disp.disp.w = disp.disp.w*2/3;
#endif
        PutDispEnv(&disp);
/*      PutDrawEnv(&draw);*/
        SetDispMask(1);     /* display permission : \ */
        
        if(Rewind_Switch == 1)
            break;
        
        if(PadRead(1) & PADk)   /* exit animation if the stop button is pressed : 
                                   Xgbv{^ꂽAj[V
                       𔲂 */
            break;
    }
    
    
    /* post-processing of animation :
       Aj[V㏈ */
    DecDCToutCallback(0);
    StUnSetRing();
    CdControlB(CdlPause,0,0);
}


/*
 *    initialize decode environment
 *  the transfer coordinates of the image decoded from x0,y0 (buffer 0)
 *  the transfer coordinates of the image decoded from x1,y1 (buffer 1)
 * fR[h
 *  x0,y0 fR[h摜̓]Wiobt@Oj
 *  x1,y1 fR[h摜̓]Wiobt@Pj
 *
 */
static void strSetDefDecEnv(DECENV *dec, int x0, int y0, int x1, int y1)
{

    dec->vlcbuf[0] = vlcbuf0;
    dec->vlcbuf[1] = vlcbuf1;
    dec->vlcid     = 0;

    dec->imgbuf[0] = imgbuf0;
    dec->imgbuf[1] = imgbuf1;
    dec->imgid     = 0;

    /* the width/height of rect[] is set from the STR data values :
       rect[]̕^STRf[^̒lɂăZbg */
    dec->rect[0].x = x0;
    dec->rect[0].y = y0;
    dec->rect[1].x = x1;
    dec->rect[1].y = y1;
    dec->rectid    = 0;

    dec->slice.x = x0;
    dec->slice.y = y0;
    dec->slice.w = 16*PPW;

    dec->isdone    = 0;
}


/*
 * initialize streming environment and begin : 
   Xg[~OĊJn
 */
static void strInit(CdlLOC *loc, void (*callback)())
{
    /* reset MDEC : MDEC Zbg */
    DecDCTReset(0);

    /* define call back for when MDEC has processed one decode block :
       MDECPfR[hubÑR[obN` */
    DecDCToutCallback(callback);
    
    /* set ring buffer : 
       Oobt@̐ݒ */
    StSetRing(Ring_Buff, RING_SIZE);
    
    /* set up streaming  
       set final frame = infinity :
       Xg[~OZbgAbv   
        It[=ɐݒ   */
    StSetStream(IS_RGB24, START_FRAME, 0xffffffff, 0, 0);
    
    
    /* begin streaming read : 
       Xg[~O[hJn */
    strKickCD(loc);
}


/*
 *    background process
 *  (call back function that is called when DecDCTout() is finished) :
 *  obNOEhvZX 
 *  (DecDCTout() IɌĂ΂R[obN֐)
 */
static void strCallback()
{
#if IS_RGB24==1
    extern StCdIntrFlag;
    if(StCdIntrFlag) {
        StCdInterrupt();    /* run here if RGB24 : RGB24̎͂ŋN */
        StCdIntrFlag = 0;
    }
#endif
    
    /* transfer decode results to the frame buffer :
       fR[hʂt[obt@ɓ] */
    LoadImage(&dec.slice, (u_long *)dec.imgbuf[dec.imgid]);
    
    /* switch image decode area :
       摜fR[ḧ̐ؑւ */
    dec.imgid = dec.imgid? 0:1;

    /* update slice (rectangular strip) area to next one on the right :
       XCXiZ`j̈ЂƂEɍXV */
    dec.slice.x += dec.slice.w;
    
    /* any remaining slices? :
       c̃XCX邩H */
    if (dec.slice.x < dec.rect[dec.rectid].x + dec.rect[dec.rectid].w) {
	    /* begin decoding next slice : 
           ̃XCXfR[hJn */
        DecDCTout(dec.imgbuf[dec.imgid], dec.slice.w*dec.slice.h/2);
    }
    /* final slice = 1 frame completed : ŏIXCXPt[I */
    else {
        /* indicate completion : IƂʒm */
        dec.isdone = 1;
        
        /* update transfer coordinates : ]WlXV */
        dec.rectid = dec.rectid? 0: 1;
        dec.slice.x = dec.rect[dec.rectid].x;
        dec.slice.y = dec.rect[dec.rectid].y;
    }
}


/*
 *  perform VLC decoding
 *  perform VLC decoding for next frame :
 *  VLCfR[h̎s
 *  1t[̃f[^VLCfR[hsȂ
 */
static void strNextVlc(DECENV *dec)
{
    int cnt = WAIT_TIME;
    u_long  *next;
    static u_long *strNext();


    /* retrieve one frame's worth of data : f[^Pt[o */
    while ((next = strNext(dec)) == 0) {
        if (--cnt == 0)
            return;
    }
    
    /* switch VLC decode area : VLCfR[ḧ̐ؑւ */
    dec->vlcid = dec->vlcid? 0: 1;

    /* VLC decode : VLCfR[h */
    DecDCTvlc(next, dec->vlcbuf[dec->vlcid]);

    /* free up frame area of ring buffer : 
       Oobt@̃t[̗̈ */
    StFreeRing(next);

    return;
}

/*
 *    retrieve data from the ring buffer
 *    (return value)      normal completion = starting address of ring buffer
 *    error occurred = NULL
 *  Oobt@̃f[^̎o
 *  iԂlj  IOobt@̐擪AhX
 *          G[NULL
 */
static u_long *strNext(DECENV *dec)
{
    u_long      *addr;
    StHEADER    *sector;
    int     cnt = WAIT_TIME;


    /* retrieve data (with timeout) :  
       f[^oi^CAEgtj */  
    while(StGetNext((u_long **)&addr,(u_long **)&sector)) {
        if (--cnt == 0)
            return(0);
    }

    /* if current frame number is the specified value, then end :   
       ݂̃t[ԍwlȂI  */   
    if(sector->frameCount >= END_FRAME) {
        Rewind_Switch = 1;
    }
    
    /* if the resolution of the frame is different from that of the previous frame,
          perform ClearImage : 
       ʂ̉𑜓x Õt[ƈႤȂ ClearImage s */
    if(StrWidth != sector->width || StrHeight != sector->height) {
        
        RECT    rect;
        setRECT(&rect, 0, 0, SCR_WIDTH * PPW, SCR_HEIGHT*2);
        ClearImage(&rect, 0, 0, 0);
        
        StrWidth  = sector->width;
        StrHeight = sector->height;
    }
    
    
    /* change decode environment to match the STR format header :
       STRtH[}bg̃wb_ɍ킹ăfR[hύX */
    dec->rect[0].w = dec->rect[1].w = StrWidth*PPW;
    dec->rect[0].h = dec->rect[1].h = StrHeight;
    dec->slice.h   = StrHeight;
    
    return(addr);
}


/*
 *  wait for the decoding of one frame to finish
 *  monitor time and check for a timeout
 *  Pt[̃fR[hI҂
 *  ԂĎă^CAEg`FbN
 */
static void strSync(DECENV *dec, int mode /* VOID */)
{
    volatile u_long cnt = WAIT_TIME;

    /* wait until the background process sets 'is done' :      
       obNOEhvZXisdone𗧂Ă܂ő҂ */      
    while (dec->isdone == 0) {
        if (--cnt == 0) {
            /* timeout:  forcibly switch : timeout: Iɐؑւ */
            printf("time out in decoding !\n");
            dec->isdone = 1;
            dec->rectid = dec->rectid? 0: 1;
            dec->slice.x = dec->rect[dec->rectid].x;
            dec->slice.y = dec->rect[dec->rectid].y;
        }
    }
    dec->isdone = 0;
}


/*
 *  begin streaming the CDROM from the specified position :
 *  CDROMwʒuXg[~OJn
 */
static void strKickCD(CdlLOC *loc)
{
 loop:
  /* Seek the target position : ړIn܂ Seek  */
  while (CdControl(CdlSetloc, (u_char *)loc, 0) == 0);
    
    /* add streaming mode and issue the command : 
       Xg[~O[hǉăR}hs */
  if(CdRead2(CdlModeStream|CdlModeSpeed|CdlModeRT) == 0)
    goto loop;
}

