
#include <r3000.h>
#include <asm.h>
#include <kernel.h>
#include <sys/file.h>
#include <sys/types.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libetc.h>
#include <libcd.h>
#include <libmath.h>


/*****************************************************************************/
/*** basic linear interpolation function *************************************/
/*** that uses integer math (that doesn't work)*******************************/
/*****************************************************************************/

int get_inter_point_int(int frame,int start_point,int end_point,int start_frame,int end_frame)
{
int t;

t= ((frame-start_frame)*(4096))/(end_frame-start_frame);

return  ( ((4096-t)/4096)*frame) + ((t*end_point)/4096);
}

/****************************************************************************/




/****************************************************************************/
/* this function returns the size of each step to get from 0 to 4096 in     */
/* equal size steps                                                         */
/****************************************************************************/
int vince_calc_stepsize(int steps)
{
return 4096/steps;
}
/****************************************************************************/

/****************************************************************************/
/*this function can be used with the function above to calclate a position  */
/*between point1 and point2 for step (fraction of 4096) generated by the    */
/* vince_calc_stepsize() function                                           */
/****************************************************************************/
int vince_inter_point(int point1,int point2,int step)
{
return point1+ ( (step*(point2-point1)) >>12);
}
/****************************************************************************/












/****************************************************************************/
/* this function returns the size of each step to get from 0 to 2048 in     */
/* equal size steps                                                         */
/****************************************************************************/
int sin_calc_stepsize(int steps)
{
return 2048/steps;
}
/****************************************************************************/


/****************************************************************************/
/* this function returns a step based on the sine curve from -1 to plus 1 to*/
/* give a nice set of dynamics                                              */
/****************************************************************************/
int sin_inter_point(int point1,int point2,int step)
{
/* from -90 to +90   -1024 + 1024*/
/* so sin = -4096 to + 4096 */
int sstep;


/*get sstep in the range 0..4096 */
sstep = ((rsin(step-1024))+4096);

sstep = sstep>>1;


return point1+ ((sstep*(point2-point1))>>12);

}
/****************************************************************************/

