/*****************************************************************************/
/*****************************************************************************/
/******** Developer Conference : Simple Game Demo               **************/
/*****************************************************************************/
/*****************************************************************************/
/* sound.c*/


/* dc5/3/96*/

#include <sys/types.h>
#include <libetc.h>
#include <libsnd.h>
#include <libsn.h>

#define VH_ADDR 0x80045000
#define VB_ADDR 0x80050000

short gVAB;




/******************************************************************************/
/* init the sound system including the reverb                                 */
/******************************************************************************/
void initialise_sound()
    {
    SsInit();									/* reset sound system */
    SsSetTickMode(SS_TICKVSYNC);				/* set tick mode = 1/240s */
    SsStart();									/* start sound system */
    SsUtSetReverbType(SS_REV_TYPE_HALL);
    SsUtSetReverbDepth( 20, 20 );
    SsUtReverbOn();
    
    SsSetMVol(127, 127);						/* set main volume */
    }
/******************************************************************************/



/******************************************************************************/
/* load the vab (sfx file from main ram to spu)                               */
/******************************************************************************/

void load_vab(unsigned char* head_buffer,unsigned char* body_buffer)
{
short gVAB;

/* Load sound effects VAB file */ 	

gVAB = SsVabOpenHead ((u_char *)head_buffer, -1);
if (gVAB < 0) 
	{
   printf ("Load VAB file - SsVabOpenHead : failed\n");
   return;
   }

if (SsVabTransBody ((u_char*)body_buffer, gVAB) != gVAB) 
 	{
   printf ("SsVabTransBody : failed!\n");
   return;
   }

SsVabTransCompleted (SS_WAIT_COMPLETED);
}
/******************************************************************************/


/******************************************************************************/
/******************************************************************************/

void bleep(int prog)
	{
	SsUtKeyOn( gVAB, prog, 0, 60, 0, 70, 70);
	}
/******************************************************************************/
/******************************************************************************/








/******************************************************************************/
void main_tune()
	{
	SsUtKeyOn( gVAB, 0, 0, 60, 0, 127, 127);
	}
/******************************************************************************/


/******************************************************************************/
void small_tune()
	{
	SsUtKeyOn( gVAB, 1, 0, 60, 0, 127, 127);
	}
/******************************************************************************/


/******************************************************************************/
void alien_one()
	{
	SsUtKeyOn( gVAB, 5, 0, 60, 0, 127, 127);
	}
/******************************************************************************/


/******************************************************************************/
void alien_two()
	{
	SsUtKeyOn( gVAB, 5, 0, 61, 0, 127, 127);
	}
/******************************************************************************/

